2000-11-09  Ulrich Drepper  <drepper@redhat.com>

	* version.h (VERSION): Bump to 2.2.
	(RELEASE): Set to stable.

	* posix/Makefile (tst-dir-ARGS): Fix problem with compiling in
	source directory.
	(tst-chmod-ARGS): Likewise.

2000-11-09  H.J. Lu  <hjl@gnu.org>

	* io/Versions (GLIBC_2.2): Add __open64.

2000-11-09  Jakub Jelinek  <jakub@redhat.com>

	* locale/C-time.c (_nl_C_LC_TIME): Fix value for _NL_TIME_WEEK_1STWEEK.

2000-11-09  Jakub Jelinek  <jakub@redhat.com>

	* locale/programs/ld-paper.c (paper_output): Fix offset into width
	field.

2000-10-27  Bruno Haible  <haible@clisp.cons.org>

	* locale/programs/charmap.c (charmap_read): Verify ASCII
	compatibility of charmap.

2000-11-08  Ulrich Drepper  <drepper@redhat.com>

	* catgets/gencat.c (main): Don't use exit() to avoid warnings with
	broken compilers.

	* include/features.h (__STDC_ISO_10646__): Correct value to be
	200009L.  Patch by Markus Kuhn <Markus.Kuhn@cl.cam.ac.uk>.

2000-11-08  H.J. Lu  <hjl@gnu.org>

	* pwd/Versions (GLIBC_2.1.2): Add getpwnam_r.

2000-11-08  Jakub Jelinek  <jakub@redhat.com>

	* string/bits/string2.h: Check if _USE_STRING_ARCH_ macros are
	defined, not _HAVE_STRING_ARCH_.
	* sysdeps/i386/bits/string.h (_USE_STRING_ARCH_memset,
	_USE_STRING_ARCH_strchr): Define.
	* sysdeps/i386/i486/bits/string.h (_USE_STRING_ARCH_memset,
	_USE_STRING_ARCH_strchr): Define.
	* sysdeps/sparc/bits/string.h: New file.

2000-11-08  Bruno Haible  <haible@clisp.cons.org>

	* locale/C-translit.h.in: Tweak <U2014> result.
	* locale/C-translit.h: Regenerated.

2000-11-08  Ulrich Drepper  <drepper@redhat.com>

	* posix/unistd.h: Add attribute((const)) to sysconf prototype.

	* iconvdata/euc-kr.c (euckr_from_ucs4): Map 0x20a9 to \xa3dc.
	(BODY from direction): Remove special handling of \x5c.
	* iconvdata/EUC-KR.irreversible: Adjust for this change.
	* iconvdata/testdata/EUC-KR..UTF8: Likewise.
	Reported by Jungshik Shin <jshin@pantheon.yale.edu>.

2000-11-07  Kazumoto Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/sh/sh3/setjmp.S (__sigsetjmp): Skip FPU fields.

2000-11-06  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/big5.c: Regenerated after BIG5 charmap change.
	Patch by Tung-Han Hsieh <thhsieh@twcpro.phys.ntu.edu.tw>.

	* sysdeps/generic/dl-cache.c (_dl_load_cache_lookup): Fix typo in
	comparison with new cache magic bytes.
	Patch by Denis Zaitsev <zzz@cd-club.ru>.

2000-11-03  Bruno Haible  <haible@clisp.cons.org>

	* locale/C-translit.h.in: Update from translit_neutral.
	* locale/C-translit.h: Regenerated.
	* intl/tst-translit.c: Update.

2000-11-04  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/mach/hurd/Dist: Remove clk_tck.c.

	* sysdeps/mach/hurd/Versions [libc] (GLIBC_2.1.1): Remove
	__libc_clk_tck.
	* sysdeps/mach/hurd/Makefile [$(subdir)==posix] (sysdep_routines):
	Remove clk_tck.
	* sysdeps/mach/hurd/clk_tck.c: Removed.
	* sysdeps/mach/hurd/getclktck.c: New file.
	* sysdeps/mach/hurd/setitimer.c (quantize_timeval): Use
	__getclktck instead of __libc_clk_tck.
	* sysdeps/mach/hurd/bits/time.h: Use __sysconf for CLK_TCK instead
	of __libc_clk_tck.
	* sysdeps/mach/hurd/i386/bits/time.h: Likewise.

2000-11-03  Ulrich Drepper  <drepper@redhat.com>

	* posix/Versions: Export __sysconf.

2000-11-02  Ulrich Drepper  <drepper@redhat.com>

	* version.h (VERSION): Bump to 2.1.97.

	* iconvdata/Makefile (distribute): Add viscii.c.

	* elf/Makefile (distribute): Add tst-pathopt.sh.

	* sysdeps/i386/i486/bits/string.h (strcmp): Cast arguments to
	__strcmp_cc, __strcmp_cg, and __strcmp_gc to unsigned char *.
	(__strcmp_cc, __strcmp_cg, __strcmp_gc): Remove casts of values here.
	Reported by Denis Zaitsev <zzz@cd-club.ru>.

	* iconvdata/utf-16.c (PREPARE_LOOP): Correct typo preventing BOM from
	being written.

	* manual/socket.texi (Local Namespace Concepts): Don't mention what
	permissions are necessary to connect to a socket.
	Reported by Peter Eisentraut <peter_e@gmx.net>.

	* sysdeps/generic/backtracesyms.c (__backtrace_symbols): Fix
	computation of total for 64-bit machines.
	Patch by Byron Stanoszek <gandalf@winds.org>.

	* manual/arith.texi (Rounding): Correct description of fesetround
	return value.  Patch by Conrado Badenas <Conrado.Badenas@uv.es>.

2000-10-30  Maciej W. Rozycki  <macro@ds2.pg.gda.pl>

	* sysdeps/mips/dl-machine.h (elf_machine_rel): Add the symbol's
	value plus the run-time displacement to the relocation for non-GOT
	symbols.  Set the relocation to the GOT entry for GOT symbols.

2000-11-02  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/s390/bits/time.h: Removed.

2000-11-01  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/TESTS: Add entries for IBM856, IBM930, IBM933, IBM935,
	IBM937, IBM939, and IBM1046.
	* iconvdata/testdata/IBM1046: New file.
	* iconvdata/testdata/IBM930..UTF8: New file.
	* iconvdata/testdata/IBM1046..UTF8: New file.
	* iconvdata/testdata/IBM933: New file.
	* iconvdata/testdata/IBM935: New file.
	* iconvdata/testdata/IBM937: New file.
	* iconvdata/testdata/IBM856..UTF8: New file.
	* iconvdata/testdata/IBM939: New file.
	* iconvdata/testdata/IBM933..UTF8: New file.
	* iconvdata/testdata/IBM935..UTF8: New file.
	* iconvdata/testdata/IBM930: New file.
	* iconvdata/testdata/IBM856: New file.
	* iconvdata/testdata/IBM937..UTF8: New file.
	* iconvdata/testdata/IBM939..UTF8: New file.
	Contributed by Masahide Washizawa <washi@yamato.ibm.co.jp>.

2000-11-01  Martin Buchholz  <martin@xemacs.org>

	* manual/memory.texi (Hooks for Malloc): Fix `caller' arg docs to
	agree with implementation.

2000-11-01  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/bits/time.h (CLK_TCK): Cast sysconf result
	to __clock_t.
	* sysdeps/unix/sysv/linux/alpha/bits/time.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/bits/time.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/bits/time.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/time.h: Likewise.

	* sysdeps/unix/sysv/linux/bits/socket.h (CMSG_ALIGN): Cast result
	of unary ~ to size_t.

	* stdlib/strtod.c: Make gcc shut up about SWAP use.

	* sysdeps/i386/fpu/bits/mathinline.h: Add support for builtin
	unordered compare functions to gcc 2.97 and up.

	* string/bits/string2.h: Disable strstr optimizations for newer
	gcc versions.  Patch by Joseph S. Myers <jsm28@cam.ac.uk>.

	* configure.in (with_cvs): Test for pserver access.

2000-10-31  Ulrich Drepper  <drepper@redhat.com>

	* elf/Versions [ld] (GLIBC_2.2): Export _dl_clktck and _dl_pagesize.
	* elf/dl-load.c: Define _dl_clktck.
	* elf/elf.h: Define AT_CLKTCK.
	* include/time.h: Declare __getclktck.
	* misc/Makefile (routines): Add getclktck.
	* sysdeps/generic/dl-sysdep.c (_dl_sysdep_start): Handle AT_CLKTCK.
	(_dl_show_auxv): Show AT_CLKTCK value.
	* sysdeps/generic/getclktck.c: New file.
	* sysdeps/unix/sysv/linux/getclktck.c: New file.
	* sysdeps/unix/sysv/linux/alpha/getclktck.c: New file.
	* sysdeps/unix/sysv/linux/ia64/getclktck.c: New file.
	* sysdeps/posix/sysconf.c: Use __getclktck to handle _SC_CLK_TCK.
	* sysdeps/unix/sysv/linux/getpagesize.c: New file.
	* sysdeps/unix/sysv/linux/bits/time.h: Use __sysconf to for CLK_TCK.
	* sysdeps/unix/sysv/linux/alpha/bits/time.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/bits/time.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/bits/time.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/time.h: Likewise.

	* sunrpc/clnt_gen.c (clnt_create): Don't set timeout with
	clnt_control for any protocol.  This would make it impossible for
	the user to provide one in clnt_call().
	Reported by Hitoshi Guutara Maruyama <maruyama@sh.rim.or.jp>.
	* sunrpc/clnt_tcp.c (clnt_call): Don't use timeout in tests with zero,
	use ct->ct_wait.
	* sunrpc/clnt_unix.c (clnt_call): Likewise.

2000-10-31  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/ia64/fpu/s_isinfl.S: New file,  - assembly based
	implementation based on suggestion by Richard Henderson.
	* sysdeps/ia64/fpu/s_isinfl.c: Removed.

2000-10-30  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/ia64/fpu/s_isnanl.S: New file - assembly based
	implementation based on suggestion by Richard Henderson.
	* sysdeps/ia64/fpu/s_isnanl.c: Removed.

2000-10-31  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/locale.c (print_item): Fix one more problem with
	string lists.  Patch by Chen Xiangyang <chenxy@opencjk.org>.

	* locale/categories.def: Add number of arguments to ctype-map-names
	and ctype-class-names entries.  Mark era as stringlist.

	* iconvdata/Makefile (modules): Add IBM856, IBM930, IBM933, IBM935,
	IBM937, IBM939, and IBM1046.
	(distribute): Add ibm856.c, ibm930.c, ibm933.c, ibm935.c, ibm937.c,
	ibm939.c, ibm1046.c, ibm856.h, ibm930.h, ibm933.h, ibm935.h, ibm937.h,
	ibm939.h, and ibm1046.h.
	* iconvdata/gconv-modules: Add entries for IBM856, IBM930, IBM933,
	IBM935, IBM937, IBM939, and IBM1046.
	* iconvdata/ibm1046.c: New file.
	* iconvdata/ibm1046.h: New file.
	* iconvdata/ibm856.c: New file.
	* iconvdata/ibm856.h: New file.
	* iconvdata/ibm930.c: New file.
	* iconvdata/ibm930.h: New file.
	* iconvdata/ibm933.c: New file.
	* iconvdata/ibm933.h: New file.
	* iconvdata/ibm935.c: New file.
	* iconvdata/ibm935.h: New file.
	* iconvdata/ibm937.c: New file.
	* iconvdata/ibm937.h: New file.
	* iconvdata/ibm939.c: New file.
	* iconvdata/ibm939.h: New file.
	Patches by Masahide Washizawa <washi@yamato.ibm.co.jp>.

2000-10-30  Ulrich Drepper  <drepper@redhat.com>

	* locale/localeinfo.h (enum value_type): Add wstring, wstringarray,
	and wstringlist.
	* locale/categories.def: Mark wide char strings as wstring or
	stringarray.
	* locale/programs/locale.c (show_info): Handle wstring, wstringarray,
	and wstringlist.  Print keywords only if there is real output.
	Reported by Chen Xiangyang <chenxy@opencjk.org>.

	* sysdeps/sparc/fpu/bits/mathinline.h: Add __THROW where necessary.
	Patch by Ben Collins <bcollins@debian.org>.

	* stdio-common/Makefile (tests): Add tst-fmemopen.
	* stdio-common/tst-fmemopen.c: New file.
	Test case by Ben Collins <bcollins@debian.org>.

	* libio/iofopncook.c (_IO_cookie_seek): Correct test for error.

	* libio/fmemopen.c (fmemopen_read): Return 0 at end of buffer.
	(fmemopen_write): Set errno at end of buffer.

	* posix/runtests.c (main): Don't use exit() to avoid warning with
	broken compilers.

	* string/bug-strncat1.c: Undefine __USE_STRING_INLINES before
	defining it again to avoid warning.
	* string/bug-strpbrk1.c: Likewise.
	* string/bug-strspn1.c: Likewise.

2000-10-29  Bruno Haible  <haible@clisp.cons.org>

	* locale/C-translit.h.in: Include more rules from translit_neutral.
	Remove a few German and Danish specific rules.
	* locale/gen-translit.pl: Avoid an error when printing a string
	containing a '%' character.
	* locale/C-translit.h: Regenerated.
	* intl/translit.po: Choose different translations.
	* intl/tst-translit.c: Update.

2000-10-29  Bruno Haible  <haible@clisp.cons.org>

	* locale/programs/ld-ctype.c (translit_include_t): New type.
	(locale_ctype_t): Remove translit_copy_locale, translit_copy_repertoire
	fields, add translit_include field.
	(ctype_read): After seeing "translit_start" in ignore_content mode,
	skip the entire translit section, not only one line.  Remove dead test
	for tok_translit_end.  Enqueue include statements into a list.
	Signal error if tok_eof seen before tok_translit_end.
	(translit_flatten): New function.
	(allocate_arrays): Call translit_flatten.

2000-10-30  Ulrich Drepper  <drepper@redhat.com>

	* locale/findlocale.c (free_mem): We can remove NODELETE marked
	data, just not the C locale data.

	* intl/tst-gettext.c: Use setlocale() in addition to setting envvar.
	* intl/tst-gettext.sh: Copy locale data if necessary.
	* intl/Makefile (generated-dirs): Add localedir.

	* intl/dcigettext.c (guess_category_value): For libc always use
	the setlocale() method.

	* intl/Makefile: Add rules to build, run and, distribute tst-gettext2.
	* intl/tst-gettext2.c: New file.
	* intl/tst-gettext2.sh: New file.
	* intl/tstlang1.po: New file.
	* intl/tstlang2.po: New file.
	Patch by Andreas Jaeger <aj@suse.de>.

2000-10-26  GOTO Masanori  <gotom@debian.or.jp>

	* intl/locale.alias: Add ja_JP.ujis alias.

2000-10-30  Ulrich Drepper  <drepper@redhat.com>

	* locale/findlocale.c (_nl_find_locale): Don't store normalized
	name in *NAME.

2000-10-29  Ben Collins  <bcollins@debian.org>

	* sysdeps/generic/lockf64.c: In the case of F_TEST, set l_type to
	F_RDLCK explicitly.
	* sysdeps/unix/sysv/linux/i386/lockf64.c: Likewise.

2000-10-29  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/big5.c: Update.
	Patch by Tung-Han Hsieh <thhsieh@twcpro.phys.ntu.edu.tw>.

	* iconvdata/Makefile (distribute): Add BIG5.irreversible.
	* iconvdata/BIG5.irreversible: New file.

2000-10-29  Greg Louis  <glouis@dynamicro.on.ca>

	* posix/regex.h (__restrict_arr): Move definition out of #ifndef block.
	Required because egcs-2.91.66 (aka 1.1.2) defines __restrict, but
	doesn't define __restrict_arr.

2000-10-29  Ulrich Drepper  <drepper@redhat.com>

	* manual/search.texi: Correct description if VISIT values.
	Patch by Ben Collins <bcollins@debian.org>.

	* string/bits/string2.h (strspn): Evaluate first argument if
	second is "".
	(strpbrk): Likewise.
	* sysdeps/i386/i486/bits/string.h: Likewise.
	* string/Makefile (tests): Add bug-strspn1 and bug-strpbrk1.
	* string/bug-strspn1.c: New file.
	* string/bug-strpbrk1.c: New file.
	Test cases by Joseph S. Myers <jsm28@cam.ac.uk>.

	* string/bits/string2.h (strncat): Terminate string correctly.
	* sysdeps/i386/i486/bits/string.h (strncat): Likewise.
	* string/Makefile (tests): Add bug-strncat1.
	* string/bug-strncat1.c: New file.
	Test case by Joseph S. Myers <jsm28@cam.ac.uk>.

2000-10-27  Ben Collins  <bcollins@debian.org>

	* sysdeps/generic/lockf.c (lockf): Set l_type to F_RDLCK before
	calling for F_GETLK.

2000-10-29  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-load.c (open_path): Don't exit loop early if we didn't
	use a directory at all.

	* elf/Makefile: Add rules to build and run tst-pathopt.
	* elf/tst-pathopt.c: New file.
	* elf/tst-pathopt.sh: New file.
	* elf/pathoptobj.c: New file.

	* elf/elf.h (SHN_XINDEX): Define.

2000-10-28  Ulrich Drepper  <drepper@redhat.com>

	* io/Makefile (tests): Add test-stat2.
	(test-stat2-ARS): New variable.
	* io/test-stat2.c: New file.

	* Makeconfig (ETAGS): Remove -T flag.

	* elf/dl-load.c (open_verify): Only try to load ET_DYN and ET_EXEC
	objects.  Reject all other types.
	(_dl_map_object_from_fd): Optimize a bit.

2000-10-27  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/Makefile (tests): Add tst-fseek.
	* stdio-common/tst-fseek.c: New file.

	* posix/regex.c (gettext): Use correct translation domain for glibc.

	* argp/argp-parse.c: Use __dcgettext instead of dcgettext for glibc.
	* argp/argp-help.c: Likewise.
	* inet/getnameinfo.c (getnameinfo): Use __snprintf instead of snprintf.
	* inet/rexec.c (rexec_af): Use __snprintf instead of snprintf.
	* misc/regexp.c (__step): Use __regexec instead of regexec.
	(__advance): Likewise.
	* nss/digits_dots.c: Use __inet_aton instead of inet_aton.
	* nscd/gethstbynm2_r.c (__inet_aton): Define as inet_aton since
	the former is not exported.
	* misc/daemon.c (daemon): Use __fork instead of fork.

	* stdlib/fmtmsg.c (fmtmsg): Change output format slightly to make
	it look better and bring it closer to SysV behavior.
	* stdlib/Makefile (distribute): Add tst-fmtmsg.sh.
	(test-srcs): Add tst-fmtmsg.
	(tests): Add $(objpfx)tst-fmtmsg.out.  Add rule to generate it.
	* stdlib/tst-fmtmsg.sh: New file.
	* stdlib/tst-fmtmsg.c: New file.

	* iconvdata/Makefile (modules): Add VISCII.
	(gen-8bit-modules): Add viscii.
	* iconvdata/viscii.c: New file.
	* iconvdata/gconv-modules: Add entries for VISCII.
	* iconvdata/tst-tables.sh: Add VISCII.

2000-10-27  Andreas Schwab  <schwab@suse.de>

	* sysdeps/m68k/fpu/libm-test-ulps: Add some more ulps.

2000-10-26  Ulrich Drepper  <drepper@redhat.com>

	* version.h (VERSION): Bump to 2.1.96.

	* inet/getipnodebyad.c: Removed.
	* inet/getipnodebynm.c: Removed.
	* inet/tst-ipnode.c: Removed.
	* inet/freehostent.c: Removed.

	* sysdeps/unix/bsd/osf/=dirstream.h: Removed.

	* sysdeps/unix/sysv/linux/Dist: Add bits/initspin.h.

	* elf/Makefile (distribute): Add neededobj4.c.

	* iconvdata/Makefile (distribute): Add BIG5HKSCS.irreversible.

	* sysdeps/hppa/Dist: New file.
	* sysdeps/unix/sysv/linux/hppa/Dist: New file.

	* posix/tst-chmod.c (do_test): Account for people running the
	tests as root.

	* locale/langinfo.h (THOUSEP): Define this and don't duplicate
	definition of THOUSANDS_SEP.

	* locale/C-monetary.c: Set mon_decimal to empty string.
	Add missing entry _NL_MONETARY_CRNCYSTR.
	* stdio-common/printf_fp.c: If MON_DECIAL_POINT is not provided use
	DECIMAL_POINT information.
	* locale/C-numeric.c: Set mon_grouping entry to empty string.
	* locale/C-time.c: Add date_fmt entries.  Remove two wrong entries.
	Correct value for number of entries.
	* locale/localeconv.c: Normalize result passed back in .grouping.
	Fix assignment to .int_* entries.

	* locale/Makefile (tests): Add tst-C-locale.
	* locale/tst-C-locale.c: New file.

	* locale/setlocale.c: Use LOCALEDIR and not LOCALE_PATH to locate
	locale files.
	* locale/newlocale.c: Likewise.

2000-10-26  GOTO Masanori  <gotom@debian.or.jp>

	* locale/langinfo.h: Define _DATE_FMT and _NL_W_DATE_FMT.
	* locale/categories.def: New support for date_fmt.
	* locale/programs/ld-time.c: Likewise.
	* locale/programs/locfile-kw.gperf: Likewise.
	* locale/programs/locfile-kw.h: Likewise.
	* locale/programs/locfile-token.h: Likewise.

2000-10-26  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/ieee754/ldbl-128/e_hypotl.c: New.

	* math/libm-test.inc (cabs_test, cexp_test, csqrt_test, hypot_test):
	Increase precision of constants.
	* sysdeps/alpha/fpu/libm-test-ulps: Update.
	* sysdeps/arm/libm-test-ulps: Update.
	* sysdeps/i386/fpu/libm-test-ulps: Update.
	* sysdeps/ia64/fpu/libm-test-ulps: Update.
	* sysdeps/m68k/fpu/libm-test-ulps: Update.
	* sysdeps/mips/fpu/libm-test-ulps: Update.
	* sysdeps/powerpc/fpu/libm-test-ulps: Update.
	* sysdeps/sparc/sparc32/fpu/libm-test-ulps: Update.
	* sysdeps/sparc/sparc64/fpu/libm-test-ulps: Update.
	* sysdeps/sh/sh4/fpu/libm-test-ulps: Update.
	* sysdeps/s390/fpu/libm-test-ulps: Update.

2000-10-26  Ulrich Drepper  <drepper@redhat.com>

	* io/Makefile (tests): Add tst-fcntl.
	* io/tst-fcntl.c: New file.

	* posix/Makefile (tests): Add tst-chmod.
	(tst-chmod-ARGS): Define.
	* posix/tst-chmod.c: New file.

	* test-skeleton.c: Before calling user-defined function remove
	parameters from argument list.
	* posix/tst-exec.c: Adjust to this change.
	* posix/tst-spawn.c: Likewise.

	* sysdeps/unix/opendir.c (__opendir): Optimize a bit.  Add
	__builtin_expect.

2000-10-25  Ulrich Drepper  <drepper@redhat.com>

	* intl/Makefile (tests): Add tst-ngettext.
	* intl/tst-ngettext.c: New file.

2000-10-25  Bruno Haible  <haible@clisp.cons.org>

	* manual/charset.texi: Fix spelling of __GCONV_FULL_OUTPUT.
	* manual/message.texi (Translation with gettext): Remove paragraph
	about macros contained in libintl.h.
	(bind_textdomain_codeset): Describe codeset argument.
	(Using gettextized software): Add setlocale call to sample code.

2000-10-26  Kazumoto Kojima  <kkojima@rr.iij4u.or.jp>
	    Yutaka Niibe  <gniibe@chroot.org>

	* sysdeps/sh/dl-machine.h (elf_machine_rela): Handle in place
	relocation which is generated by new ld.
	* sysdeps/sh/elf/initfini.c (_init): Preseted __fpscr_values.
	(_fini): Delete an obsolete register prefix.
	* sysdeps/unix/sysv/linux/sh/Versions: Add __xstat64, __fxstat64,
	__lxstat64, alphasort64, glob64, readdir64, readdir64_r, scandir64
	and versionsort64 as the 2.2-versioned symbols.
	* sysdeps/unix/sysv/linux/sh/bits/fcntl.h: New file.
	* sysdeps/unix/sysv/linux/sh/brk.c: Changes for the new system call
	calling convention of the kernel.
	* sysdeps/unix/sysv/linux/sh/pipe.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/socket.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/vfork.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/sysdep.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/fcntl.c: New file.
	* sysdeps/unix/sysv/linux/sh/lockf64.c: New file.
	* sysdeps/unix/sysv/linux/sh/sys/user.h: Include the kernel header
	file and delete the definitions of struct user and user_fp.
	* sysdeps/unix/sysv/linux/sh/syscall.S: New file.
	* sysdeps/unix/sysv/linux/sh/syscalls.list: Remove entries for
	s_ioctl, s_ipc, s_llseek, s_chown, s_fchown, s_lchown, s_execve,
	rt_sigaction, rt_sigpending, rt_sigprocmask, rt_sigqueueinfo,
	rt_sigsuspend, rt_sigtimedwait, s_getcwd, s_getdents, s_getgroups,
	s_getpriority, s_getegid, s_geteuid, s_getuid, getresgid, getresuid,
	s_getrlimit, s_poll, s_pread64, s_ptrace, s_pwrite64, s_reboot,
	s_setrlimit, s_sigaction, s_sigpending, s_sigprocmask, s_sigsuspend,
	s_setfsgid, s_setfsuid, s_setgid, s_setgroups, s_setregid,
	s_setresgid, s_setresuid, s_setreuid, s_setuid, s_sysctl,
	s_ugetrlimit, s_ustat, sys_fstat, sys_lstat, sys_mknod, sys_readv,
	sys_stat, sys_writev and syscall.

2000-10-25  Ulrich Drepper  <drepper@redhat.com>

	* io/test-lfs.c (do_prepare): Rewrite so it doesn't fail on systems
	without LFS support.

	* sysdeps/ieee754/dbl-64/e_jn.c: Use __ieee754_sqrt instead of __sqrt.
	* sysdeps/ieee754/dbl-64/e_j1.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_j0.c: Likewise.
	* sysdeps/ieee754/flt-32/e_j1f.c: Likewise.
	* sysdeps/ieee754/flt-32/e_j0f.c: Likewise.

2000-10-25  David Mosberger  <davidm@hpl.hp.com>

	* sysdeps/unix/sysv/linux/ia64/profil-counter.h: Multiply slot
	number by four to use bins of width 4 to get accurate
	instruction-level profiling.

2000-10-25  Andreas Jaeger  <aj@suse.de>

	* sysdeps/generic/dl-cache.h (CACHEMAGIC_VERSION_NEW): Correct string.

2000-10-25  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/i386/fcntl.c (__libc_fcntl): When
	converting struct flock64 to struct flock and back, use fcntl commands
	which work on struct flock.

2000-10-25  Jakub Jelinek  <jakub@redhat.com>

	* math/test-misc.c (main): Only check modfl if NO_LONG_DOUBLE is not
	defined.
	* sysdeps/sparc/sparc32/fpu/libm-test-ulps: Update.
	* sysdeps/sparc/sparc64/fpu/libm-test-ulps: Update.

2000-10-25  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/arm/libm-test-ulps: Updated.

	* sysdeps/generic/dl-cache.h (CACHEMAGIC_VERSION_NEW): New value.

2000-10-25  Andreas Jaeger  <aj@suse.de>

	* elf/dl-load.c (_dl_map_object_from_fd): Remove unused variable.
	(_dl_map_object): Likewise.

2000-10-24  Paul Eggert  <eggert@twinsun.com>

	* time/strftime.c (my_strftime macro)
	[!defined _LIBC && HAVE_TZNAME && HAVE_TZSET]:
	When redefining, do it without args, so that it works even if
	emacs is defined and an extra argument is passed to my_stftime.
	(my_strftime function): When evaluating a subformat, pass
	ut_argument as well.

2000-10-24  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/ia64/Versions: Add pciconfig_read and
	pciconfig_write.

2000-10-25  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/dl-cache.c (_dl_cache_verify_ptr): Correct test
	for files with new cache format.
	(_dl_load_cache_lookup): Add variable cache_data_size for size of the
	data.  Correctly report error if neither old not new signature is
	found. Little optimizations.
	Mostly based on a patch by Denis Zaitsev <zzz@cd-club.ru>.

	* elf/dl-close.c (_dl_close): Optimize a bit by optimizing out the
	nsearchlist variable.

2000-10-24  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-lookup.c (add_dependency): Fix test to check whether
	dependency already exists.
	* elf/Makefile: Add testobj1 and testobj2 as dependencies of testobj6.
	* elf/loadtest.c (main): Add test at the end that everything is
	unloaded.

	* elf/dl-open.c (dl_open_worker): Fix typo in comment.

	* elf/elf.h: Add even more IA-64 relocations.

2000-10-24  Geoffrey Keating  <geoffk@cygnus.com>

	* io/test-lfs.c (do_prepare): Call setrlimit64, in case the user
	has a limit set---for instance, a limit of 2^31 bytes, which can't
	easily be reset by non-LFS-aware shells.

	* sysdeps/unix/sysv/linux/powerpc/mmap64.c: Define PAGE_SHIFT
	explicitly rather than getting it from <asm/page.h>.

2000-10-24  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-close.c (_dl_close): Handle relocation dependencies of
	the dependencies of the object currently unloaded.

	* elf/dl-close.c (_dl_close): Don't free memory for global scope
	list immediately when empty.  Move code to...
	(free_mem): ...here.  Called as part of __libc_subfreeres list.

	* elf/dl-deps.c (_dl_map_object_deps): Put l_initfini array before
	r_list array in allocated memory.
	* elf/dl-close.c (_dl_close): Optimize access to l_initfini list
	and remove use of r_list.

	* elf/dl-close.c (_dl_close): Use correct list (l_initfini) when
	computing new opencounts.
	* elf/Makefile: Add rules to build and run neededtest3.
	* neededtest3.c: New file.
	* neededobj4.c: New file.

	* elf/neededtest.c (main): Correct tests for failing dlopen.

2000-10-24  Andreas Jaeger  <aj@suse.de>

	* elf/dl-lookup.c (add_dependency): Remove unused variable j.

2000-10-24  Ulrich Drepper  <drepper@redhat.com>

	* malloc/obstack.c (_obstack_newchunk): Correctly align first returned
	block.
	* malloc/tst-obstack.c: New file.
	Patch and test case by Alexandre Duret-Lutz <duret_g@epita.fr>.
	* malloc/Makefile (tests): Add tst-obstack.

	Complete revamp of the reference counter handling.
	* include/link.h (struct link_map): Add l_idx field.
	* elf/dl-close.c: Handle decrementing of reference counters more
	correctly. If necessary decrement reference counters of dependencies
	of dependencies.
	* elf/dl-lookup.c (add_dependency): Only increment reference counter
	of the object itself and not also its dependencies.
	* elf/dl-open.c: Increment reference counters here.
	* elf/dl-deps.c: Remove reference counter handling here.
	* elf/dl-load.c: Likewise.
	* elf/rtld.c: Adjust for _dl_map_deps not handling reference counters.

	* elf/loadtest.c: Print loaded objects at the beginning.

2000-10-24  Andreas Jaeger  <aj@suse.de>

	* sysdeps/mips/dl-machine.h: Partly revert patch from 2000-10-18.

2000-10-23  Ulrich Drepper  <drepper@redhat.com>

	* include/link.h (struct link_map): New bit field l_faked.
	* elf/dl-deps.c: Use l_faked field in struct link_map instead of
	the magic l_opencount==0.
	* elf/dl-load.c: Likewise.
	* elf/dl-version.c: Likewise.
	* elf/rtld.c: Likewise.

	* elf/dl-close.c (_dl_close): Add a few more __builtin_expect.

2000-10-23  Jim Meyering  <meyering@ascend.com>

	Allow this code to be used outside of glibc.
	* sysdeps/generic/memrchr.c: Undef __memrchr, too.
	[!weak_alias]: Define __memrchr to memrchr.
	Guard weak_alias use with `#ifdef weak_alias'.

2000-10-23  Ulrich Drepper  <drepper@redhat.com>

	* elf/unload.c: Generate more debugging output.

	* elf/neededtest.c: Make it more complicated.
	* elf/neededtest2.c: New file.
	* elf/Makefile: Add rules to build and run neededtest2.

	* elf/dl-sym.c (_dl_sym): Use exact check for caller PC in range
	of DSO address space.
	(_dl_vsym): Likewise.

	* elf/dl-sym.c (_dl_sym): For RTLD_DEFAULT, search in objects
	global scope if we can determine it.

2000-10-23  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/ia64/bits/resource.h (RLIMIT_LOCKS): Added.
	(RLIMIT_NLIMITS): Sync with kernel definition.
	(PRIO_PROCESS, PRIO_PGRP, PRIO_USER): Also define as macros.

2000-10-23  Andreas Schwab  <schwab@suse.de>

	* sysdeps/m68k/fpu/libm-test-ulps: Updated.

2000-10-23  Ulrich Drepper  <drepper@redhat.com>

	* elf/elf.h (R_IA64_GPREL32MSB, R_IA64_GPREL32LSB): New definitions.

2000-10-22  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/big5hkscs.c (big5hkscs_to_ucs): Add irreversible mappings
	for 0x8BF8, 0xA27E..0xA2A7.
	* iconvdata/BIG5HKSCS.irreversible: New file.

2000-10-23  Jakub Jelinek  <jakub@redhat.com>

	* timezone/zdump.c (main): setlocale LC_CTYPE as well as LC_MESSAGES.
	* timezone/zic.c (main): Likewise.

2000-10-23  Thorsten Kukuk  <kukuk@suse.de>

	* nscd/connections.c (invalidate_cache): Don't invalidate a cache
	if it is not enabled.

2000-10-23  Andreas Jaeger  <aj@suse.de>

	* sysdeps/s390/fpu/libm-test-ulps: New ulps.

	* sysdeps/unix/sysv/linux/mips/syscalls.list: Add fcntl64.
	Patch by Ralf Baechle <ralf@gnu.org>.

2000-10-21  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-load.c (_dl_map_object_from_fd): Split out ELF file
	verification in open_verify.
	(open_verify): New function.  Called instead of open.  Ignores valid
	files for other architectures.
	(open_path): Call open_verify instead of open.
	(_dl_map_object): Likewise.
	Somewhat based on a patch by Don Dugger <n0ano@valinux.com>.

	* io/pwd.c (main): The output was missing a newline.

	* posix/fnmatch_loop.c: Make FNM_LEADING_DIR behave as GNU tar
	expects it.  Patch by Colin Watson <riva.ucam.org>.
	* posix/tst-fnmatch.input: Add test cases for FNM_LEADING_DIR.

	* elf/dl-open.c (add_to_global): New function.  Split out from
	dl_open_worker.
	(dl_open_worker): Call add_to_global not only for new objects, also for
	previously loaded objects when (mode & RTLD_GLOBAL) and the object
	was not yet in the global scope.
	* elf/Makefile: Add rules to build and run lateglobal.
	* elf/lateglobal.c: New file.
	* elf/ltglobmod1.c: New file.
	* elf/ltglobmod2.c: New file.

2000-10-20  Ulrich Drepper  <drepper@redhat.com>

	* include/link.h (struct link_map): Add l_soname_added bitfield.
	* elf/dl-load.c (_dl_map_object): Remember when we added the
	SONAME to the l_libname list and don't try it again.

	* elf/dl-close.c: Decrement opencount for all dependencies which can
	be removed even if the object is not yet unloaded.
	* elf/dl-deps.c (_dl_map_object_deps): If dependency is already in
	the list decrement opencount of all dependencies.
	* elf/dl-load.c (_dl_map_object_from_fd): Increment object of object
	and all dependencies.
	(_dl_map_object): Likewise.
	* elf/dl-lookup.c (add_dependency): Likewise.

	* elf/loadtest.c: Add debug when with more output.

	* elf/Makefile: Add rules to build and run unload2.
	* elf/unload2.c: New file.
	* elf/unload2mod.c: New file.
	* elf/unload2dep.c: New file.

	* intl/libintl.h (ngettext macro): Add missing parameter.
	(dngettext macro): Likewise.

2000-10-19  H.J. Lu  <hjl@gnu.org>

	* elf/Makefile (distribute): Add neededtest.c, neededobj1.c,
	neededobj2.c and neededobj3.c.
	(tests): Add neededtest.
	(modules-names): Add neededobj1, neededobj2 and neededobj3.
	($(objpfx)neededobj1.so): New target.
	($(objpfx)neededobj2.so): Likewise.
	($(objpfx)neededobj3.so): Likewise.
	($(objpfx)neededtest): Likewise.
	($(objpfx)neededtest.out): Likewise.
	* elf/neededtest.c: New. Based on the bug report from
	Allen Bauer <kylix_rd@hotmail.com>.
	* elf/neededobj1.c: Likewise.
	* elf/neededobj2.c: Likewise.
	* elf/neededobj3.c: Likewise.

2000-10-20  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-load.c (_dl_map_object_from_fd): Pass pointer to ELF header
	to elf_machine_matches_host.
	* sysdeps/alpha/dl-machine.h (elf_machine_matches_host): Parameter
	is now pointer to ELF header.
	* sysdeps/arm/dl-machine.h: Likewise.
	* sysdeps/generic/dl-machine.h: Likewise.
	* sysdeps/hppa/dl-machine.h: Likewise.
	* sysdeps/i386/dl-machine.h: Likewise.
	* sysdeps/ia64/dl-machine.h: Likewise.
	* sysdeps/m68k/dl-machine.h: Likewise.
	* sysdeps/mips/dl-machine.h: Likewise.
	* sysdeps/mips/mips64/dl-machine.h: Likewise.
	* sysdeps/powerpc/dl-machine.h: Likewise.
	* sysdeps/s390/dl-machine.h: Likewise.
	* sysdeps/sh/dl-machine.h: Likewise.
	* sysdeps/sparc/sparc32/dl-machine.h: Likewise.
	* sysdeps/sparc/sparc64/dl-machine.h: Likewise.
	Patch by Martin Schwidefsksy <schwidefsky@de.ibm.com>.

2000-10-20  Jakub Jelinek  <jakub@redhat.com>

	* include/limits.h: Include bits/wordsize.h, use #if __WORDSIZE == 64
	check instead of #ifdef __alpha__.
	* include/bits/xopen_lim.h (WORD_BIT, LONG_BIT): Don't count on
	INT_MAX, __INT_MAX__, LONG_MAX or __LONG_MAX__ being defined when
	this is included.

2000-10-20  Ulrich Drepper  <drepper@redhat.com>

	* posix/wordexp-tst.sh (testout): Place output file in build
	directory.  Patch by Joseph S. Myers <jsm28@cam.ac.uk>.

	* sysdeps/powerpc/fpu/bits/mathinline.h: Pretty print.

2000-10-19  Ulrich Drepper  <drepper@redhat.com>

	* hesiod/nss_hesiod/hesiod-grp.c (_nss_hesiod_initgroups_dyn):
	Correctly handle numeric group member information.
	Patch by tomasw@cs.huji.ac.il.

	* hesiod/nss_hesiod/hesiod-grp.c (_nss_hesiod_initgroups_dyn):
	Complete test for strtol overflow.

2000-10-19  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/semctl.c (__new_semctl): Pass union
	semun as 4th argument to semctl syscall, not address of it.

2000-10-18  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* sysdeps/unix/sysv/linux/powerpc/syscalls.list: Add fcntl64() syscall.

2000-10-17  Andreas Schwab  <schwab@suse.de>

	* string/string.h: Remove declaration of __strcasecmp and __strcasestr.
	* include/string.h: Declare them here.

2000-10-18  Ralf Baechle  <ralf@gnu.org>

	* sysdeps/unix/sysv/linux/mips/sys/syscall.h: Include <asm/unistd.h>.

2000-10-19  Geoffrey Keating  <geoffk@cygnus.com>

	* sysdeps/powerpc/fpu/bits/mathinline.h: Add versions
	of the unordered comparison functions that use the GCC builtins.

	* sysdeps/powerpc/dl-machine.c (dl_reloc_overflow): New function.
	(__process_machine_rela): Print the address of an overflowing
	reloc.

2000-10-18  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/shm_open.c: Correct default mount point
	in comments.
	(freeit): Remove unnecessary test.

2000-10-18  Andreas Jaeger  <aj@suse.de>

	* sysdeps/mips/dl-machine.h (ELF_MIPS_GNU_GOT1_OK): New.
	(ELF_MACHINE_BEFORE_RTLD_RELOC): Handle newer linkers.
	(elf_machine_runtime_link_map): Likewise.
	(elf_machine_runtime_setup): Likewise.
	Handle dynamic linker's local got entries.
	Patches by Ralf Baechle <ralf@gnu.org>.

2000-10-09  Maciej W. Rozycki  <macro@ds2.pg.gda.pl>

	* sysdeps/mips/dl-machine.h (_dl_runtime_resolve): Define $sp as
	the frame pointer.  Allocate stack space for $a0 for
	__dl_runtime_resolve().  Do not save $sp in $s0 as it's
	callee-saved anyway.

2000-10-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/powerpc/fpu/libm-test-ulps: Update for changes in
	libm-test.inc.

2000-10-17  Andreas Schwab  <schwab@suse.de>

	* sysdeps/m68k/fpu/libm-test-ulps: Update for changes in
	libm-test.inc.

2000-10-17  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/ieee754/ldbl-128/printf_fphex.c (PRINT_FPHEX_LONG_DOUBLE):
	Add missing backslash.

2000-10-16  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/dl-sysdep.c (DL_FIND_ARG_COMPONENTS): Little cleanup.

	* sysdeps/i386/fpu/libm-test-ulps: Update for changes in libm-test.inc.

2000-10-16  Jakub Jelinek  <jakub@redhat.com>

	* math/libm-test.inc (M_LOG_SQRT_PIl, M_LOG_2_SQRT_PIl): Increase
	precision.
	(acos_test, asin_text, cexp_test, cos_test, cproj_test, exp10_test,
	sin_test, sincos_test, sqrt_test): Likewise.  Add L suffixes also
	to parameters.
	(acosh_test, asinh_test, atan2_test, atanh_test, atan_test, cabs_test,
	cacosh_test, cacos_test, casinh_test, casin_test, catanh_test,
	catan_test, cbrt_test, ccosh_test, ccos_test, clog10_test, cosh_test,
	csinh_test, csin_test, csqrt_test, ctanh_test, ctan_test, erfc_test,
	erf_test, exp2_test, expm1_test, exp_test, fmod_test, hypot_test,
	j0_test, j1_test, jn_test, lgamma_test, llrint_test, llround_test,
	log10_test, log1p_test, log2_test, log_test, lrint_test, lround_test,
	nextafter_test, nexttoward_test, pow_test, round_test, scalb_test,
	sinh_test, static void, tanh_test, tan_test, tgamma_test, y0_test,
	y1_test, yn_test): Add L suffixes also to parameters.
	* sysdeps/ieee754/ldbl-128/s_ceill.c (__ceill): Fix mask.
	* sysdeps/ieee754/ldbl-128/s_floorl.c (__floorl): Likewise.
	* soft-fp/op-2.h (_FP_FRAC_SRS_2): Fix computation of sticky bit.

2000-10-16  Ulrich Drepper  <drepper@redhat.com>

	* timezone/Makefile: Define HAVE_GETTEXT for zdump.c, zic.c,
	ialloc.c, and scheck.c.
	* malloc/obstack.c: Always include <libintl.h> for glibc.
	* posix/getopt.c: Likewise.
	Reported by Petr Vandrovec <VANDROVE@vc.cvut.cz>.

2000-10-15  Pete Wyckoff  <pw@osc.edu>

	* Rules: Define _LIBC during generation of bits/stdio_lim.d.

2000-10-15  Pete Wyckoff  <pw@osc.edu>

	* iconvdata/tst-tables.sh: Invoke other shell scripts through ${SHELL}.
	* iconvdata/tst-table.sh: Likewise.

2000-10-15  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-error.c (_dl_signal_error): Allocate memory for objname
	as well.  Reported by Alexander V. Lukyanov <lav@yars.free.net>.

	* iconvdata/gconv-modules: Add aliases for Winblowz charsets.
	Patch by Joseph S. Myers <jsm28@cam.ac.uk>.

2000-10-13  Andreas Schwab  <schwab@suse.de>

	* elf/elf.h (R_IA64_PCREL60B): Add relocation.

2000-10-15  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/hppa/brk.c: Cleanups.
	* sysdeps/unix/sysv/linux/hppa/umount.c: Likewise.
	* sysdeps/unix/sysv/linux/hppa/bits/sigaction.h: Likewise.
	* sysdeps/unix/sysv/linux/hppa/bits/signum.h: Likewise.
	* sysdeps/unix/sysv/linux/hppa/sys/ucontext.h: Likewise.

2000-10-14  Ulrich Drepper  <drepper@redhat.com>

	* math/libm-test.inc (frexp_test): Add L suffix also to parameters.
	(hypot_test): Likewise.

	* sysdeps/generic/printf_fphex.c: Compute width of decimal point
	string correctly.  Handle padding correctly.

	* sysdeps/ia64/fpu/printf_fphex.c: Use sizeof in _itowa parameters
	correctly.
	* sysdeps/ieee754/ldbl-128/printf_fphex.c: Likewise.
	* sysdeps/ieee754/ldbl-96/printf_fphex.c: Likewise.

2000-10-12  Alan Modra  <alan@linuxcare.com.au>

	* FAQ.in: Add --start-group and --end-group.

2000-10-12  Alan Modra  <alan@linuxcare.com.au>

	* malloc/memusage.c: Conditionalize stack usage calculation on
	stack direction.

2000-10-12  Alan Modra  <alan@linuxcare.com.au>

	* config.h.in: Add ASM_LINE_SEP.
	* configure.in: Add test for comment and line separators.
	* include/libc-symbols.h: Define and use ASM_LINE_SEP, and add tabs to
	placate some hppa assemblers.
	* sysdeps/hppa/sysdep.h: Likewise.
	* sysdeps/gnu/siglist.c: Insert \n and \t into inline asm.
	* sysdeps/unix/sysv/linux/errlist.c: Likewise.

2000-10-12  David Huggins-Daines  <dhd@linuxcare.com>

	* sysdeps/unix/sysv/linux/Makefile: Include <bits/initspin> in
	$(sysdep_headers).
	* sysdeps/unix/sysv/linux/bits/initspin.h: Dummy version for
	non-threaded platforms.

2000-10-12  David Huggins-Daines  <dhd@linuxcare.com>

	* configure.in: Add definitions for hppa.
	* elf/elf.h: Add PLABEL32 relocation for hppa ELF32, comments
	for IPLT and EPLT relocations.
	* shlib-versions: Version symbol definitions for hppa-linux.
	* sysdeps/unix/sysv/linux/configure.in: Define $arch_minimum_kernel
	for hppa.

2000-10-12  David Huggins-Daines  <dhd@linuxcare.com>

	* sysdeps/hppa/Makefile: New file.
	* sysdeps/hppa/Versions: New file.

	* sysdeps/hppa/setjmp.S: New file.
	* sysdeps/hppa/__longjmp.S: New file.
	* sysdeps/hppa/bits/setjmp.h: New file.
	* sysdeps/hppa/frame.h: New file.

	* sysdeps/hppa/add_n.s: Don't use %r19 (linkage table pointer).
	* sysdeps/hppa/sub_n.s: Likewise.
	* sysdeps/hppa/lshift.s: Likewise.
	* sysdeps/hppa/rshift.s: Likewise.
	* sysdeps/hppa/udiv_qrnnd.s: Likewise.
	* sysdeps/hppa/hppa1.1/addmul_1.s: Likewise.
	* sysdeps/hppa/hppa1.1/submul_1.s: Likewise.
	* sysdeps/hppa/hppa1.1/mul_1.s: Likewise.
	* sysdeps/hppa/hppa1.1/udiv_qrnnd.s: Likewise.

	* sysdeps/hppa/dl-machine.h: New file.
	* sysdeps/hppa/dl-fptr.c: New file (note that this is almost
	identical to the IA-64 one).
	* sysdeps/hppa/dl-lookupcfg.h: Likewise.
	* sysdeps/hppa/dl-symaddr.c: Likewise.

	* sysdeps/hppa/elf/initfini.c: New file.
	* sysdeps/hppa/elf/start.S: New file.

	* sysdeps/hppa/fpu/bits/fenv.h: New file.
	* sysdeps/hppa/fpu/fclrexcpt.c: New file.
	* sysdeps/hppa/fpu/fedisblxcpt.c: New file.
	* sysdeps/hppa/fpu/feenablxcpt.c: New file.
	* sysdeps/hppa/fpu/fegetenv.c: New file.
	* sysdeps/hppa/fpu/fegetexcept.c: New file.
	* sysdeps/hppa/fpu/fegetround.c: New file.
	* sysdeps/hppa/fpu/feholdexcpt.c: New file.
	* sysdeps/hppa/fpu/fesetenv.c: New file.
	* sysdeps/hppa/fpu/fesetround.c: New file.
	* sysdeps/hppa/fpu/feupdateenv.c: New file.
	* sysdeps/hppa/fpu/fegetexcptflg.c: New file.
	* sysdeps/hppa/fpu/fraiseexcpt.c: New file.
	* sysdeps/hppa/fpu/fsetexcptflg.c: New file.
	* sysdeps/hppa/fpu/ftestexcept.c: New file.

	* sysdeps/unix/sysv/linux/hppa/Makefile: New file.
	* sysdeps/unix/sysv/linux/hppa/Versions: New file.
	* sysdeps/unix/sysv/linux/hppa/syscalls.list: New file.
	* sysdeps/unix/sysv/linux/hppa/sysdep.c: New file.
	* sysdeps/unix/sysv/linux/hppa/sysdep.h: New file.


	* sysdeps/unix/sysv/linux/hppa/bits/fcntl.h: New file.
	* sysdeps/unix/sysv/linux/hppa/bits/ioctls.h: New file.
	* sysdeps/unix/sysv/linux/hppa/bits/mman.h: New file.
	* sysdeps/unix/sysv/linux/hppa/bits/sigaction.h: New file.
	* sysdeps/unix/sysv/linux/hppa/bits/signum.h: New file.
	* sysdeps/unix/sysv/linux/hppa/brk.c: New file.
	* sysdeps/unix/sysv/linux/hppa/clone.S: New file.
	* sysdeps/unix/sysv/linux/hppa/socket.S: New file.
	* sysdeps/unix/sysv/linux/hppa/syscall.S: New file.
	* sysdeps/unix/sysv/linux/hppa/setrlimit.c: New file.
	* sysdeps/unix/sysv/linux/hppa/getrlimit.c: New file.
	* sysdeps/unix/sysv/linux/hppa/getrlimit64.c: New file.
	* sysdeps/unix/sysv/linux/hppa/kernel_sigaction.h: New file.
	* sysdeps/unix/sysv/linux/hppa/kernel_stat.h: New file.
	* sysdeps/unix/sysv/linux/hppa/mmap.c: New file.
	* sysdeps/unix/sysv/linux/hppa/profil-counter.h: New file.
	* sysdeps/unix/sysv/linux/hppa/procfs.h: New file.
	* sysdeps/unix/sysv/linux/hppa/ucontext.h: New file.
	* sysdeps/unix/sysv/linux/hppa/umount.c: New file.

2000-10-12  Alan Modra  <alan@linuxcare.com.au>

	* sysdeps/hppa/hppa1.1/Implies: New file.
	* sysdeps/hppa/memusage.h: New file.

2000-10-28  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/unix/sysv/linux/ia64/Versions: Export ioperm, iopl, inb,
	inw, inl, _inb, _inw, _inl, outb, outw, outl, _outb, _outw,
	_outl.  Reported by Bill Nottingham.

2000-04-06  Andreas Schwab  <schwab@suse.de>

	* sysdeps/ia64/dl-machine.h (TRAMPOLINE_TEMPLATE): Save and
	restore register r8 for functions that return a structure.

2000-10-12  Jakub Jelinek  <jakub@redhat.com>

	* math/libm-test.inc (M_PI_6l, M_E2l, M_E3l, M_2_SQRT_PIl,
	M_SQRT_PIl): Increase precision.
	(cbrt_test): If cbrt is not implemented, don't test it.
	Add L suffix to double constants in results which differ from their
	L suffixed counterparts.
	(exp10_test, fmod_test, frexp_test, hypot_test, sqrt_test): Likewise.

	* sysdeps/sparc/sparc64/fpu/libm-test-ulps: Update.

2000-10-11  Jakub Jelinek  <jakub@redhat.com>

	* inet/rexec.c (rexec_af): Convert rport to host order before
	passing it to snprintf.

2000-10-14  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/gnu/netinet/tcp.h: Use u_intXX_t types instead of
	uintXX_t since this is what <sys/types.h> defines and we include
	this header.  Reported by Bernhard Rosenkraenzer <bero@redhat.de>.

	* intl/localealias.c (read_alias_file): Update string pointers
	in map[] if realloc() changed the values.
	Patch by Jakub Jelinek <jakub@redhat.com>.

	* manual/stdio.texi: Update printf extension documentation after
	z became a valid modifier.
	Patch by Joseph S. Myers <jsm28@cam.ac.uk>.

	* timezone/africa: Update from tzcode2000g and tzdata2000g.
	* timezone/asia: Likewise.
	* timezone/australasia: Likewise.
	* timezone/backward: Likewise.
	* timezone/europe: Likewise.
	* timezone/iso3166.tab: Likewise.
	* timezone/northamerica: Likewise.
	* timezone/southamerica: Likewise.
	* timezone/zone.tab: Likewise.

2000-10-14  Geoffrey Keating  <geoffk@cygnus.com>

	* sysdeps/unix/sysv/linux/powerpc/syscalls.list: Add fcntl()
	syscall.

2000-10-13  Michael Fedrowitz  <michael@fedrowitz.de>

	* sysdeps/unix/sysv/linux/m68k/alphasort64.c: New file.
	* sysdeps/unix/sysv/linux/m68k/fcntl.c: New file.
	* sysdeps/unix/sysv/linux/m68k/getdents64.c: New file.
	* sysdeps/unix/sysv/linux/m68k/getrlimit.c: New file.
	* sysdeps/unix/sysv/linux/m68k/getrlimit64.c: New file.
	* sysdeps/unix/sysv/linux/m68k/glob64.c: New file.
	* sysdeps/unix/sysv/linux/m68k/lockf64.c: New file.
	* sysdeps/unix/sysv/linux/m68k/oldgetrlimit64.c: New file.
	* sysdeps/unix/sysv/linux/m68k/readdir64.c: New file.
	* sysdeps/unix/sysv/linux/m68k/readdir64_r.c: New file.
	* sysdeps/unix/sysv/linux/m68k/scandir64.c: New file.
	* sysdeps/unix/sysv/linux/m68k/setrlimit.c: New file.
	* sysdeps/unix/sysv/linux/m68k/versionsort64.c: New file.
	* sysdeps/unix/sysv/linux/m68k/Dist: Add oldgetrlimit64.c.
	* sysdeps/unix/sysv/linux/m68k/Makefile: Add oldgetrlimit64.
	* sysdeps/unix/sysv/linux/m68k/Versions: Export __xstat64,
	__fxstat64, __lxstat64, alphasort64, glob64, getrlimit, setrlimit,
	getrlimit64, readdir64, readdir64_r, scandir64, versionsort64 at
	GLIBC_2.2.
	* sysdeps/unix/sysv/linux/m68k/syscalls.list: Add oldgetrlimit,
	oldsetrlimit for GLIBC_2.0.

	* sysdeps/m68k/dl-machine.h (_dl_start_user): Pass correct
	arguments to _dl_init.

2000-10-13  Geoffrey Keating  <geoffk@cygnus.com>

	* sysdeps/i386/fpu/libm-test-ulps: Update ULPs for my Pentium III
	building with the default options.

2000-10-11  Andreas Jaeger  <aj@suse.de>

	* sysdeps/generic/dl-cache.c (_dl_load_cache_lookup): Set cache.
	Patch by Denis Zaitsev <zzz@cd-club.ru>.

2000-10-09  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/ieee754/ldbl-128/s_nexttoward.c (__nexttoward): If x == y,
	return y not x.
	* manual/arith.texi (nextafter): Document it.
	* sysdeps/ieee754/ldbl-96/s_nexttoward.c: Fix a comment.

2000-10-08  Ulrich Drepper  <drepper@redhat.com>

	* version.h (VERSION): Bump to 2.1.95.

	* configure.in: Remove warning message.

	* nscd/Makefile (distribute): Add nscd-types.h.
	* elf/Makefile (distribute): Add gccframe.h.
	* sysdeps/sparc/sparc32/Dist: Add ieee754.h.
	* sysdeps/ia64/Dist: Add ieee754.h.

2000-10-07  Ulrich Drepper  <drepper@redhat.com>

	* elf/elf.h: Add a few section-related symbols.

	* include/features.h (__STDC_ISO_10646__): Set to correct date.
	Patch by Markus Kuhn <Markus.Kuhn@cl.cam.ac.uk>.

2000-10-06  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/ia64/fpu/fraiseexcpt.c (feraiseexcept): Implement
	overflow generation by adding DBL_MAX to DBL_MAX instead of
	setting the bits manually in the fpsr and generating the exception
	with kill() if necessary.
	(feraiseexcept): Implement underflow by dividing DBL_MIN by
	DBL_MIN - similar to the overflow change described above.

2000-08-27  H.J. Lu  <hjl@gnu.org>

	* sysdeps/unix/sysv/linux/ia64/clone.S: Make it a dummy as clone
	is not supported under Linux/ia64, use clone2.

2000-10-06  Jakub Jelinek  <jakub@redhat.com>

	* malloc/malloc.h (__THROW): Define to nothing if not gcc.
	* misc/sys/cdefs.h (__THROW): Likewise.

2000-10-05  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/sparc/sparc64/fpu/libm-test-ulps: New file.

2000-10-02  Jakub Jelinek  <jakub@redhat.com>

	* sunrpc/svc_udp.c (svcudp_recv): Set msg_controllen to all
	remaining xp_pad space.

2000-10-05  Jakub Jelinek  <jakub@redhat.com>

	* elf/dl-close.c (_dl_close): Check imap's l_flags_1 for
	DF_1_NODELETE, not list[i]'s.

2000-10-04  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/euc-kr.c (euckr_from_ucs4): Handle U20a9.
	(BODY from direction): Map \x5c to U20a9.
	* iconvdata/testdata/EUC-KR..UTF8: Adjust to this change.
	* iconvdata/EUC-KR.irreversible: New file.
	* iconvdata/Makefile (distribute): Add EUC-KR.irreversible.

	* argp/argp-parse.c (argp_default_argp): Set libc as message domain.
	(argp_version_argp): Likewise.

2000-10-04  Jakub Jelinek  <jakub@redhat.com>

	* stdio-common/vfscanf.c (_IO_vfscanf): For [ conversion do
	input_error() if EOF is seen before processing.
	* stdio-common/tstscanf.c (main): Add testcase.

2000-10-04  Ulrich Drepper  <drepper@redhat.com>

	* argp/argp-help.c: Make sure we get the correct gettext and
	dgettext definitions.
	* argp/argp-parse.c: Likewise.

2000-10-03  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/linereader.c (get_string): Also clear wide
	string info if illegal_string.

2000-10-03  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/m68k/bits/stat.h: New file.

2000-10-02  Jakub Jelinek  <jakub@redhat.com>

	* elf/nextmod1.c (failing_rtld_next_use): Ensure it is not tail call
	optimized.

	* sysdeps/sparc/sparc32/fpu/libm-test-ulps: New file.

2000-10-02  Ralf Baechle  <ralf@gnu.org>

	* sysdeps/unix/sysv/linux/mips/sys/tas.h: Add missing .mips0 at the
	end of inline assembler code.

2000-10-02  Ulrich Drepper  <drepper@redhat.com>

	* include/features.h [__USE_FILE_OFFSET && !__REDIRECT]: Define
	__USE_LARGEFILE64 and __USE_LARGEFILE to 1 and not nothing.

2000-10-02  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/alpha/bits/fcntl.h: Synch with Linux
	2.4.0-test9-pre8.

	* sysdeps/unix/sysv/linux/alpha/bits/resource.h: Add RLIMIT_LOCKS.

2000-10-01  Ralf Baechle  <ralf@gnu.org>

	* sysdeps/mips/dl-machine.h (RTLD_START): Fix computation of envp
	argument passed to _dl_init.

2000-09-30  Bruno Haible  <haible@clisp.cons.org>

	* locale/programs/charmap-dir.h: New file.
	* locale/programs/charmap-dir.c: New file.
	* locale/programs/linereader.h (lr_create): New declaration.
	* locale/programs/linereader.c (lr_create): New function, split out
	from lr_open.
	(lr_open): Tailcall lr_create.
	* locale/programs/locale.c: Include "charmap-dir.h". Don't include
	<unistd.h>.
	(xstrdup): New declaration.
	(more_help): Use xstrdup instead of strdup.
	(write_locales): Likewise. When encountering a symbolic link, call
	stat.
	(write_charmaps): Simplify using the charmap-dir.h functions.
	Use xstrdup instead of strdup.
	* locale/programs/charmap.c: Include "charmap-dir.h". Don't include
	<dirent.h> and <unistd.h>.
	(cmlr_open): New function.
	(charmap_read): Use cmlr_open instead of lr_open. Simplify using the
	charmap-dir.h functions.
	* locale/Makefile (distribute): Add charmap-dir.h.
	(lib-modules): Add charmap-dir.
	(CFLAGS-charmap-dir.c): Set to -Wno-write-strings, because posix_spawn
	wants a 'char **', not a 'const char **'.
	* include/spawn.h: New file.

2000-09-30  Bruno Haible  <haible@clisp.cons.org>

	* posix/spawn_faction_init.c: Include "spawn_int.h".
	(__posix_spawn_file_actions_realloc): Fix second realloc argument.

2000-09-30  Bruno Haible  <haible@clisp.cons.org>

	* locale/programs/config.h (DEFAULT_CHARMAP): Set to ANSI_X3.4-1968.

2000-09-30  Bruno Haible  <haible@clisp.cons.org>

	* wcsmbs/wcwidth.h (__ctype32_wctype): Remove declaration.
	(internal_wcwidth): Remove the tests for L'\0' and iswprint.
	* locale/programs/ld-ctype.c (find_idx): If max == NULL, return
	a pointer to the table entry, without extending the table.
	(allocate_arrays): Set a width only for characters with 'print'
	property. Set the width of L'\0' to 0.
	* locale/C-ctype.c (_nl_C_LC_CTYPE_width): Use default entry 0xff
	for unprintable characters.  Set entry of NUL to 0.

2000-09-30  Bruno Haible  <haible@clisp.cons.org>

	* locale/programs/charmap.c (charmap_read): Avoid redundant tests.
	Don't forget to call closedir when the filename was found as a
	code_set_name.

2000-09-30  Bruno Haible  <haible@clisp.cons.org>

	* iconv/gconv.h (__gconv_trans_context_fct): Change first argument's
	type to 'void *'.

2000-09-30  Bruno Haible  <haible@clisp.cons.org>

	* locale/programs/ld-ctype.c (wctype_table_init): Initialize level1,
	level2, and level3 as well.
	(wctype_table_add): Remove a few unnecessary conditionals.

2000-09-30  Ralf Baechle  <ralf@gnu.org>

	* wcsmbs/Versions [libc] (GLIBC_2.0): Add __mbrtowc.

2000-09-30  H.J. Lu  <hjl@gnu.org>

	* sysdeps/ieee754/ldbl-96/s_ceill.c (__ceill): Handle overflow.
	* sysdeps/ieee754/ldbl-96/s_floorl.c (__floorl): Likewise.

2000-09-29  H.J. Lu  <hjl@gnu.org>

	* math/libm-test.inc (init_max_error): Clear all exceptions
	before starting test.
	(acosh_test): Test for existence of function.
	(asinh_test): Likewise.
	(atan2_test): Likewise.
	(cabs_test): Likewise.
	(cacos_test): Likewise.
	(cacosh_test): Likewise.
	(casin_test): Likewise.
	(casinh_test): Likewise.
	(catan_test): Likewise.
	(catanh_test): Likewise.
	(ccos_test): Likewise.
	(ccosh_test): Likewise.
	(cexp_test): Likewise.
	(clog_test): Likewise.
	(clog10_test): Likewise.
	(cosh_test): Likewise.
	(cpow_test): Likewise.
	(csin_test): Likewise.
	(csinh_test): Likewise.
	(csqrt_test): Likewise.
	(ctan_test): Likewise.
	(ctanh_test): Likewise.
	(fmod_test): Likewise.
	(hypot_test): Likewise.
	(remainder_test): Likewise.
	(remquo_test): Likewise.
	(sincos_test): Likewise.
	(sinh_test): Likewise.
	(tanh_test): Likewise.

2000-09-29  H.J. Lu  <hjl@gnu.org>

	* sysdeps/ia64/ieee754.h: New file.

	* sysdeps/ia64/fpu/math_ldbl.h: New file.

2000-09-30  Jakub Jelinek  <jakub@redhat.com>

	* elf/ldconfig.h (FLAG_X8664_LIB64): Define.
	* sysdeps/unix/sysv/linux/i386/readelflib.c: New file.

2000-09-30  Ulrich Drepper  <drepper@redhat.com>

	* manual/charset.texi: Correct notations, reference to C90 amd 1,
	and some other details.
	* manual/ctype.texi: Likewise.
	Patches by Markus Kuhn <Markus.Kuhn@cl.cam.ac.uk>.

2000-09-30  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* sysdeps/ieee754/flt-32/s_frexpf.c: Make it aliasing safe.

2000-09-29  Ulrich Drepper  <drepper@redhat.com>

	* elf/cache.c (save_cache): Initialize __unused field in new cache
	as well to get reproducable results.

2000-09-29  H.J. Lu  <hjl@gnu.org>

	* sysdeps/ia64/fpu/libm-test-ulps: Updated for long double.

2000-09-29  H.J. Lu  <hjl@gnu.org>

	* sysdeps/ia64/bits/huge_val.h: New file.

2000-09-29  Ulrich Drepper  <drepper@redhat.com>

	* elf/chroot_canon.c: Don't report a failure if the last path
	component is not available.
	* elf/ldconfig.c (parse_conf): Use canonicalized name when reporting
	error.

	* elf/cache.c (print_cache): Use stat64 instead of stat.
	* elf/ldconfig.c (chroot_stat): Likewise.
	(create_links): Likewise.
	(manual_link): Likewise.
	(search_dir): Likewise.
	* elf/readlib.c (process_file): Likewise.

	* Makefile (install): Set LC_ALL and LANGUAGE to C before running
	ldconfig.

2000-09-29  Jakub Jelinek  <jakub@redhat.com>

	* elf/chroot_canon.c: New file.
	* elf/Makefile: Build and distribute it.
	* elf/ldconfig.h (process_file): Add real_file_name argument.
	(chroot_canon): Add prototype.
	* elf/ldconfig.c (cache_file): Remove const.
	(chroot_stat): New.
	(create_links): Add real_path argument.
	If opt_chroot, maintain both real and given filenames.
	(manual_link): Likewise.
	(search_dir): Likewise.
	(parse_conf): If opt_chroot, use chroot_canon to find the real
	config file.
	(main): For -r, try to use chroot, if it fails, leave opt_chroot set
	and use chroot_canon where appropriate to do the same as if chroot
	succeeded.
	* elf/readlib.c (process_file): Add real_file_name argument, pass it
	to fopen.

2000-09-29  Ulrich Drepper  <drepper@redhat.com>

	* math/complex.h (_Complex): We can be more specific when _Complex
	is defined by the compiler.

2000-09-29  H.J. Lu  <hjl@gnu.org>

	* sysdeps/unix/sysv/linux/ia64/dl-cache.h: New.

	* elf/cache.c (print_entry): Replace 64bit with IA-64 in message
	for x86/IA-64 binary.

2000-09-29  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/ia64/readelflib.c: New file.

	* elf/cache.c (print_entry): Check for FLAG_IA64_LIB64.

2000-09-29  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/mach/hurd/dl-sysdep.c (__access): New function.  Dummy
	implementation for use by the dynamic linker.

2000-09-29  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/arm/bits/fcntl.h: Protect DN_* by
	__USE_GNU.
	* sysdeps/unix/sysv/linux/ia64/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/m68k/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/mips/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/fcntl.h: Likewise.

2000-09-29  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/arm/bits/fcntl.h: Synch with Linux
	2.4.0-test9-pre7.
	* sysdeps/unix/sysv/linux/ia64/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/m68k/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/mips/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/fcntl.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/fcntl.h: Likewise.

2000-09-29  David Mosberger  <davidm@hpl.hp.com>

	* sysdeps/unix/sysv/linux/ia64/sysdep.S (__ia64_syscall): Cleanup.

	* sysdeps/unix/sysv/linux/ia64/sysdep.h (CALL_MCOUNT): Implement.

2000-06-10  David Mosberger  <davidm@hpl.hp.com>

	* sysdeps/unix/sysv/linux/ia64/setjmp.S: Fix it so it actually
	works: call to __sigjmp_save must be done unconditionally to
	ensure jmp_buf is initialized properly.

2000-09-27  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/i386/bits/fcntl.h: Synch with Linux
	2.4.0-test9-pre7.

2000-09-29  Jakub Jelinek  <jakub@redhat.com>

	* nscd/nscd-client.h (NSCD_VERSION): Bump to 3.
	Use nscd_ssize_t where appropriate.
	* nscd/nscd_gethst_r.c (nscd_gethst_r): Use nscd_ssize_t instead of
	ssize_t where appropriate.
	* nscd/nscd_getgr_r.c (nscd_getgr_r): Likewise.
	* nscd/hstcache.c (cache_addhst): Likewise.
	* nscd/grpcache.c (cache_addgr): Likewise.
	* sysdeps/generic/nscd-types.h: New file.
	* sysdeps/alpha/nscd-types.h: New file.

2000-09-29  Ulrich Drepper  <drepper@redhat.com>

	* inet/getnameinfo.c (nrl_domainname): Use symbolic constant
	INADDR_LOOPBACK instead of numeric value.

2000-09-28  H.J. Lu  <hjl@gnu.org>

	* sysdeps/ia64/dl-machine.h (RTLD_START): Adjust _dl_argv by
	_dl_skip_args.
	(ELF_MACHINE_FIXED_STACK): Removed.

2000-09-29  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/s390/lockf64.c: New file.

	* sysdeps/unix/sysv/linux/s390/fcntl.c: New file.

	* sysdeps/unix/sysv/linux/powerpc/lockf64.c: New file.

	* sysdeps/unix/sysv/linux/powerpc/fcntl.c: New file.

2000-09-28  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/alpha/dl-machine.h (elf_machine_rela): Handle unaligned
	relocation also for R_ALPHA_RELATIVE.
	Reported by Ivan Kokshaysky <ink@jurassic.park.msu.ru>.

2000-09-18  Bruno Haible  <haible@clisp.cons.org>

	* intl/dcigettext.c: Outside libc, use local variable names that don't
	clash with those in libc.
	* intl/bindtextdom.c: Likewise.
	* intl/textdomain.c: Likewise.

2000-09-28  Ulrich Drepper  <drepper@redhat.com>

	* elf/ldconfig.c (parse_conf): Print full name of config dir
	including chroot() path.
	(main): Remove trailing / from opt_chroot string.

	* include/features.h: Correct description of what happens if no
	*_SOURCE macro is defined.

	* sysdeps/posix/getaddrinfo.c (gaih_inet): Handle req->ai_socktype
	correctly.  Reported by Felix von Leitner <leitner@convergence.de>.

2000-09-19  H.J. Lu  <hjl@gnu.org>

	* malloc/malloc.h (__memalign_hook): Fix the parameter order.
	* malloc/malloc.c (__memalign_hook): Likewise.
	(memalign_hook_ini): Likewise.

2000-09-28  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/tmpnam.c (tmpnam): Optimize a bit.

	* sysdeps/posix/getaddrinfo.c (gaih_local): Don't use tmpnam, use
	underlying functions directly.

	* sysdeps/unix/sysv/linux/bits/resource.h: Add RLIMIT_LOCKS.
	* sysdeps/unix/sysv/linux/arm/bits/resource.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/bits/resource.h: Likewise.
	* sysdeps/unix/sysv/linux/mips/bits/resource.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/resource.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/bits/resource.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/resource.h: Likewise.

2000-09-28  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* sysdeps/unix/sysv/linux/kernel-features.h: Add __ASSUME_IPC64, only
	define it for powerpc for kernel >= 2.4.0.
	* sysdeps/unix/sysv/linux/msgctl.c: Test for __ASSUME_IPC64, not
	__ASSUME_32BITUIDS.
	* sysdeps/unix/sysv/linux/semctl.c: Likewise.
	* sysdeps/unix/sysv/linux/shmctl.c: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/ipc.h: Sync with kernel.
	* sysdeps/unix/sysv/linux/powerpc/bits/msq.h: New file.
	* sysdeps/unix/sysv/linux/powerpc/bits/sem.h: New file.
	* sysdeps/unix/sysv/linux/powerpc/bits/shm.h: New file.

2000-09-28  Martin Schwidefsksy  <schwidefsky@de.ibm.com>

	* sysdeps/s390/atomicity.h: Fix compare_and_swap.

	* sysdeps/unix/sysv/linux/s390/bits/fcntl.h
	(F_GETLK64,F_SETLK64,F_SETLKW64): Use values from 2.4.0-test8.

2000-09-28  Denis Joseph Barrow  <djbarrow@de.ibm.com>

	* sysdeps/unix/sysv/linux/s390/sys/procfs.h: Use definitions from
	ucontext.h.
	* sysdeps/unix/sysv/linux/s390/sys/ucontext.h: Fix ucontext structure.

2000-09-27  Andreas Schwab  <schwab@suse.de>

	* math/Makefile (distribute): Explicitly add the long double test
	sources, to get them included even if long double is not supported.

2000-09-27  Jes Sorensen  <jes@linuxcare.com>

	* elf/soinit.c (struct object): Move definition to gccframe.h and
	include it.  Problem identified by HJ Lu.

	* sysdeps/ia64/gccframe.h: New file.  ia64 specific version of
	struct object to be searched for frame unwind info.
	* sysdeps/generic/gccframe.h: New file.  Generic version of
	struct object to be searched for frame unwind info.

2000-09-28  Ulrich Drepper  <drepper@redhat.com>

	* manual/errno.texi: Correct error text for ENXIO.
	Reported by Jörg Schilling <schilling@fokus.gmd.de>.

2000-09-27  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/ia64/fpu/fsetexcptflg.c (fesetexceptflag): Set the
	exception status bits rather than the exception disable bits.
	Don't include math.h.

	* sysdeps/ia64/fpu/fgetexcptflg.c (fegetexceptflag): Report the
	status of exceptions currently raised rather than which exceptions
	are enabled.

	* sysdeps/ia64/fpu/fclrexcpt.c (feclearexcept): Typecase to fenv_t
	rather than unsigned long int.

	* sysdeps/ia64/fpu/fedisblxcpt.c (fedisableexcept): Only disable
	the exceptions actually requested by the caller and not just
	disable all exceptions.

	* sysdeps/ia64/fpu/feenablxcpt.c (feenableexcept): Exceptions on
	the ia64 are enabled by clearing the respective bits in the fpsr,
	not setting them.

	* sysdeps/ia64/bits/fenv.h: typedef fexcept_t and fenv_t to
	unsigned long int rather than unsigned long to be consistent with
	the coding conventions.

2000-09-20  H.J. Lu  <hjl@gnu.org>

	* sysdeps/ia64/fpu/fesetenv.c (fesetenv): Use fenv_t instead of
	unsigned long int.
	* sysdeps/ia64/fpu/fesetround.c (fesetround): Likewise.

2000-09-28  Ulrich Drepper  <drepper@redhat.com>

	* string/bits/string2.h: Unify #if usage.

2000-09-27  Jakub Jelinek  <jakub@redhat.com>

	* math/test-fenv.c (feexcp_mask_test): If enabling all exceptions
	and disabling underflow or overflow, disable inexact as well.

2000-09-26  Andreas Jaeger  <aj@suse.de>

	* sysdeps/gnu/netinet/tcp.h: Add tcp_info defines and types.

	* sysdeps/unix/sysv/linux/sys/mount.h (enum): New flag MS_BIND.

	* sysdeps/unix/sysv/linux/powerpc/bits/fcntl.h (F_SETLKW64,
	F_GETLK64, F_SETLK64): Update from Linux-2.4.0-test9-pre4.

	* elf/ldconfig.c (search_dir): Allow unlimited path length.
	(create_links): Likewise.

2000-09-27  Ulrich Drepper  <drepper@redhat.com>

	* posix/tst-dir.c: Test a few error cases of chdir.

2000-09-26  Ulrich Drepper  <drepper@redhat.com>

	* math/math_private.h: Don't add long double prototypes if
	NO_LONG_DOUBLE is defined.

	* sysdeps/unix/i386/i586/clock_nanosleep.c (CLOCK_P): Remove
	CLOCK_MONOTONIC.
	* sysdeps/unix/i386/i586/clock_gettime.c (EXTRA_CLOCK_CASES): Likewise.
	* sysdeps/unix/i386/i586/clock_getres.c (EXTRA_CLOCK_CASES): Likewise.

	* sysdeps/unix/sysv/linux/i386/bits/time.h: Remove CLOCK_MONOTONIC.

2000-09-26  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/sparc/sparc32/bits/endian.h: Remove.
	* sysdeps/sparc/sparc32/ieee754.h: New.
	* sysdeps/sparc/sparc64/bits/endian.h: Move...
	* sysdeps/sparc/bits/endian.h: ...here.
	* sysdeps/unix/sysv/linux/sparc/sparc32/clone.S (__clone): Optimize.
	* sysdeps/unix/sysv/linux/sparc/sparc64/clone.S (__clone): Check
	%o1, not %o0 to see if we're parent or child.  Optimize.

2000-09-26  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/unix/sysv/linux/ia64/fork.S: New file (based on code
	by Hans Boehm).
	* sysdeps/unix/sysv/linux/ia64/vfork.S: New file (based on
	code by Hans Boehm).
	* sysdeps/unix/sysv/linux/ia64/fork.c: Deleted (obsoleted by fork.S).

2000-09-20  H.J. Lu  <hjl@gnu.org>

	* sysdeps/ia64/fpu/printf_fphex.c: New file.

	* sysdeps/ia64/fpu/libm-test-ulps: New file.

2000-09-17  H.J. Lu  <hjl@gnu.org>

	* sysdeps/ia64/Makefile (long-double-fcts): New.  Defined as yes.

	* sysdeps/ia64/fpu/s_isinfl.c: New file.  Include
	sysdeps/i386/fpu/s_isinfl.c.

	* sysdeps/ia64/fpu/s_isnanl.c: New file.  Include
	sysdeps/i386/fpu/s_isnanl.c.

	* sysdeps/ia64/fpu/s_nextafterl.c: New file.  Include
	sysdeps/i386/fpu/s_nextafterl.c.

	* sysdeps/ia64/fpu/bits/mathdef.h: New file.  Copied from
	sysdeps/i386/fpu/bits/mathdef.h.

2000-09-16  H.J. Lu  <hjl@gnu.org>

	* sysdeps/generic/ldsodefs.h (DL_UNMAP): New.  Defined if
	DL_UNMAP_IS_SPECIAL is not defined.

	* sysdeps/ia64/dl-lookupcfg.h (DL_UNMAP_IS_SPECIAL): Defined.
	(_dl_unmap): New prototype.
	(DL_UNMAP): New.  Defined as _dl_unmap.

	* sysdeps/ia64/Versions [ld] (GLIBC_2.2): Add _dl_unmap.

	* elf/dl-close.c (_dl_close): Replace __munmap with DL_UNMAP.

2000-09-16  H.J. Lu  <hjl@gnu.org>

	* sysdeps/generic/ldsodefs.h (DL_LOOKUP_ADDRESS): New. Defined
	if ELF_FUNCTION_PTR_IS_SPECIAL is not defined.

	* sysdeps/ia64/dl-lookupcfg.h (_dl_lookup_address): New
	prototype.
	(DL_LOOKUP_ADDRESS): New. Defined as _dl_lookup_address.

	* sysdeps/ia64/dl-fptr.c (_dl_lookup_address): New. Lookup
	the memory location of a function from a function descriptor.

	* sysdeps/ia64/Versions [ld] (GLIBC_2.2): Add _dl_lookup_address.

	* elf/dl-addr.c (_dl_addr): Use DL_LOOKUP_ADDRESS to get the
	memory location.

2000-09-14  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/ia64/bits/byteswap.h (__bswap_16): Don't mark output
	variable as input argument.
	(__bswap_32): Likewise.

	* sysdeps/ia64/dl-machine.h: Add missing stop bit in RTLD_START()
	- found by Jim Wilson <wilson@cygnus.com>

2000-09-26  Ulrich Drepper  <drepper@redhat.com>

	* string/strxfrm.c: Only require alignment on __alignof__ (int32_t)
	instead of 4.

2000-09-26  Andreas Schwab  <schwab@suse.de>

	* locale/programs/ld-collate.c (collate_output): Only require
	alignment on __alignof__ (int32_t) instead of 4.
	* locale/loadlocale.c (_nl_load_locale): Likewise.
	* string/strcoll.c: Likewise.

2000-09-26  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/ieee754/ldbl-96/e_atan2l.c (__ieee754_atan2l): Add
	parentheses around arithmetic used in | statement to kill compiler
	warning.

	* math/math_private.h: Add prototype for __finitel.
	(__ilogbl): Likewise.
	(__isinfl): Likewise.
	(__isnanl): Likewise.
	(__atanl): Likewise.
	(__copysignl): Likewise.
	(__expm1l): Likewise.
	(__floorl): Likewise.
	(__frexpl): Likewise.
	(__ldexpl): Likewise.
	(__log1pl): Likewise.
	(__nanl): Likewise.
	(__rintl): Likewise.
	(__scalbnl): Likewise.
	(__sqrtl): Likewise.
	(fabsl): Likewise.
	(__sincosl): Likewise.

2000-09-26  Andreas Schwab  <schwab@suse.de>

	* sysdeps/m68k/fpu/libm-test-ulps: New file

2000-09-26  Ulrich Drepper  <drepper@redhat.com>

	* locale/langinfo.h (__nl_langinfo_l): Add prototype.

2000-09-26  Andreas Jaeger  <aj@suse.de>

	* misc/mkstemp64.c: New file.
	* misc/Makefile (routines): Add mkstemp64.
	* stdlib/stdlib.h: Add prototype and redirection magic.
	* misc/Versions: Add mkstemp64.

2000-09-26  Thorsten Kukuk  <kukuk@suse.de>

	* nscd/dbg_log.c (dbg_log): Add missing format string.

2000-09-26  Ulrich Drepper  <drepper@redhat.com>

	* catgets/catgets.c (catopen): Use getenv instead of __secure_getenv
	since we filter out the variable once.
	* iconv/gconv_conf.c (__gconv_get_path): Likewise.
	* locale/newlocale.c (__newlocale): Likewise.
	* locale/setlocale.c (setlocale): Likewise.
	* malloc/malloc.c (ptmalloc_init): Likewise.
	* resolv/res_hconf.c (_res_hconf_init): Likewise.
	* resolv/res_init.c (__res_vinit): Likewise.
	* time/tzfile.c (__tzfile_read): Likewise.
	* sysdeps/generic/unsecvars.h: New file.
	* elf/dl-support.c (non_dynamic_init): Use it here to remove variables.
	* elf/rtld.c (process_envvars): Likewise.
	* elf/Makefile (distribute): Add unsecvars.h.

	* misc/daemon.c (daemon): Fail if !noclose and we cannot open the
	real /dev/null device.

	* sysdeps/generic/check_fds.c: Include device-nrs.h.
	* sysdeps/generic/device-nrs.h: New file.
	* sysdeps/unix/sysv/linux/device-nrs.h: New file.
	* misc/Makefile (distribute): Add device-nrs.h.

	* sysdeps/unix/sysv/linux/gethostid.c (sethostid): Use O_TRUNC to
	remove possible garbage at the end of the file.

2000-09-25  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/tmpnam_r.c: Warn about insecure tmpnam_r.
	* stdio-common/tmpnam.c: Warn about insecure tmpnam.
	* stdio-common/tempnam.c: Warn about insecure tempnam.
	* misc/mktemp.c: Warn about insecure mktemp.

	* sysdeps/generic/check_fds.c: Check that file opened is really
	/dev/null.
	* posix/wordexp.c (exec_comm_child): Likewise.

	* elf/rtld.c (process_envvars): Open debug output file with O_NOFOLLOW.

	* locale/Makefile (routines): Add nl_langinfo_l.
	* locale/Versions [libc] (GLIBC_2.2): Add __nl_langinfo_l.
	* locale/nl_langinfo_l.c: New file.
	* locale/nl_langinfo.c: Allow use of file for __nl_langinfo_l
	definition.

2000-09-23  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/gbk.c (USE_PRIVATE_AREA): Define to 0.
	(__gbk_to_ucs): Conditionalize private area mappings.
	(__gbk_from_ucs4_tab9): Likewise.
	(BODY for TO_LOOP): Likewise.
	* iconvdata/testdata/GBK: Don't use characters not yet in Unicode.
	* iconvdata/testdata/GBK..UTF-8: Likewise.
	* iconvdata/tst-tables.sh: Enable GBK test.

2000-09-23  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/gbk.c (__gbk_to_ucs): Swap U+2014 and U+2015.
	(__gbk_from_ucs4_tab4): Swap entries for U+2014 and U+2015.
	(BODY for FROM_LOOP): Reject input > 0xFEA0, avoids out-of-bounds
	array access.
	* iconvdata/gbgbk.c (BODY for FROM_LOOP): Map 0xA844 to 0xA1AA.
	* iconvdata/testdata/GBK..UTF8: Swap U+2014 and U+2015.

2000-09-23  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/johab.c (final_to_ucs): Fix typos.
	(jamo_from_ucs_table): Likewise.
	(BODY for FROM_LOOP): Map 0x5c to U+20A9. Reject ranges
	0xD9E6..0xD9FE and 0xDEF2..0xDEFE.
	(BODY for TO_LOOP): Map U+20A9 to 0x5c. Don't produce values in
	the range 0xD9E6..0xD9FE.
	* iconvdata/tst-tables.sh: Enable JOHAB testing.

2000-09-25  Ulrich Drepper  <drepper@redhat.com>

	* iconv/gconv_conf.c (__gconv_get_path): Fix problem with relative
	GCONV_PATH.

2000-09-24  Ulrich Drepper  <drepper@redhat.com>

	* libio/genops.c (_IO_doallocbuf): Don't use single byte buffer if
	stream is in wide mode.

	* stdio-common/vfprintf.c (buffered_vfprintf): Orient stream.

2000-09-21  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/iso-2022-cn-ext.c (EMIT_SHIFT_TO_INIT): Shift __count
	by 3, not 2.
	(INIT_PARAMS, UPDATE_PARAMS): Likewise.

2000-09-21  Bruno Haible  <haible@clisp.cons.org>

	* stdio-common/vfscanf.c (__vfscanf, _IO_vfscanf): Fix bugs in
	reallocation logic for MALLOC (%as, %aS formats).

2000-09-24  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/vfprintf.c (process_arg): Handle %hhn.
	Add missing case in va_arg handling for numbers.
	* stdio-common/tst-printf.c (main): Add tests for %hhu and %hhn
	handling.
	* stdio/tst-printf.sh: Adjust expected results.
	Reported by Joseph S. Myers <jsm28@cam.ac.uk>.

2000-09-20  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/iso-2022-jp.c (BODY for FROM_LOOP): Reject 0x80.
	(BODY for TO_LOOP): Clear bit 7 when outputting ISO-8859-1 upper half
	characters.
	* iconvdata/gen-8bit-gap-1.sh: Recognize lowercase hexadecimal digits
	as equivalent to uppercase hexadecimal digits.

2000-09-20  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/testdata/EUC-KR..UTF8: New file.
	* iconvdata/testdata/EUC-TW: New file.
	* iconvdata/testdata/EUC-TW..UTF8: New file.
	* iconvdata/testdata/EUC-JP: New file.
	* iconvdata/testdata/EUC-JP..UTF8: New file.
	* iconvdata/testdata/ISO-2022-JP: New file.
	* iconvdata/testdata/ISO-2022-JP..UTF8: New file.
	* iconvdata/testdata/ISO-2022-JP-2: New file.
	* iconvdata/testdata/ISO-2022-JP-2..UTF8: New file.
	* iconvdata/testdata/ISO-2022-KR: Add a few more lines.
	* iconvdata/testdata/ISO-2022-KR..UTF8: New file.
	* iconvdata/testdata/ISO-2022-CN: New file.
	* iconvdata/testdata/ISO-2022-CN..UTF8: New file.
	* iconvdata/testdata/ISO-2022-CN-EXT: New file.
	* iconvdata/testdata/ISO-2022-CN-EXT..UTF8: New file.
	* iconvdata/TESTS: Enable tests for ISO-2022-JP, ISO-2022-JP-2,
	ISO-2022-CN, ISO-2022-CN-EXT, EUC-JP, EUC-TW.

2000-09-24  Andreas Jaeger  <aj@suse.de>

	* elf/ldconfig.c (add_dir): Move logic to add entry to list to new
	function add_single_dir.
	(add_single_dir): New function.
	(search_dir): Use add_single_dir instead of recursing.

	* sysdeps/generic/dl-cache.h: Include stdint.h.
	(struct file_entry_new): Use fixed sizes for interoperability
	between 32bit and 64bit systems, add __unused to make alignment
	explicit.
	(CACHE_VERSION): Increment.
	(struct cache_file_new): Use fixed sizes, add one more unused
	entry to make alignment explicit.

2000-09-24  Ulrich Drepper  <drepper@redhat.com>

	* elf/ldconfig.c (search_dir): Make more use of d_type information.

2000-09-23  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/printf-parse.h (parse_one_spec): Clear
	spec->info.i18n.  Patch by Joseph S. Myers <jsm28@cam.ac.uk>.

2000-09-18  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/mach/hurd/bits/posix_opt.h (_POSIX_SYNCHRONIZED_IO):
	#undef since we don't have msync.

	* sysdeps/mach/hurd/bits/time.h: (CLOCKS_PER_SEC): Make a long int
	constant since that is what clock_t is.
	* sysdeps/mach/hurd/i386/bits/time.h: Likewise.

2000-09-11  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/mach/getloadavg.c (getloadavg): Divide instead of
	multiply by LOAD_SCALE.

2000-09-22  Jakub Jelinek  <jakub@redhat.com>

	* crypt/crypt.h (crypt, setkey, encrypt): Add __THROW.
	(crypt_r, setkey_r, encrypt_r): Likewise.

2000-09-22  Andreas Jaeger  <aj@suse.de>

	* locale/programs/repertoire.c (repertoiremap_hash): Don't specify
	array size.

	* sysdeps/alpha/fpu/libm-test-ulps: New file.
	From Christian Iseli <chris@ludwig-alpha.unil.ch>.

2000-09-21  Andreas Jaeger  <aj@suse.de>

	* math/libm-test.inc (atan_test): Test for existence of function.
	(expm1_test): Likewise.
	(acos_test): Likewise.
	(asin_test): Likewise.
	(exp_test): Likewise.
	(log10_test): Likewise.
	(log_test): Likewise.
	(pow_test): Likewise.
	(sqrt_test): Likewise.
	(cos_test): Likewise.
	(sin_test): Likewise.
	(tan_test): Likewise.
	(log1p_test): Likewise.
	(log2_test): Likewise.

	* sysdeps/i386/fpu/libm-test-ulps: Tweak some values for K6.

	* libio/oldiofsetpos64.c: Fix alias names.

2000-09-21  Martin Buchholz  <martin@xemacs.org>

	* manual/terminal.texi (Allocation): Sample code correction.

2000-09-20  Andreas Jaeger  <aj@suse.de>

	* iconvdata/Makefile (generated): Add tst-tables.out.

	* intl/Makefile	(generated): Add test output.

2000-09-19  Andreas Jaeger  <aj@suse.de>

	* sunrpc/clnt_simp.c (callrpc): Fix write beyond end of buffer.
	Reported by Jens-Uwe Mager <jum@helios.de>.

2000-09-18  Ulrich Drepper  <drepper@redhat.com>

	* version.h (VERSION): Bump to 2.1.94.

	* sysdeps/mips/Dist: Add fpu/fenv_libc.h.
	* sysdeps/sparc/sparc32/soft-fp/Dist: Add q_add.c.
	* sysdeps/sparc/sparc64/soft-fp/Dist: Add qp_add.c.
	* sysdeps/unix/sysv/linux/ia64/Dist: Add net/route.h.

	* malloc/mtrace.c (mtrace): Mark stream as close on exec.

2000-09-17  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/utf-16.c (BODY for TO_LOOP): Reject UCS-4 input in the
	range 0xD800..0xDFFF.
	* iconvdata/unicode.c (BODY for TO_LOOP): Likewise.
	(BODY for FROM_LOOP): Likewise.
	* iconv/gconv_simple.c (ucs2_internal_loop): Likewise.
	(internal_ucs2_loop): Likewise.
	(ucs2reverse_internal_loop): Likewise.
	(internal_ucs2reverse_loop): Likewise.

2000-09-17  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/utf-16.c (gconv_init): Add missing slashes to encoding
	names.

2000-09-17  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/tst-table-from.c (main): Fix test for error on stdout.
	* iconvdata/tst-table-to.c (main): Likewise.

2000-09-17  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/iso-ir-165.c (__isoir165_from_tab): Renamed from
	__isoir165_tab.
	* iconvdata/cns11643.h (__cns11643l1_to_ucs4_tab): New declaration.
	* iconvdata/iso-2022-cn-ext.c: Include "cns11643.h".
	(GB7590_set, GB13132_set, CNS11643_3_set, CNS11643_4_set,
	CNS11643_5_set, CNS11643_6_set, CNS11643_7_set): Change enum values.
	(BODY for FROM_LOOP): Fix buffer overrun. Treat CNS11643 plane 3.
	Return __GCONV_INCOMPLETE_INPUT instead of __GCONV_EMPTY_INPUT.
	(BODY for TO_LOOP): Fix usage of `set' vs. `used'.  Fix typo that
	caused GB2312 to be used instead of ISO-IR-165. Treat CNS11643
	plane 3.  Fix shift sequences. Output announcement for SS2 and SS3
	encodings when needed.  When outputting an announcement, don't clear
	most other announcements.

2000-09-17  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/iso-2022-cn.c (BODY for FROM_LOOP): Fix buffer overrun.
	(BODY for TO_LOOP): Fix usage of `set' vs. `used'.

2000-09-14  Bruno Haible  <haible@clisp.cons.org>

	* intl/Versions: Add bind_textdomain_codeset.

2000-09-16  Ralf Baechle  <ralf@gnu.org>

	* sysdeps/mips/dl-machine.h (_RTLD_PROLOGUE): Reformat.  Declare
	as function.
	(_RTLD_EPILOGUE): Reformat.  Declare size of entry function.
	(ELF_MACHINE_BEFORE_RTLD_RELOC): Relocate the dynamic linker itself so
	it will even work when not loaded to the standard address.
	(RTLD_START): Reformat.  Call _dl_start in a way that is safe even
	before the dynamic linker itself is relocated.

2000-09-18  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/kernel-features.h: Always define
	__ASSUME_32BITUIDS for MIPS.
	* sysdeps/unix/sysv/linux/mips/ipc_priv.h: New file.
	* sysdeps/unix/sysv/linux/mips/Dist: Add ipc_priv.h.

2000-09-17  H.J. Lu  <hjl@gnu.org>

	* catgets/Makefile ($(objpfx)de/libc.cat): Use
	$(make-target-directory) instead of mkdir.

2000-09-17  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* sysdeps/unix/sysv/linux/kernel-features.h: Always define
	__ASSUME_32BITUIDS for __powerpc__.
	* sysdeps/unix/sysv/linux/powerpc/ipc_priv.h: New file.
	* sysdeps/unix/sysv/linux/powerpc/Dist: Add ipc_priv.h.

2000-09-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/m68k/sysdep.h (INLINE_SYSCALL): Fix last
	patch.
	* sysdeps/unix/sysv/linux/arm/sysdep.h (INLINE_SYSCALL): Likewise.

2000-09-16  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/ia64/Implies: Reorder ieee754 implies so that ldbl-* comes
	first.
	* sysdeps/m68k/Implies: Likewise.
	* sysdeps/sparc/sparc64/Implies: Likewise.

2000-09-16  Jakub Jelinek  <jakub@redhat.com>

	* elf/readlib.c (process_file): Don't error for stale .so links either.

2000-09-16  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-load.c (_dl_map_object_from_fd): Add one more
	__builtin_expect.

	* include/bits/xopen_lim.h (LONG_BIT): Use LONG_MAX, not INT_MAX.
	Patch by Thorsten Kukuk <kukuk@suse.de>.

	* dlfcn/Makefile (distribute): Add defaultmod1.c and defaultmod2.c.
	(test): Add default.
	(modules-names): Add defaultmod1 and defaultmod2.
	Add rules to build test objects.

2000-09-15  Ulrich Drepper  <drepper@redhat.com>

	* wctype/wctype.h: Always include <bits/types.h>.
	Reported by Jim Meyering <meyering@ascend.com>.

	* elf/rtld.c (_dl_dynamic_weak): Set to 1 by default for now.
	* elf/dl-support.c: Likewise.

	* sysdeps/unix/sysv/linux/ia64/bits/stat.h: Correct position of
	st_blocks member in stat and stat64 structs.
	Patch by Bill Nottingham <notting@redhat.com>.

	* iconvdata/tst-tables.sh: Add warning that GB18030 test might
	take longer.

	* math/complex.h: Don't define _Complex macro for gcc 3.  Add
	__extension__ to _Complex_I definition since gcc warns if -pedantic.
	* math/bits/cmathcalls.h (conj): Add __extension__ since we use ~.
	Patches by Joseph S. Myers <jsm28@cam.ac.uk>.

	* include/limits.h: Define LLONG_MIN, LLONG_MAX, ULLONG_MAX if
	necessary.  Move includes of POSIX and Unix limits files to the end.
	* stdlib/Makefile (tests): Add tst-limits.
	* stdlib/tst-limits.h: New file.

2000-09-15  Andreas Jaeger  <aj@suse.de>

	* sysdeps/mips/fpu/fesetenv.c (__fesetenv): Handle FE_NOMASK_ENV.

	* sysdeps/mips/bits/fenv.h (FE_NOMASK_ENV): Define.

2000-09-15  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/alpha/sysdep.h (inline_syscall_clobbers): Add memory
	clobber.
	* sysdeps/unix/sysv/linux/arm/sysdep.h (INLINE_SYSCALL): Likewise.
	* sysdeps/unix/sysv/linux/m68k/sysdep.h (INLINE_SYSCALL): Likewise.

2000-09-15  Ulrich Drepper  <drepper@redhat.com>

	* elf/Makefile (distribute): Add nextmod1.c and nextmod2.c.
	(tests): Add next.
	(modules-names): Add nextmod1 and nextmod2.
	Add rules to build and run next.
	* elf/next.c: New file.
	* elf/nextmod1.c: New file.
	* elf/nextmod2.c: New file.

2000-09-14  Jakub Jelinek  <jakub@redhat.com>

	* elf/dl-lookup.c (_dl_lookup_symbol_skip): Fix a typo.

2000-09-15  Andreas Jaeger  <aj@suse.de>

	* sysdeps/mips/fpu/fenv_libc.h: New file.
	* sysdeps/mips/fpu/feenablxcpt.c: Use fenv_libc.h
	* sysdeps/mips/fpu/fegetexcept.c: Likewise.
	* sysdeps/mips/fpu/fedisblxcpt.c: Likewise.

	* sysdeps/mips/fpu/feenablxcpt.c: New file.
	* sysdeps/mips/fpu/fegetexcept.c: New file.
	* sysdeps/mips/fpu/fedisblxcpt.c: New file.

2000-09-14  Ulrich Drepper  <drepper@redhat.com>

	* intl/Makefile: Avoid unnecessary test reruns.

	* stdio-common/tst-printf.sh: Also allow output from 64-bit machines.

	* sysdeps/unix/sysv/linux/dl-osinfo.h (DL_SYSDEP_OSCHECK): Change
	to not use sysctl().  Too many architectures have problems with it.

2000-09-14  Andreas Jaeger  <aj@suse.de>

	* scripts/config.sub: New version from subversions.gnu.org.

	* time/clocktest.c (main): Change format, CLOCKS_PER_SEC is now
	long.

2000-09-14  Jakub Jelinek  <jakub@redhat.com>

	* posix/regex.c (compile_range): Cast collseq index to unsigned char
	to avoid accessing data before collseq.

	* sysdeps/sparc/fpu/bits/mathinline.h (__unordered_v9cmp): Avoid
	pasting strings together.

2000-09-14  Greg McGary  <greg@mcgary.org>

	* sysdeps/generic/bp-checks.h: Remove bogus reference to GNU MP in
	copyright notice.
	* sysdeps/generic/bp-semctl.h: Likewise.
	* sysdeps/generic/bp-start.h: Likewise.
	* sysdeps/generic/bp-sym.h: Likewise.
	* sysdeps/generic/bp-thunks.h: Likewise.  Include <stdio.h> to get
	rename prototype.

2000-09-13  Ulrich Drepper  <drepper@redhat.com>

	* io/test-lfs.c (do_test): Allow stat64() to return EOVERFLOW and
	don't fail.

	* elf/elf.h: Add missing official relocations.

	* libio/stdio.h: Define __FILE if __need___FILE is defined.
	* stdio/stdio.h: Likewise.
	* wcsmbs/wchar.h: Get definition of __FILE. Use __FILE instead of FILE.
	* include/stdio.h: Handle __need___FILE like __need_FILE.
	* include/wchar.h: Use __FILE instead of FILE.
	* libio/fwprintf.c: Include <stdio.h> for FILE definition.
	* libio/fwscanf.c: Likewise.
	* libio/getwc.c: Likewise.

	* sysdeps/generic/stdint.h (WINT_MAX): Define to 4294967295u.
	* sysdeps/generic/bits/wchar.h (WCHAR_MIN): Define to -2147483647 - 1.
	* sysdeps/unix/sysv/linux/i386/bits/wchar.h: Likewise.

	* assert/assert.h: Update comment header about ISO C section.
	* math/complex.h: Likewise.
	* ctype/ctype.h: Likewise.
	* include/errno.h: Likewise.
	* include/limits.h: Likewise.
	* locale/locale.h: Likewise.
	* math/math.h: Likewise.
	* setjmp/setjmp.h: Likewise.
	* signal/signal.h: Likewise.
	* stdio/stdio.h: Likewise.
	* libio/stdio.h: Likewise.
	* stdlib/stdlib.h: Likewise.
	* string/string.h: Likewise.
	* time/time.h: Likewise.
	* wcsmbs/wchar.h: Likewise.
	* wctype/wctype.h: Likewise.
	Patches by Joseph S. Myers <jsm28@cam.ac.uk>.

2000-09-13  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/bits/socket.h (__cmsg_nxthdr): Fix test
	for no more entries.
	* sysdeps/unix/sysv/aix/bits/socket.h (__cmsg_nxthdr): Likewise.
	* sysdeps/unix/sysv/linux/mips/bits/socket.h (__cmsg_nxthdr): Likewise.
	Reported by Eric S. Johnson <esj@cs.fiu.edu>, closes PR libc/1887.

2000-09-13  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/bits/time.h (CLOCKS_PER_SEC): Make a long int
	constant since this is what clock_t is.
	* sysdeps/unix/sysv/linux/alpha/bits/time.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/bits/time.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/bits/time.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/time.h: Likewise.

	* time/time.h: Don't defined clockid_t and timer_t unless POSIX
	definitions are requested.

2000-09-13  Andreas Jaeger  <aj@suse.de>

	* shlib-versions: libBrokenLocale needs minimal version for ia64,
	sparc64 and sh to synch with libc.

2000-09-13  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/Makefile (modules): Add ISO-2022-CN-EXT.
	(distribute): Add iso-2022-cn-ext.c.
	Add definitions to compile the new module.
	* iconvdata/gconv-modules: Add entries for ISO-2022-CN-EXT.
	* iconvdata/iso-2022-cn-ext.c: New file.
	* iconvdata/iso-ir-165.h (isoir165_to_ucs4): Renamed from
	ucs4_from_isoir165.  Increment input pointer if successful.

	* csu/Makefile: Work around a gcc bug when creating csu-dummies.

	* sysdeps/unix/sysv/linux/getdents.c: Pretty print.

2000-09-01  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/unix/sysv/linux/ia64/syscalls.list: Add
	__syscall_getdents64 wrapper.

	* sysdeps/unix/sysv/linux/ia64/net/route.h: New file.

2000-09-12  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/gb18030.c: Many many changes.  Make consistent with
	charmap and with itself.
	* iconvdata/tst-tables.sh: Test GB18030.

2000-09-11  Ulrich Drepper  <drepper@redhat.com>

	* iconv/skeleton.c: Fix last patch, add missing parameter to
	unaligned function call.

2000-09-10  Bruno Haible  <haible@clisp.cons.org>

	* locale/programs/ld-collate.c (collate_read): Fix typo in handling
	of decimal ellipsis.

2000-09-11  Bruno Haible <haible@clisp.cons.org>

	* locale/programs/ld-collate.c (collate_read): Always initialize
	error_section.next.

2000-09-10  Bruno Haible  <haible@clisp.cons.org>

	* locale/programs/ld-collate.c (collate_finish): Upper bound for
	ruleidx is 128, not 256.

2000-09-11  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/ld-collate.c (collate_read): Correct check for
	already inserted entries.

2000-09-10  Bruno Haible <haible@clisp.cons.org>

	* iconv/skeleton.c (FUNCTION_NAME): Handle unaligned access in
	second try as well.

2000-09-10  Bruno Haible <haible@clisp.cons.org>

	* iconv/skeleton.c (FUNCTION_NAME): Optimize an `if' if
	MAX_NEEDED_FROM > 1 && MAX_NEEDED_TO > 1.

2000-09-10  Bruno Haible <haible@clisp.cons.org>

	* iconv/skeleton.c (gconv_init): Replace all uses of RESET_STATE with
	SAVE_RESET_STATE.

2000-09-10  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/utf-7.c: New file.
	* iconvdata/gconv-modules (UTF-7): New module entries.
	* iconvdata/Makefile (modules): Add UTF-7.
	(distribute): Add utf-7.c.
	* iconvdata/testdata/UTF-7: New file.
	* iconvdata/testdata/UTF-7..UTF8: New file.
	* iconvdata/TESTS (UTF-7): New entry.
	* iconvdata/run-iconv-test.sh: Fix confusing output.

2000-09-11  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/posix/tempname.c (__gen_tempname): Use __lxstat and __xstat.

2000-09-10  David S. Miller  <davem@redhat.com>

	* sysdeps/sparc/sparc32/__longjmp.S (__longjmp): Correct %fp
	frame pointer offset for non-fast path.

2000-09-10  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/3level.h (*_init): Initialize level1, level2,
	and level3 as well.
	(*_add): Remove a few unnecessary conditionals.

2000-09-05  Wolfram Gloger  <wg@malloc.de>

	* malloc/thread-m.h [_LIBC]: Even if not linking with libpthread,
	ensure usability of mutex as an `in use' flag.

2000-09-10  Ulrich Drepper  <drepper@redhat.com>

	* shlib-versions: Simplify libm entries.  Correct a few Hurd entries.

	* sysdeps/generic/initfini.c: Rewrite slightly to get rid of the
	ugly GMON_WEAK_START hack.
	Patch by Philip Blundell <philb@gnu.org>.

	* sysdeps/i386/i486/bits/string.h: Pretty printing.

2000-09-09  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/powerpc/dl-machine.c: Add volatile to PPC_DCBST, PPC_SYNC,
	and PPC_ICBI asm for broken compilers.
	Patch by Franz Sirl <Franz.Sirl-kernel@lauterbach.com>.

2000-09-09  Andreas Jaeger  <aj@suse.de>

	* manual/message.texi (Advanced gettext functions): Fix typo.

	* sysdeps/unix/sysv/linux/dl-osinfo.h: Include <string.h> for
	strncpy prototype.

2000-09-09  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/ia64/memchr.S: Add .pred.rel to avoid wrong assembler
	warnings.
	* sysdeps/ia64/memccpy.S: Likewise.
	Patches by Jim Wilson <wilson@redhat.com>.

	* sysdeps/unix/sysv/linux/dl-osinfo.h (DL_SYSDEP_OSCHECK): Use uname
	before trying to read /proc.
	Patch by Matt Wilson <msw@redhat.com>.
	* include/sys/utsname.h: Declare __uname.
	* sysdeps/generic/uname.c: Make uname a weak alias of __uname.
	* sysdeps/mach/hurd/uname.c: Likewise.
	* sysdeps/unix/syscalls.list: Likewise.

	* iconv/gconv_dl.c (do_release_shlib): Rewrite condition for
	unloading a bit.

2000-09-08  Ulrich Drepper  <drepper@redhat.com>

	* posix/getopt.c (_getopt_internal): When long_only is set always
	recognize conflicts just like before.

2000-09-08  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* sysdeps/ia64/Makefile (sysdep-rtld-routines): New variable.

2000-09-08  Greg McGary  <greg@mcgary.org>

	* sysdeps/unix/sysv/linux/syscalls.list (mincore): Fix arg signature.
	* sysdeps/unix/make-syscalls.sh: New signature keyletter `V'.
	* sysdeps/generic/bp-checks.h (CHECK_N_PAGES): New macro.

2000-09-08  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/arm/lockf64.c: New file.

	* sysdeps/unix/sysv/linux/arm/fcntl.c: New file.

	* sysdeps/unix/sysv/linux/arm/bits/fcntl.h
	(F_GETLK64,F_SETLK64,F_SETLKW64): Use values from 2.4.0-test8.
	(F_GETLK,F_SETLK,F_SETLKW): Handle __USE_FILE_OFFSET64 correctly.

2000-09-07  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/tst-tables.sh: Enable EUC-KR test.

	* elf/dl-load.c (lose): Decrement _nl_loaded.
	(_dl_map_object_from_fd): Don't try to dlopen executables.

	* iconvdata/tst-tables.sh: Actually return with an error if
	something goes wrong.
	* iconvdata/tst-table.sh: Return with an error if any of the cmp fails.
	* iconvdata/big5hkscs.c (BODY of FROM_LOOP): Reject 0xff as input.

	* iconvdata/tst-tables.sh: Add BIG5HKSCS.

	* iconvdata/tst-table-to.c (main): Correct cast in iconv call.
	* iconvdata/tst-table-from.c: Include <string.h>.
	(try): Correct cast in iconv call.

	* elf/Makefile (all-rtld-routines): Evaluate $(sysdep-rtld-routines)
	too.
	* sysdeps/powerpc/Makefile (sysdep-rtld-routines): New variable.
	(sysdep_routines): Remove dl-start.
	Patches by Franz Sirl <Franz.Sirl-kernel@lauterbach.com>.

	* assert/__assert.c: Undefine NDEBUG before include <assert.h>.

	* sysdeps/unix/sysv/linux/msgsnd.c (msgsnd): Add cast to avoid warning.
	* sysdeps/unix/sysv/linux/shmat.c (shmat): Likewise.

2000-09-06  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/ia64/bits/time.h: New file.

2000-09-07  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/gethostid.c: Find hostid file in /etc.

	* scripts/config.sub: Strip out -unknown for Linux targets.
	Patch by Scott Bambrough <scottb@netwinder.org>.

	* posix/tst-dir.c (main): Correct one bug (missing NULL test) and
	add one more test.

2000-09-07  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/mips/lockf64.c: New file.

	* sysdeps/unix/sysv/linux/i386/fcntl.c: Add prototypes for the
	syscalls.

	* sysdeps/unix/sysv/linux/mips/syscalls.list: Add __syscall_fcntl.

	* sysdeps/mips/dl-machine.h (RESOLVE_GOTSYM): Fix calls to dl_lookup.
	(ELF_MACHINE_RUNTIME_TRAMPOLINE): Likewise.

	* sysdeps/unix/sysv/linux/mips/fcntl.c: New file.

	* stdlib/tst-bsearch.c (main): Add more test cases.

	* locale/programs/ld-collate.c (handle_ellipsis): Fix typo.
	* elf/dl-load.c (_dl_map_object_from_fd): Likewise.
	Reported by GOTO Masanori <gotom@debian.or.jp>.

2000-09-07  Ulrich Drepper  <drepper@redhat.com>

	* posix/Makefile (tests): Add tst-dir.
	(tst-dir-ARGS): New variable.
	* posix/tst-dir.c: New file.

2000-09-07  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/mips/sys/syscall.h (SYS_getdents64): New.
	(SYS_fcntl64): New.

	* sysdeps/unix/sysv/linux/mips/syscalls.list: Add getdents64.

2000-09-06  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/opendir.c: If O_DIRECTORY_WORKS is defined don't
	use the hack with tryopen_o_directory to determine at runtime
	whether it works.
	* sysdeps/unix/sysv/linux/opendir.c: New file.
	* sysdeps/unix/sysv/linux/kernel-features.h: Define
	__ASSUME_O_DIRECTORY if kernel knows O_DIRECTORY.

	* catgets/Depend: New file.  Add intl.
	* catgets/Makefile (tests): Add tst-catgets.
	(generated): Remove de.msg.
	(generated-dirs): Add de.
	Add dependency if tst-catgets output on de/libc.cat.
	* catgets/tst-catgets.c: New file.

	* po/ja.po: New file.
	* po/el.po: Update from translation team.

	* wcsmbs/Depend: New file.
	* wcsmbs/Makefile (tests): Add tst-btowc.
	(tst-btowc-ENV): Define.
	* wcsmbs/tst-btowc.c: New file.

	* sysdeps/unix/sysv/linux/_G_config.h: Moved to...
	* sysdeps/gnu/_G_config.h: ...here to be shared with Hurd.

	* sysdeps/posix/signal.c: Add sig to act.sa_mask for completeness.

	* stdlib/Makefile (tests): Add tst-bsearch.
	* stdlib/tst-bsearch.c: New file.

	* posix/getopt.c (_getopt_internal): Don't recognize an option
	name as ambiguous if it's a prefix for more than one name but the
	other struct option values are identical.

	* posix/tstgetopt.c: Add test for improved ambiguity recognition.
	Don't depend on visual inspection of the output file to recognize
	errors.
	* posix/Makefile (tstgetopt-ARGS): Add a few more parameters.

2000-09-06  Andreas Jaeger  <aj@suse.de>

	* sysdeps/alpha/soft-fp/Dist: New file.
	* sysdeps/i386/soft-fp/Dist: New file.
	* sysdeps/mips/mips64/soft-fp/Dist: New file.
	* sysdeps/mips/soft-fp/Dist: New file.
	* sysdeps/powerpc/soft-fp/Dist: New file.
	* sysdeps/sparc/sparc32/soft-fp/Dist: New file.
	* sysdeps/sparc/sparc64/soft-fp/Dist: New file.

	* sysdeps/sparc/sparc64/soft-fp/Makefile [$(subdir) = soft-fp]:
	Use sysdep_routines instead of routines to fix make dist failure.
	* sysdeps/sparc/sparc32/soft-fp/Makefile: Likewise (in commented
	out code).
	* sysdeps/powerpc/soft-fp/Makefile [$(subdir) = soft-fp]: Likewise.

	* sysdeps/mips/Makefile [$(subdir) = misc]:  Use
	sysdep_headers instead of headers for make dist.

	* sysdeps/unix/sysv/linux/mips/Makefile [$(subdir) = misc]:
	Likewise.

2000-09-06  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/m68k/bits/fcntl.h: New file.

2000-09-06  Andreas Jaeger  <aj@suse.de>

	* soft-fp/Makefile (distribute): Remove ChangeLog.

	* sysdeps/sparc/sparc32/Makefile [$(subdir) = gnulib]:  Use
	sysdep_routines instead of routines for make dist.

2000-09-05  Ulrich Drepper  <drepper@redhat.com>

	* libio/libio.h (_IO_fwide_maybe_incompatible): For glibc 2.0
	compatibility check for old stream and call _IO_wide in doubt.
	(_IO_fwide): Use _IO_fwide_maybe_incompatible macro.
	* libio/iofwide.c (_IO_fwide): If compatibility with glibc 2.0 is
	needed tst for such an old structure and don't do anything.
	* libio/freopen.c: Remove declaration of _IO_stdin_used.

2000-09-06  Andreas Jaeger  <aj@suse.de>

	* sysdeps/powerpc/Makefile [$(subdir) = elf]: Modify
	sysdep-dl-routines and sysdep_routines instead of rtld-routines
	and dl-routines.

	* soft-fp/ChangeLog: Merged with this file.

2000-06-13  Ulrich Drepper  <drepper@redhat.com>

	* soft-fp/Makefile (distribute): Add op-8.h and testit.c.

	* soft-fp/Makefile (distribute): Add the math functions, too.

	* soft-fp/Makefile (distribute): Add ChangeLog, Banner, and configure.

2000-03-03  Geoff Keating  <geoffk@cygnus.com>

	* soft-fp/soft-fp.h (_FP_ROUND_ZERO): Cast 0 to void before using it
	as a statement.

	* soft-fp/sysdeps/powerpc/Makefile (routines): New file.
	* soft-fp/sysdeps/powerpc/q_*: New files.

2000-09-05  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/vfprintf.c (process_string_arg): Handle precision
	in wide char case correctly.  Don't allocate too long temporary
	strings with alloca.

	* stdio-common/Makefile (tests): Add tst-swprintf.
	(tst-swprintf-ENV): New variable.
	* stdio-common/tst-swprintf.c: New file.

2000-09-05  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/mips/bits/stat.h: Use st_pad5.
	* sysdeps/unix/sysv/linux/mips/xstatconv.c: Fix assignments.
	Patch by Maciej W. Rozycki <macro@ds2.pg.gda.pl>.

2000-09-05  Ulrich Drepper  <drepper@redhat.com>

	* configure.in: Strip out "unknown" from configuration names.

2000-09-05  Andreas Jaeger  <aj@suse.de>

	* sysdeps/powerpc/Subdirs: New file, adds soft-fp.

	* sysdeps/sparc/sparc64/Implies: Add soft-fp.
	* sysdeps/sparc/sparc32/Implies: Likewise.
	* sysdeps/powerpc/Implies: Likewise.

	* libio/oldiofsetpos64.c: Check for compatibility with glibc 2.1.
	* libio/oldiofgetpos64.c: Likewise.

	* soft-fp/Makefile (distribute): Remove configure.

	* sysdeps/sparc/sparc64/soft-fp/Versions: Use version glibc 2.2.

	* soft-fp/configure: Remove.

	* soft-fp/sysdeps/sparc/sparc64/qp_neg.S: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_neg.S: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/Makefile: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/Makefile: ... to here.

	* soft-fp/sysdeps/powerpc/Makefile: Move from here...
	* sysdeps/powerpc/soft-fp/Makefile: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/Makefile: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/Makefile: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_neg.S: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_neg.S: ... to here.

	* soft-fp/sysdeps/powerpc/q_add.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_add.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_cmp.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_cmp.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_cmpe.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_cmpe.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_div.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_div.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_dtoq.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_dtoq.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_feq.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_feq.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_fge.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_fge.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_fgt.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_fgt.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_fle.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_fle.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_flt.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_flt.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_fne.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_fne.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_itoq.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_itoq.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_lltoq.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_lltoq.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_mul.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_mul.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_neg.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_neg.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_qtod.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_qtod.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_qtoi.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_qtoi.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_qtoll.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_qtoll.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_qtos.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_qtos.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_qtou.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_qtou.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_qtoull.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_qtoull.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_sqrt.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_sqrt.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_stoq.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_stoq.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_sub.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_sub.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_ulltoq.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_ulltoq.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_util.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_util.c: ... to here.

	* soft-fp/sysdeps/powerpc/q_utoq.c: Move from here...
	* sysdeps/powerpc/soft-fp/q_utoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_add.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_add.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_cmp.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_cmp.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_cmpe.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_cmpe.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_div.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_div.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_dtoq.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_dtoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_feq.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_feq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_fge.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_fge.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_fgt.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_fgt.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_fle.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_fle.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_flt.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_flt.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_fne.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_fne.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_itoq.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_itoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_mul.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_mul.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_neg.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_neg.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_qtod.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_qtod.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_qtoi.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_qtoi.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_qtos.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_qtos.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_qtoui.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_qtoui.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_qtoux.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_qtoux.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_qtox.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_qtox.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_sqrt.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_sqrt.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_stoq.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_stoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_sub.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_sub.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_uitoq.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_uitoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_util.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_util.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_uxtoq.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_uxtoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/q_xtoq.c: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/q_xtoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_add.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_add.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_cmp.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_cmp.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_cmpe.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_cmpe.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_div.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_div.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_dtoq.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_dtoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_feq.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_feq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_fge.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_fge.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_fgt.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_fgt.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_fle.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_fle.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_flt.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_flt.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_fne.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_fne.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_itoq.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_itoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_mul.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_mul.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_qtod.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_qtod.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_qtoi.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_qtoi.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_qtos.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_qtos.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_qtoui.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_qtoui.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_qtoux.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_qtoux.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_qtox.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_qtox.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_sqrt.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_sqrt.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_stoq.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_stoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_sub.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_sub.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_uitoq.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_uitoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_util.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_util.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_uxtoq.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_uxtoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/qp_xtoq.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/qp_xtoq.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/s_frexpl.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/s_frexpl.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/s_ilogbl.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/s_ilogbl.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/s_scalblnl.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/s_scalblnl.c: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/s_scalbnl.c: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/s_scalbnl.c: ... to here.

	* soft-fp/sysdeps/alpha/sfp-machine.h: Move from here...
	* sysdeps/alpha/soft-fp/sfp-machine.h: ... to here.

	* soft-fp/sysdeps/i386/sfp-machine.h: Move from here...
	* sysdeps/i386/soft-fp/sfp-machine.h: ... to here.

	* soft-fp/sysdeps/mips/mips64/sfp-machine.h: Move from here...
	* sysdeps/mips/mips64/soft-fp/sfp-machine.h: ... to here.

	* soft-fp/sysdeps/mips/sfp-machine.h: Move from here...
	* sysdeps/mips/soft-fp/sfp-machine.h: ... to here.

	* soft-fp/sysdeps/powerpc/sfp-machine.h: Move from here...
	* sysdeps/powerpc/soft-fp/sfp-machine.h: ... to here.

	* soft-fp/sysdeps/sparc/sparc32/sfp-machine.h: Move from here...
	* sysdeps/sparc/sparc32/soft-fp/sfp-machine.h: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/sfp-machine.h: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/sfp-machine.h: ... to here.

	* soft-fp/sysdeps/powerpc/Versions: Move from here...
	* sysdeps/powerpc/soft-fp/Versions: ... to here.

	* soft-fp/sysdeps/sparc/sparc64/Versions: Move from here...
	* sysdeps/sparc/sparc64/soft-fp/Versions: ... to here.

	* libio/oldiofsetpos64.c: iofsetpos was introduced in glibc 2.1,
	change symbol version.
	* libio/oldiofgetpos64.c: Likewise.
	Reported by Martin v. Loewis <martin@loewis.home.cs.tu-berlin.de>.

	* locale/programs/ld-ctype.c (charclass_charcode_ellipsis): Fix
	typo.
	Reported by dyky@kondara.org, closes PR libc/1886.

	* stdlib/tst-strtod.c: Add testcases for denormal numbers from PR
	libc/1880.

2000-09-04  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/run-iconv-test.sh: Add code to immediately stop the
	script when ^C is hit.

	* locale/programs/localedef.c (construct_output_path): Correct
	computation of endp after asprintf.
	* locale/programs/locfile.c (write_locale_data): Don't add extra
	slash in filename.

2000-09-05  Andreas Jaeger  <aj@suse.de>

	* scripts/config.guess: New upstream version.
	* scripts/config.sub: Likewise.
	* manual/texinfo.tex: Likewise.

2000-09-04  Andreas Schwab  <schwab@suse.de>

	* elf/Makefile (all-dl-routines): New variable.
	(elide-routines.os): Use it instead of $(dl-routines).
	(all-rtld-routines): New variable.
	(extra-objs): Use it instead of $(rtld-routines).
	($(objpfx)dl-allobjs.os): Likewise.
	* sysdeps/ia64/Makefile [$(subdir) = elf]: Modify
	sysdep-dl-routines and sysdep_routines instead of rtld-routines
	and dl-routines.

2000-09-03  Bruno Haible  <haible@clisp.cons.org>

	* iconv/gconv_trans.c (__gconv_translit_find): Update open_count.
	Set fname to NULL if the module wasn't found.

2000-09-03  Bruno Haible  <haible@clisp.cons.org>

	* iconv/gconv_trans.c (__gconv_translit_find): Don't set need_so to
	true if trans->name already ends in ".so".

2000-09-03  Bruno Haible  <haible@clisp.cons.org>

	* iconv/gconv_int.h (__gconv_release_shlib): Change return type to
	void.
	* iconv/gconv_dl.c (do_release_shlib): Don't decrement the counter
	below -TRIES_BEFORE_UNLOAD-1, to avoid wraparound.
	(__gconv_release_shlib): Change return type to void.
	* iconv/gconv_builtin.c (__gconv_get_builtin_trans): Don't set
	step->__counter here.
	* iconv/gconv_db.c (free_derivation): Don't call a step's destructor
	if the reference is zero.
	(release_step): New function.
	(gen_steps): Always initialize the __counter to 1. Use release_step.
	Don't call the destructor on the step whose initializer failed.
	(increment_counter): Use release_step. Don't normally run destructors
	here.
	(__gconv_close_transform): Use release_step.

2000-09-03  Bruno Haible  <haible@clisp.cons.org>

	* iconv/gconv_simple.c (encoding_mask, encoding_byte): Remove.
	(__gconv_transform_internal_utf8) [BODY]: Use simple shifts instead.

2000-09-03  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/euc-tw.c (BODY for FROM_LOOP): Initialize ch2 correctly.
	If the first byte is 0x8E, don't ask for 4 bytes until it has been
	verified that the second byte is valid. Leave it to cns11643_to_ucs4
	to check for incomplete input.
	* iconvdata/cns11643.h (cns11643_to_ucs4): The plane number is
	ch - 0x20 - offset, not ch - 0x21 - offset. Upper bound for
	__cns11643l1_to_ucs4_tab is 0x21f2, not 0x2196.
	(ucs4_to_cns11643): Fix mapping for ranges 0x3105..0x3129 and
	0x9f9d..0x9fa5.
	* iconvdata/cns11643l1.h (cns11643l1_to_ucs4): Upper bound for
	__cns11643l1_to_ucs4_tab is 0x21f2, not 0x2196.
	(ucs4_to_cns11643l1): Fix mapping for range 0x3105..0x3129.
	* iconvdata/cns11643l1.c (__cns11643l1_from_ucs4_tab6): Extend
	upto index 0x0052.

2000-09-03  Bruno Haible  <haible@clisp.cons.org>

	* iconv/gconv_db.c (find_derivation): Always use the least-cost
	solution.

2000-09-03  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/big5.c (BODY for FROM_LOOP): Bytes 0x81..0xA0, 0xFA..0xFF
	are invalid.

2000-09-03  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/jis0208.c (__jis0208_to_ucs): Map EUC-JP 0xA1C0 to U+005C.
	* iconvdata/jis0212.c (__jisx0212_to_ucs): Map EUC-JP 0x8FA2B7 to
	U+007E.

2000-09-03  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/sjis.c (cjk_block1): Map 0x815F to U+005C.

2000-09-03  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/iso_6937-2.c (to_ucs4): Map 0xB4 to U+00D7.

2000-09-03  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/tst-tables.sh: New file.
	* iconvdata/tst-table.sh: New file.
	* iconvdata/tst-table-from.c: New file.
	* iconvdata/tst-table-to.c: New file.
	* iconvdata/tst-table-charmap.sh: New file.
	* iconvdata/Makefile (test-srcs): Set to tst-table-from tst-table-to.
	(distribute): Add tst-tables.sh, tst-table.sh, tst-table-charmap.sh,
	tst-table-from.c, tst-table-to.c, EUC-JP.irreversible,
	ISIRI-3342.irreversible, SJIS.irreversible.
	(tests): Add dependency on tst-tables.out.
	(tst-tables.out, tst-tables-clean): New rules.
	(do-tests-clean, common-mostlyclean): Require tst-tables-clean.
	* iconvdata/ISIRI-3342.irreversible: New file.
	* iconvdata/EUC-JP.irreversible: New file.
	* iconvdata/SJIS.irreversible: New file.

2000-09-04  Ulrich Drepper  <drepper@redhat.com>

	* manual/locale.texi (General Numeric): Update description of
	representation of the grouping information in the locale data.
	Patch by Gaute B. Strokkenes <gs234@cam.ac.uk>.

2000-09-04  Andreas Jaeger  <aj@suse.de>

	* locale/programs/ld-monetary.c (monetary_read): Fix typo.
	* iconv/iconv_prog.c (options): Fix typo.
	Reported by dyky@kondara.org, closes PR libc/1885.

2000-09-04  Andreas Jaeger  <aj@suse.de>

	* sysdeps/generic/fegetenv.c: It's __fegetenv.
	Reported by Rob Levin <lilo@transvirtual.com>.

2000-09-03  Ulrich Drepper  <drepper@redhat.com>

	* time/sys/time.h (gettimeofday): Move restrict for tz parameter
	to the typedefs of __timezone_ptr_t.
	Reported by MATSUMURA Hiromitsu <coji2@mb.infoweb.ne.jp>.

2000-09-02  Jakub Jelinek  <jakub@redhat.com>

	* nss/nss_files/files-hosts.c (HOST_DB_LOOKUP): Increment counter in
	the loop.

2000-09-01  H.J. Lu  <hjl@gnu.org>

	* Makeconfig (built-program-cmd): Don't use the dynamic linker
	to run a binary if it is in $(tests-static).

	* Rules (binaries-static): Add $(tests-static).

2000-09-02  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/mips/bits/fcntl.h: Fixes for fcntl64.

	* libio/fmemopen.c (fmemopen_close): Revert one part of last
	patch.

2000-09-01  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/big5hkscs.c: Regenerated from charmap.
	* iconvdata/testdata/BIG5HKSCS: Regenerated.
	* iconvdata/testdata/BIG5HKSCS..UTF8: Regenerated.

	* libio/fmemopen.c (fmemopen_seek): Add default case in switch
	statement.  General cleanup.

2000-08-31  Bruno Haible  <haible@clisp.cons.org>

	* wctype/wcfuncs.c (iswblank): New function.
	* wctype/wcfuncs_l.c (__iswblank_l): New function.
	* wctype/wcextra.c: Remove file.
	* wctype/wcextra_l.c: Remove file.
	* wctype/Makefile (distribute): Remove wcextra and wcextra_l.

2000-08-31  Bruno Haible  <haible@clisp.cons.org>

	* locale/programs/ld-collate.c (collate_output): Remove redundant
	assert call.
	* string/strcoll.c: Likewise.
	* string/strxfrm.c: Include assert.h.  Add assert calls like in
	string/strcoll.c.

2000-08-31  Bruno Haible  <haible@clisp.cons.org>

	* locale/categories.def (_NL_COLLATE_HASH_SIZE,
	_NL_COLLATE_HASH_LAYERS, _NL_COLLATE_NAMES, _NL_CTYPE_NAMES,
	_NL_CTYPE_HASH_SIZE, _NL_CTYPE_HASH_LAYERS): Remove definitions.
	* locale/langinfo.h (_NL_COLLATE_HASH_SIZE, _NL_COLLATE_HASH_LAYERS,
	_NL_COLLATE_NAMES): Rename to _NL_COLLATE_GAP1/2/3 respectively.
	(_NL_CTYPE_NAMES): Rename to _NL_CTYPE_GAP3.
	(_NL_CTYPE_GAP3): Rename to _NL_CTYPE_GAP4.
	(_NL_CTYPE_HASH_SIZE, _NL_CTYPE_HASH_LAYERS): Rename to
	_NL_CTYPE_GAP5/6 respectively.

	* locale/C-ctype.c (_nl_C_LC_CTYPE): Update.
	* ctype/ctype-info.c (__ctype_names, __ctype_width): Remove variables.
	* locale/lc-ctype.c (_nl_postload_ctype): Assume new locale format.
	Don't initialize __ctype_names and __ctype_width.
	* wctype/cname-lookup.h: Remove file.
	* wctype/Makefile (distribute): Remove cname-lookup.h.
	* wctype/wchar-lookup.h: Include stdint.h.
	* wctype/wctype.c (__wctype): Assume new locale format.
	* wctype/wctype_l.c (__wctype_l): Likewise.
	* wctype/iswctype.c: Don't include cname-lookup.h.
	(__iswctype): Assume new locale format.
	* wctype/iswctype_l.c: Don't include cname-lookup.h.
	(__iswctype_l): Assume new locale format.
	* wctype/wctrans.c: Don't include ctype.h.
	(wctrans): Assume new locale format.
	* wctype/wctrans_l.c (__wctrans_l): Likewise.
	* wctype/towctrans.c: Don't include cname-lookup.h.
	(__towctrans): Assume new locale format.
	* wctype/towctrans_l.c: Don't include cname-lookup.h.
	(__towctrans_l): Assume new locale format.
	* wctype/wcfuncs.c: Don't include ctype.h and cname-lookup.h. Include
	localeinfo.h instead.
	(__NO_WCTYPE): Remove unused macro.
	(__ctype32_b, __ctype32_toupper, __ctype32_tolower): Remove
	declarations.
	(iswalnum, iswalpha, iswcntrl, iswdigit, iswlower, iswgraph, iswprint,
	iswpunct, iswspace, iswupper, iswxdigit): Assume new locale format.
	(towlower, towupper): Likewise.
	* wctype/wcfuncs_l.c: Don't include cname-lookup.h. Include
	localeinfo.h instead.
	(__NO_WCTYPE): Remove unused macro.
	(__iswalnum_l, __iswalpha_l, __iswcntrl_l, __iswdigit_l, __iswlower_l,
	__iswgraph_l, __iswprint_l, __iswpunct_l, __iswspace_l, __iswupper_l,
	__iswxdigit_l): Assume new locale format.
	(__towlower_l, __towupper_l): Likewise.
	* wcsmbs/wcwidth.h: Don't include cname-lookup.h.
	(__ctype32_b): Remove declaration.
	(internal_wcwidth): Assume new locale format.
	* locale/programs/ld-ctype.c (struct locale_ctype_t): Remove fields
	plane_size, plane_cnt, names, width. Rename map to map_b, rename map32
	to map32_b, rename width_3level to width.
	(ctype_output): Always create new locale format. Don't emit
	_NL_CTYPE_NAMES, _NL_CTYPE_HASH_SIZE, _NL_CTYPE_HASH_LAYERS any more.
	(allocate_arrays): Always create new locale format.

	* locale/C-collate.c (_nl_C_LC_COLLATE): Update.
	* locale/weightwc.h (findidx): Assume new locale format.
	* string/strcoll.c (wcscoll): Remove local variables size, layers,
	names.
	* string/strxfrm.c (wcsxfrm): Likewise.
	* posix/fnmatch_loop.c (internal_fnwmatch): Likewise. Change type of
	local variable collseq to 'const char *'.
	(SUFFIX): Don't use, don't undefine.
	* posix/fnmatch.c: Remove SUFFIX definition.
	* locale/programs/ld-collate.c (struct locale_collate_t): Remove
	fields plane_size, plane_cnt, wcheads, wcseqorder. Rename
	wcheads_3level to wcheads, rename wcseqorder_3level to wcseqorder.
	(collate_finish): Always create new locale format. Remove local
	variables min_total, act_size.
	(collate_output): Always create new locale format. Remove local
	variables table_size, names, tablewc. Rename tablewc_3level to
	tablewc.

2000-08-31  Bruno Haible  <haible@clisp.cons.org>

	* locale/programs/ld-collate.c (obstack_int32_grow,
	obstack_int32_grow_fast): New inline functions.
	(output_weightwc, collate_output): Use them where possible.

2000-09-01  Ulrich Drepper  <drepper@redhat.com>

	* libio/libio.h (_IO_flockfile, _IO_funlockfile): Fix typo in last
	patch (_mode -> _flags).

	* libio/Makefile (headers): Add stdio_ext.h.
	(routines): Add __fbufsize, __freading, __fwriting, __freadable,
	__fwritable, __flbf, __fpurge, __fpending, and __fsetlocking.
	* libio/Versions [libc] (GLIBC_2.2): Add __fbufsize, __freading,
	__fwriting, __freadable, __fwritable, __flbf, __fpurge, __fpending,
	__fsetlocking, and _flushlbf.
	* libio/__fbufsize.c: New file.
	* libio/__flbf.c: New file.
	* libio/__fpending.c: New file.
	* libio/__fpurge.c: New file.
	* libio/__freadable.c: New file.
	* libio/__freading.c: New file.
	* libio/__fsetlocking.c: New file.
	* libio/__fwritable.c: New file.
	* libio/__fwriting.c: New file.
	* libio/stdio_ext.h: New file.
	* libio/genops.c (_IO_flush_all_linebuffered): Add alias _flushlbf.
	* libio/libio.h (_IO_USER_LOCK): Define.
	[_IO_MTSAFE_IO] (_IO_flockfile, _IO_funlockfile): Add macros which
	test _IO_USER_LOCK flag first.

	* iconv/gconv_open.c (__gconv_open): Set res to __GCONV_NOMEM is
	malloc fails.

2000-09-01  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/bits/fcntl.h: Always fail.

	* sysdeps/unix/sysv/linux/powerpc/bits/fcntl.h: New file.

2000-08-31  Ulrich Drepper  <drepper@redhat.com>

	* math/Makefile (tests): Add tst-defintions.
	* math/tst-definitions.c: New file.

	* stdlib/Makefile (headers): Add bits/wchar.h.
	* sysdeps/unix/sysv/linux/i386/bits/wchar.h: New file.
	* sysdeps/generic/bits/wchar.h: New file.
	* sysdeps/generic/stdint.h: Include <bits/wchar.h>.  Use values in this
	file to define WCHAR_MIN and WCHAR_MAX.
	Change UINT*8_MAX and UIN*16_MAX value to type int.
	* wcsmbs/wchar.h: Include <bits/wchar.h>.  Use values in this
	file to define WCHAR_MIN and WCHAR_MAX.
	* sysdeps/alpha/fpu/bits/mathdef.h: Make FP_ILOGB0 and FP_ILOGBNAN
	int values.
	* sysdeps/arm/fpu/bits/mathdef.h: Likewise.
	* sysdeps/generic/bits/mathdef.h: Likewise.
	* sysdeps/i386/fpu/bits/mathdef.h: Likewise.
	* sysdeps/m68k/fpu/bits/mathdef.h: Likewise.
	* sysdeps/powerpc/fpu/bits/mathdef.h: Likewise.
	* sysdeps/sparc/fpu/bits/mathdef.h: Likewise.
	* locale/locale.h (struct lconv): Add __ prefix to the new members
	if not C99.
	* sysdeps/generic/inttypes.h: Remove unnecessary imaxabs and
	imaxdiv optimizations.
	* sysdeps/wordsize-32/lldiv.c: Add hack to make alias work.
	* sysdeps/wordsize-64/ldiv.c: Likewise.
	* sysdeps/alpha/fpu/bits/fenv.h: Change type of FE_*_ENV macros to
	const fenv_t*.
	* sysdeps/generic/bits/fenv.h: Likewise.
	* sysdeps/i386/fpu/bits/fenv.h: Likewise.
	* sysdeps/ia64/bits/fenv.h: Likewise.
	* sysdeps/m68k/fpu/bits/fenv.h: Likewise.
	* sysdeps/mips/bits/fenv.h: Likewise.
	* sysdeps/s390/fpu/bits/fenv.h: Likewise.
	* sysdeps/sparc/fpu/bits/fenv.h: Likewise.
	Reported by Joseph S. Myers <jsm28@cam.ac.uk>.

	* inet/rcmd.c: Use *stat64 instead of *stat internally.
	* inet/ruserpass.c: Likewise.
	* catgets/open_catalog.c: Likewise.
	* intl/loadmsgcat.c: Likewise.
	* io/getdirname.c: Likewise.
	* locale/loadlocale.c: Likewise.
	* misc/getusershell.c: Likewise.
	* stdlib/canonicalize.c: Likewise.
	* sysdeps/posix/euidaccess.c: Likewise.
	* sysdeps/posix/isfdtype.c: Likewise.
	* sysdeps/posix/posix_fallocate.c: Likewise.
	* sysdeps/posix/tempname.c: Likewise.
	* sysdeps/unix/grantpt.c: Likewise.
	* sysdeps/unix/opendir.c: Likewise.
	* sysdeps/unix/sysv/linux/fstatvfs.c: Likewise.
	* sysdeps/unix/sysv/linux/internal_statvfs.c: Likewise.
	* sysdeps/unix/sysv/linux/ptsname.c: Likewise.
	* sysdeps/unix/sysv/linux/statvfs.c: Likewise.
	* sysdeps/unix/sysv/linux/ttyname.c: Likewise.
	* sysdeps/unix/sysv/linux/ttyname_r.c: Likewise.
	* sysvipc/ftok.c: Likewise.
	* time/getdate.c: Likewise.

	* time/getdate.c: Add extra access test.

2000-08-31  Ulrich Drepper  <drepper@redhat.com>

	* version.h (VERSION): Bump to 2.1.93.

	* sysdeps/unix/sysv/linux/powerpc/Dist: Add fe_nomask.c.
	* sysdeps/unix/sysv/linux/i386/Dist: Add olddirent.h.

	* intl/Makefile (tests): Depend in mtrace-tst-gettext.
	Make this a new rule depending on tst-gettext.out and run mtrace.
	* intl/tst-gettext.c: Call mtrace.
	* intl/tst-gettext.sh: Put MALLOC_TRACE in environment of tst-gettext.

	* elf/dl-reloc.c: Add a few more __builtin_expect.

	* configure.in: Remove --with-gettext option.

	* intl/dcigettext.c (free_mem): Correct freeing of
	_nl_domain_bindings list.

	* sysdeps/generic/setenv.c (free_mem): New function.  Free all
	allocated memory.

	* intl/locale.alias: Add aliases for bokmal and nynorsk.

	* locale/iso-639.def: Fix 639-1 code for Bokmal.

	* stdio-common/itoa-digits.c: Move upper digits to...
	* stdio-common/itoa-udigits.c: ...here.  New file.
	* stdio-common/Makefile (routines): Add itoa-udigits.

	* sysdeps/i386/dl-machine.h (elf_machine_rel): For the version to
	relocate ld.so don't add supprt for relocations which should not
	appear in ld.so.

	* malloc/malloc.c (ptmalloc_init): Optimize a bit by not calling
	__secure_getenv.  Instead test __libc_enable_secure once.

	* io/pwd.c (main): Provide a good example, use *_unlocked function.

2000-08-30  Ulrich Drepper  <drepper@redhat.com>

	* iconv/gconv_conf.c (insert_module): Take extra parameter to decide
	whether the new record should be freed if it's a duplicate.
	(add_module): Adjust insert_module call.
	(__gconv_read_conf): Likewise.
	* iconvdata/Makefile (generated): Add tst-loading.mtrace and
	mtrace-tst-loading.
	(tests): Make $(objpfx)mtrace-tst-loading a dependency.  Add rule.

	* sysdeps/generic/ldsodefs.h: Add declaration for _dl_all_dirs and
	_dl_all_init_dirs.
	* include/link.h (struct r_search_path_struct): New.
	(struct link_map): Use it for l_rpath_dirs and l_runpath_dirs.
	* elf/Versions [ld] (GLIBC_2.2): Add _dl_all_dirs and
	_dl_all_init_dirs.
	* elf/dl-close.c (_dl_close): Free l_rpath_dirs and l_runpath_dirs.
	* elf/dl-libc.c (free_mem): Free _dl_all_dirs list except elements
	added at startup time.
	* elf/dl-load.c: Fix memory handling.  r_search_path_struct
	contains element to remember fact that we can free memory.
	(all_dirs): Renamed to _dl_all_dirs.  Made global.
	(_dl_init_all_dirs): New variable.
	(fillin_rpath): Save one malloc call.
	(decompose_rpath): Change interface.  New first parameter points to
	r_search_path_struct.
	(_dl_init_paths): Adjust for changes.  Mark all memory as not
	deletable.  Set _dl_init_all_paths value.
	(open_path): Remove may_free_dirs parameter.  r_search_path_elem ***
	parameter replaced with r_search_path_struct *.  Information about
	freeing now contained in r_search_path_struct.
	(_dl_map_object): Adjust for above changes.

	* elf/dl-open.c (dl_open_worker): Change format of debug info a bit.

	* elf/dl-load.c (fillin_rpath): Only check for trusted directories
	when adding new entries.

	* elf/dl-load.c (fillin_rpath): Make local copy of where string
	since the object being loaded can be unloaded.

	* iconvdata/Makefile (tests): Add tst-loading.
	* iconvdata/tst-loading.c: New file.

2000-08-29  Bruno Haible  <haible@clisp.cons.org>

	* stdio-common/vfscanf.c (_IO_vfscanf): Back out last ungetc change.
	When comparing a char with an int, always cast the char to
	'unsigned char'. New macro ungetc_not_eof, to avoid warnings when
	compiling with -funsigned-char.	Use UCHAR_MAX+1 instead of UCHAR_MAX.

2000-08-30  Ulrich Drepper  <drepper@redhat.com>

	* time/strftime.c (my_strftime): Add compatibility code for use
	outside glibc.  Patch by Jim Meyering <meyering@ascend.com>.

	* sysdeps/posix/getaddrinfo.c (gaih_local): uname does not everywhere
	return 0 for success but always < 0 on failure.

	* nss/getXXbyYY_r.c: Define result to *result before including
	digits_dots.c.

2000-08-30  Andreas Jaeger  <aj@suse.de>

	* math/gen-libm-test.pl (parse_ulps): Remove extra \.

2000-08-29  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/big5hkscs.c: Rewritten.  Regenerate data from the
	official file.
	* iconvdata/TESTS: Add BIG5HKSCS entry.
	* iconvdata/testdata/BIG5HKSCS: New file.
	* iconvdata/testdata/BIG5HKSCS..UTF8: New file.

	* iconvdata/big5.c (BODY for FROM_LOOP): Remove condition which is
	always true.

	* libio/iogetline.c: Set mode before the loop in case n==0.
	* libio/iogetwline.c: Likewise.

2000-08-29  H.J. Lu  <hjl@gnu.org>

	* libio/fileops.c (new_do_write): Check fp->_mode <= 0 instead
	of fp->_mode < 0.
	(_IO_new_file_overflow): Likewise.
	* libio/genops.c (_IO_flush_all): Likewise.
	* libio/ioftell.c (_IO_ftell): Likewise.

2000-08-29  Akira Higuchi  <a@kondara.org>

	* iconv/gconv_db.c (increment_counter): Reset __init_fct, __fct,
	and __end_fct fields of struct __gconv_step.
	* iconv/Makefile (tests): Add iconv-bug2.
	* iconv/iconv-bug2.c: New file.

	* iconvdata/euc-kr.c (BODY for FROM_LOOP): Pass 'inend - inptr'
	instead of 'inptr - inend' to ksc5601_to_ucs4.

	* iconvdata/sjis.c (BODY for FROM_LOOP): Allow 0x7f character.

	* iconvdata/iso-2022-cn.c (BODY for FROM_LOOP): If an incomplete
	character or shift sequence is found at the end of the input
	string, return__GCONV_INCOMPLETE_INPUT instead of
	__GCONV_EMPTY_INPUT.
	* iconvdata/iso-2022-jp.c (BODY for FROM_LOOP): Likewise.
	* iconvdata/iso-2022-kr.c (BODY for FROM_LOOP): Likewise.

	* iconvdata/iso-2022-jp.c (BODY for FROM_LOOP): Return
	__GCONV_ILLEGAL_INPUT for 8bit characters.

2000-08-29  Ulrich Drepper  <drepper@redhat.com>

	* signal/signal.h (sigpause): Move __THROW before __asm__.

	* inet/rcmd.c (__checkhost_sa): If getnameinfo succeeds but the
	names don't match don't return.
	Patch by Olaf Kirch <okir@flash.lst.de>.

2000-08-28  Ulrich Drepper  <drepper@redhat.com>

	* time/strftime.c (my_strftime): Handle # flag for %b as well.

2000-08-27  H.J. Lu  <hjl@gnu.org>

	* posix/Makefile (otherlibs): Add for building with static-nss
	for "make check".

2000-08-28  Ulrich Drepper  <drepper@redhat.com>

	* libio/stdio.h: Add fmemopen prototype.

2000-08-25  Andreas Jaeger  <aj@suse.de>

	* libio/Makefile (routines): Add fmemopen.
	(tests): Add test-fmemopen.
	* libio/Versions: Add fmemopen with version GLIBC_2.2.
	* libio/test-fmemopen.c: New file.
	* libio/fmemopen.c: New file.
	Patches by Hanno Mueller <kontakt@hanno.de>.

2000-08-28  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/ia64/bits/sigstack.h: Prevent double
	inclusion.  Patch by Jes Sorensen <jes@linuxcare.com>.

	* locale/localeinfo.h (LIMAGIC): Change base number to 0x20000828
	to avoid crashing statically linked applications.

2000-08-27  Bruno Haible  <haible@clisp.cons.org>

	* string/strxfrm.c (strxfrm, wcsxfrm): Include <sys/param.h>.
	If nrules == 0 and srclen < n, copy only srclen + 1 characters.

	* sysdeps/generic/getdomain.c (getdomainname): Include <sys/param.h>.
	If the result is fits in the buffer, copy only as many bytes as needed.

	* sysdeps/generic/_strerror.c (__strerror_r): Don't zero-fill the
	buffer after copying numbuf into it.
	* sysdeps/mach/_strerror.c (__strerror_r): Likewise.

2000-08-27  Bruno Haible  <haible@clisp.cons.org>

	* posix/confstr.c (confstr): When string_len > len, NUL-terminate
	the result.  When string_len < len, don't clear the rest of the buffer.

2000-08-27  Bruno Haible  <haible@clisp.cons.org>

	Support for new LC_COLLATE format.
	* locale/coll-lookup.h: New file.
	* locale/weightwc.h (findidx): When size == 0, call
	collidx_table_lookup.
	* wcsmbs/wcscoll.c: Include coll-lookup.h.
	* wcsmbs/wcsxfrm.c: Likewise.
	* posix/fnmatch.c: Likewise.
	* posix/fnmatch_loop.c (internal_fnwmatch): When size == 0, call
	collseq_table_lookup.
	* locale/programs/3level.h: New file.
	* locale/programs/ld-ctype.c: (wcwidth_table, wctrans_table): Define
	by including "3level.h".
	* locale/programs/ld-collate.c (wchead_table, collidx_table,
	collseq_table): New types, defined by including "3level.h".
	(locale_collate_t): New wcheads_3level, wcseqorder_3level fields.
	(encoding_mask, encoding_byte): Remove.
	(utf8_encode): Use simple shifts instead.
	(collate_finish): When !oldstyle_tables, set plane_size and plane_cnt
	to 0, and initialize and fill wcheads_3level and wcseqorder_3level.
	(collate_output): New local variable tablewc_3level. When
	!oldstyle_tables, set table_size to 0 and names to NULL and fill
	tablewc_3level instead of tablewc. Change format of TABLEWC and
	COLLSEQWC entries written to the file.
	* locale/C-collate.c (collseqwc): Change format.
	(_nl_C_LC_COLLATE): Set HASH_SIZE and HASH_LAYERS to 0, change format
	of COLLSEQWC.
	* locale/Makefile (distribute): Add coll-lookup.h, programs/3level.h.

2000-08-27  Bruno Haible  <haible@clisp.cons.org>

	* locale/programs/ld-ctype.c (MAX_CHARNAMES_IDX): New macro.
	(locale_ctype_t): New charnames_idx field.
	(ctype_startup): Initialize charnames_idx field.
	(find_idx): Speed up dramatically by using charnames_idx inverse table.

2000-08-27  Bruno Haible  <haible@clisp.cons.org>

	* locale/C-ctype.c: Switch to new locale format.
	(_nl_C_LC_CTYPE_names): Remove array.
	(STRUCT_CTYPE_CLASS): New macro.
	(_nl_C_LC_CTYPE_class_{upper,lower,alpha,digit,xdigit,space,print,
	graph,blank,cntrl,punct,alnum}, _nl_C_LC_CTYPE_map_{toupper,tolower}):
	New three-level tables.
	(_nl_C_LC_CTYPE_width): Change from array to three-level table.
	(_nl_C_LC_CTYPE): Fix nstrings value. Set HASH_SIZE and HASH_LAYERS
	to 0. Change WIDTH format. Set CLASS_OFFSET and MAP_OFFSET. Add
	12 class tables and 2 map tables at the end.
	* ctype/ctype-info.c (_nl_C_LC_CTYPE_names): Remove declaration.
	(_nl_C_LC_CTYPE_class_{upper,lower,alpha,digit,xdigit,space,print,
	graph,blank,cntrl,punct,alnum}, _nl_C_LC_CTYPE_map_{toupper,tolower}):
	New declarations.
	(b): Remove trailing semicolon.
	(__ctype_names, __ctype_width): Don't initialize.
	(__ctype32_wctype, __ctype32_wctrans, __ctype32_width): Initialize.

2000-08-27  Bruno Haible  <haible@clisp.cons.org>

	* elf/dl-load.c (open_path): Add a argument telling whether *dirsp
	is guaranteed to be allocated with the same malloc() and may be
	passed to free().
	(_dl_map_object): Update open_path calls. If rtld_search_dirs has
	been set to empty by an earlier open_path call, don't pass it again.

2000-08-28  Ulrich Drepper  <drepper@redhat.com>

	* include/libintl.h: Include <locale.h> since libintl.h doesn't if
	we are not optimizing.

	* sysdeps/unix/sysv/linux/powerpc/sysdep.h: Protect against double
	inclusion.

	* stdio-common/vfscanf.c (ungetc): Cast c to signed char first to
	really match EOF.
	Patch by Franz Sirl <Franz.Sirl-kernel@lauterbach.com>.

2000-08-28  Andreas Jaeger  <aj@suse.de>

	* sysdeps/i386/fpu/libm-test-ulps: Tweaks for AMD Athlon.

2000-08-28  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/mach/hurd/getpeername.c (__getpeername): Renamed from
	getpeername.  Use ISO C style function definition.
	(getpeername): Provide weak alias.
	* sysdeps/mach/hurd/setrlimit.c (__setrlimit): Renamed from
	setrlimit.  Use ISO C style function definition.
	(setrlimit): Provide weak alias.

2000-08-28  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* shlib-versions: Add a rule for S/390 to the libm version list.
	* sysdeps/s390/Versions: New file.
	* sysdeps/unix/sysv/linux/s390/Dist: Add oldgetrlimit64.c.
	* sysdeps/unix/sysv/linux/s390/Makefile: Add oldgetrlimit64.
	* sysdeps/unix/sysv/linux/s390/Versions: New file.
	* sysdeps/unix/sysv/linux/s390/alphasort64.c: New file.
	* sysdeps/unix/sysv/linux/s390/chown.c: New file.
	* sysdeps/unix/sysv/linux/s390/fxstat.c: New file.
	* sysdeps/unix/sysv/linux/s390/getdents64.c: New file.
	* sysdeps/unix/sysv/linux/s390/getrlimit.c: New file.
	* sysdeps/unix/sysv/linux/s390/getrlimit64.c: New file.
	* sysdeps/unix/sysv/linux/s390/lxstat.c: New file.
	* sysdeps/unix/sysv/linux/s390/oldgetrlimit64.c: New file.
	* sysdeps/unix/sysv/linux/s390/readdir64.c: New file.
	* sysdeps/unix/sysv/linux/s390/readdir64_r.c: New file.
	* sysdeps/unix/sysv/linux/s390/scandir64.c: New file.
	* sysdeps/unix/sysv/linux/s390/setrlimit.c: New file.
	* sysdeps/unix/sysv/linux/s390/syscalls.list: New file.
	* sysdeps/unix/sysv/linux/s390/versionsort64.c: New file.
	* sysdeps/unix/sysv/linux/s390/xstat.c: New file.

2000-08-28  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/Makefile [$(subdir)==csu]
	(CFLAGS-initfini.s): Add -DWEAK_GMON_START.

	* elf/Versions [ld] (GLIBC_2.2): Export _dl_debug_files.
	* elf/dl-close.c (_dl_close): Print debug message if object is not
	unloaded.
	* elf/dl-open.c (dl_open_worked): Print message about opencount before
	returning to caller.

	* po/zh.po: Renamed to...
	* po/zh_TW.po: ...this.

2000-08-27  Geoff Keating  <geoffk@cygnus.com>

	* sysdeps/powerpc/fpu/feenablxcpt.c: Correct bogus checkin.

	* sysdeps/powerpc/fpu/fedisblxcpt.c: New file.
	* sysdeps/powerpc/fpu/feenablxcpt.c: New file.
	* sysdeps/powerpc/fpu/fegetexcept.c: New file.
	* sysdeps/unix/sysv/linux/powerpc/fe_nomask.c: New file.

2000-08-27  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/ld-collate.c (insert_weights): Also update
	backpointer of next element.
	(collate_read): Allow definition of new collation symbols in stage 2.
	Symbol after reorder-after can be UCS4 value.
	Allow reordering of collation symbols and elements.
	Do not only move reorder entry in new position.  Instead call
	insert_weight to do this and read the weights.

	* locale/findlocale.c (free_mem): Add cast to avoid warning.

	* intl/dcigettext.c (DCIGETTEXT): Remove _nl_find_language in code
	to determine invalid locale name.
	* locale/findlocale.c (_nl_find_locale): Likewise.

	* posix/annexc.c: Correct test for unavailable feature.

	* sysdeps/unix/sysv/linux/i386/sys/io.h (outw): Fix __INLINE ->
	__inline.

2000-08-26  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/syscalls.list: Add getdents64
	syscall.

	* sysdeps/unix/sysv/linux/arm/Makefile [$(subdir)==resource]
	(sysdep_routines): Add oldgetrlimit64.

	* elf/Makefile (distribute): Add unloadmod.c, reldepmod1.c,
	reldepmod2.c, reldepmod3.c, and reldepmod4.c.
	(tests): Add unload, reldep, reldep2, and reldep3.
	(modules-names): Add unloadmod, reldepmod1, reldepmod2, reldepmod3,
	and reldepmod4.
	Add rules to build and run unload, reldep, reldep2, and reldep3.
	* elf/dl-lookup.c (_dl_lookup_symbol): Add new parameter explicit.
	Don't create relocation dependency if it is nonzero.
	(_dl_lookup_symbol_skip): Remove relocation dependency stuff.  This
	can never happen here.
	(_dl_lookup_versioned_symbol): Add new parameter explicit.
	Don't create relocation dependency if it is nonzero.
	(_dl_lookup_versioned_symbol_skip): Remove relocation dependency
	stuff.  This can never happen here.
	* sysdeps/generic/ldsodefs.h: Change prototypes.
	* elf/dl-reloc.c (RESOLVE_MAP): Pass 0 in explicit parameter to
	_dl_lookup_up and _dl_lookup_versioned_symbol.
	(RESOLV): Likewise.
	* elf/dl-runtime.c (fixup): Likewise.
	(profile_fixup): Likewise.
	* elf/dl-libc.c (do_dlsym): Pass 1 in explicit parameter to
	_dl_lookup_symbol.
	* elf/dl-symbol.c (_dl_symbol_value): Likewise.
	* elf/rtld.c (dl_main): Likewise.
	* elf/dl-sym.c (_dl_sym): Pass 1 in explicit parameter to
	_dl_lookup_symbol if handle is not RTLD_DEFAULT.  Always compute
	and pass down the caller map.
	(_dl_vsym): Likewise.
	* elf/reldep.c: New file.
	* elf/reldep2.c: New file.
	* elf/reldep3.c: New file.
	* elf/reldepmod1.c: New file.
	* elf/reldepmod2.c: New file.
	* elf/reldepmod3.c: New file.
	* elf/reldepmod4.c: New file.
	* elf/unload.c: New file.
	* elf/unloadmod.c: New file.

	* elf/do-lookup.h: Remove unused undef_name parameter.
	* elf/dl-lookup.c: Adjust callers.

2000-08-25  Ulrich Drepper  <drepper@redhat.com>

	* iconv/gconv_trans.c (__gconv_transliterate): Pass NULL instead of
	irreversible in recursive call of conversion function to signal that
	no error handling is wanted.
	* iconv/loop.c (ignore_errors_p): irreversible must be != NULL, too.
	(STANDARD_ERR_HANDLER): Don't do anything if irreversible == NULL.
	* iconv/skeleton.c (lirreversiblep): New variable.  Set to NULL is
	recursive error handling call, otherwise to &lirreversible.  Use it
	for calls to conversion functions.
	* iconv/gconv_simple.c (ucs4_internal_loop): Don't handle errors when
	transliterating.
	(ucs4_internal_loop_unaligned): Likewise.
	(ucs4le_internal_loop): Likewise.
	(ucs4le_internal_loop_unaligned): Likewise.

2000-08-25  Greg McGary  <greg@mcgary.org>

	* sysdeps/i386/memchr.S: Check high bound against chars
	actually scanned.
	* sysdeps/i386/memcmp.S: Likewise.
	* sysdeps/i386/stpncpy.S: Adjust high-bound check to
	account for pointers that lie one beyond end-of-buffer.

2000-08-25  Ulrich Drepper  <drepper@redhat.com>

	* elf/Makefile (LDFLAGS-nodelete): Add -rdynamic.
	* elf/nodelete.c (fini_ran): New global variable.
	(do_test): Before every dlclose call clear fini_ran and test
	afterwards that it is not set by the destructors.
	* elf/nodelmod1.c: Add destructor which sets fini_ran.
	* elf/nodelmod2.c: Likewise.
	* elf/nodelmod4.c: Likewise.

2000-08-21  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/unix/sysv/linux/ia64/syscalls.list: Add getrlimit and
	getrlimit to the list.

2000-08-18  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/ia64/Implies: gcc now has support for the Intel 80 bit
	long double format so use ldbl-96 instead of ldbl-128.

2000-08-25  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/mmap.S (__mmap): Return -EINVAL
	even if bits 10 a 11 are non-zero.
	* sysdeps/unix/sysv/linux/i386/mmap64.S (__mmap64): Likewise.

	* Makeconfig: Ensures the soversions.mk part of Makefile gets
	included before building gnu/lib-names.h
	Patch by Maciej W. Rozycki <macro@ds2.pg.gda.pl>.

	* elf/dl-close.c (_dl_close): Don't run destructors of objects
	marked DF_1_NODELETE.

	* sysdeps/posix/system.c (__libc_system): We cannot use vfork here
	since we call sigaction in the child.

2000-08-25  Andreas Jaeger  <aj@suse.de>

	* iconvdata/Makefile ($(objpfx)bug-iconv1.out): Depend on
	gconv-modules.

2000-08-25  Andreas Jaeger  <aj@suse.de>

	* manual/arith.texi (Control Functions): Clarify possible
	arguments.  Closes PR libc/1856.

2000-08-24  H.J. Lu  <hjl@gnu.org>

	* stdio-common/Makefile (tests): Don't do it for cross compiling.
	* malloc/Makefile (tests): Likewise.

2000-08-24  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/unicode.c (gconv_init): Correct test for direction.

2000-08-24  Andreas Jaeger  <aj@suse.de>

	* malloc/Makefile (extra-objs): Fix last patch, build memusagestat
	only if LIBGD is available.

2000-08-24  Ulrich Drepper  <drepper@redhat.com>

	* resolv/res_send.c (res_ourserver_p): Cleanup the type mess to avoid
	problems with now restrict parameter types.
	(convaddr4to6): Likewise.

2000-08-24  Denis Joseph Barrow  <djbarrow@de.ibm.com>

	* sysdeps/s390/fpu/fedisblxcpt.c: New file.
	* sysdeps/s390/fpu/feenablxcpt.c: New file.
	* sysdeps/s390/fpu/fegetexcept.c: New file.
	* sysdeps/s390/fpu/fenv_libc.h: Some reordering, new definition
	FPC_VALID_MASK.

2000-08-24  Andreas Jaeger  <aj@suse.de>

	* malloc/Makefile (extra-objs): Add memusagestat.o.
	(generated): Added memusage and memusagestat for make clean.

	* libio/tst_putwc.c (do_test): Delete temporary file.
	Move inclusion of test-skeleton to front to have prototype for
	add_temp_file.

	* posix/Makefile (generated): Add wordexp-tst.out.

2000-08-24  Ulrich Drepper  <drepper@redhat.com>

	* resolv/res_hconf.c (free_mem): Remove not needed if.

	* time/tzset.c (free_mem): New function.
	* string/strsignal.c (free_mem): New function.
	* inet/inet_ntoa.c (free_mem): New function.
	* sunrpc/clnt_perr.c (free_mem): New function.

2000-08-24  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/syscalls.list: Use __setrlimit as strong name.
	* sysdeps/unix/sysv/syscalls.list: Likewise.

	* posix/unistd.h: Move internal prototypes from here ...
	* include/unistd.h: ... to here.

	* sysvipc/sys/shm.h: Add const attribute to __getpagesize.

2000-08-24  Ulrich Drepper  <drepper@redhat.com>

	* grp/initgroups.c (initgroups): Deallocate groups array.
	Reported by jani.raiha@sonera.com [PR libc/1868].

	* sysdeps/s390/Dist: Add fpu/fenv_libc.h.
	* sysdeps/alpha/Dist: Likewise.

2000-08-23  Ulrich Drepper  <drepper@redhat.com>

	* crypt/md5-crypt.c (free_mem): Fix typo (constructor ->
	destructor).  Reported by Solar Designer <solar@false.com>.

	* iconv/gconv_conf.c (add_module): Remove some unneeded code to
	avoid adding double slashes.

2000-08-23  Jakub Jelinek  <jakub@redhat.com>

	* dirent/dirent.h (alphasort, versionsort): Move __attribute_pure__
	out of the __REDIRECT macro.

2000-08-23  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/vfscanf.c: Add %F format support.

	* locale/programs/ld-ctype.c (ctype_output): Make sure
	_NL_CTYPE_TRANSLIT_DEFAULT_MISSING_LEN and
	_NL_CTYPE_TRANSLIT_IGNORE_LEN are aligned.
	(ctype_read): Enable returning of wide character strings for reading
	transliteration information.

2000-08-23  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/i386/sys/io.h (_EXTERN_INLINE): Remove.
	Use static __inline instead of _EXTERN_INLINE.

	* misc/sys/select.h: Move prototypes of __select from here ...
	* include/sys/select.h: ... to here.

	* socket/sys/socket.h: Move prototypes of __send and __connect
	from here....
	* include/sys/socket.h: ... to here.

	* locale/programs/ld-ctype.c (ctype_read): Fix parameter for
	lr_error.

2000-08-23  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/sparc/sparc32/syscalls.list: Use
	__setrlimit as strong name. Takes only 2 arguments.

	* sysdeps/unix/sysv/linux/sh/syscalls.list: __syscall_setrlimit
	takes only 2 arguments.

2000-08-23  Martin Schwidefsky	<schwidefsky@de.ibm.com>

	* sysdeps/s390/__longjmp.c: Add __ to JB_GPR*.

	* sysdeps/s390/bits/setjmp.h: Add __ to JB_GPR* defines.

2000-08-23  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/ld-ctype.c (ctype_read): Allow more than one
	default_missing character being specified, pick the first
	representable.

2000-08-23  Andreas Jaeger  <aj@suse.de>

	* include/wchar.h: Add some pure attributes.

	* time/time.h: Add const attribute for dysize.

	* include/stdlib.h: Add malloc attribute to __posix memalign.

	* stdlib/stdlib.h: Add some pure and malloc attributes.
	* wcsmbs/wchar.h: Likewise.

	* dirent/dirent.h: Add some pure attributes.
	* include/dirent.h: Likewise.

2000-08-23  Jakub Jelinek  <jakub@redhat.com>

	* inet/netinet/in.h (struct in6_addr): Don't enforce 64bit alignment
	on 64bit arches.

2000-08-22  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/iso-2022-jp.c: In conversion to ISO-2022-JP, add two
	missing buffer size checks.

2000-08-23  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/alpha/syscalls.list: Use __setrlimit as
	strong name.
	* sysdeps/unix/sysv/linux/sparc/sparc64/syscalls.list: Likewise.

	* sysdeps/unix/sysv/linux/dl-osinfo.h: Include "kernel-features.h",
	otherwise __LINUX_KERNEL_VERSION might not be defined.
	(MIN): Define if not already defined.

2000-08-22  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/vfprintf.c: Handle %F format.
	* stdio-common/printf-parse.h (parse_one_spec): Likewise.
	Reported by Joseph S. Myers <jsm28@cam.ac.uk>.

	* stdio-common/tstdiomisc.c: Add test for %F printf format.

	* po/zh.po: New file.

	* iconvdata/sjis.c: In conversion from UCS4, correct test for
	enough room in target buffer.
	Patch by KUSANO Takayuki <AE5T-KSN@asahi-net.or.jp> [PR libc/1865].
	* iconvdata/bug-iconv1.c: New file.
	* iconvdata/Makefile (tests): Add bug-iconv1.

	* locale/iso-4217.def: Update entry for Nicaragua.

2000-08-22  Mark Kettenis  <kettenis@gnu.org>

	* hurd/hurdsig.c: Rearrange headers a bit.
	(_hurdsig_init): Block until _hurd_msgport_thread is initialized
	when cthreads is being used.

2000-08-22  Ulrich Drepper  <drepper@redhat.com>

	* elf/Makefile (distribute): Add dl-osinfo.h.
	* sysdeps/generic/dl-osinfo.h: New file.
	* sysdeps/unix/sysv/linux/dl-osinfo.h: New file.
	* sysdeps/generic/dl-sysdep.c (_dl_sysdep_start): Use DL_SYSDEP_OSCHECK
	if defined.
	* sysdeps/unix/sysv/linux/init-first.c: Perform kernel version test
	only for !SHARED case.	Get the code from dl-osinfo.h.

	* stdlib/random_r.c: Cleanups.
	* stdlib/tst-random.c: New file.
	* stdlib/Makefile (tests): Add tst-random.
	Patches by Michael Fischer <fischer-michael@cs.yale.edu>.

2000-08-21  Martin Schwidefsky	<schwidefsky@de.ibm.com>

	* sysdeps/unix/sysv/linux/s390/getmsg.c: Remove.
	* sysdeps/unix/sysv/linux/s390/getpmsg.c: Remove.
	* sysdeps/unix/sysv/linux/s390/putmsg.c: Remove.
	* sysdeps/unix/sysv/linux/s390/putpmsg.c: Remove.

2000-08-22  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/syscalls.list (sysctl): Remove.
	* sysdeps/unix/sysv/linux/ia64/syscalls.list (sysctl): Remove.
	(__syscall__sysctl): Add.

2000-08-21  Andreas Jaeger  <aj@suse.de>

	* stdlib/tst-strtol.c: Add test for 0xFFFFFFFFFFFF00FF (from PR
	libc/1864).
	* stdlib/tst-strtoll.c: Likewise.

2000-08-21  Ulrich Drepper  <drepper@redhat.com>

	* stdlib/random_r.c (__setstate_r): Also compute end_ptr
	correctly.
	(__initstate_r): Set errno on error.
	(__random_r): Likewise.
	(__setstate_r): Correct offset when computing
	new rptr and fptr.  Test for arg_state being NULL.
	Reported by Michael Fischer <fischer@cs.yale.edu>.

	* posix/regex.h: Add macro definitions to allow compiling outside
	glibc.

	* sysdeps/i370/Implies: Removed.
	* sysdeps/mvs/Implies: Removed.

	* catgets/catgets.c (catopen): Filter out env_var values with / if
	necessary.

	* locale/findlocale.c (_nl_find_locale): Move test for unusable
	locale name after all getenvs.

	* configure.in: Allow sed versions like 3.02.8.
	Patch by Rodrigo Barbosa <rodrigob@conectiva.com.br>.

2000-08-21  Marko Myllynen  <myllynen@lut.fi>

	* inet/netinet/icmp6.h: Add Mobile IPv6 extensions structures.

2000-08-21  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/posix/getaddrinfo.c (gethosts): Handle TRY_AGAIN error
	of gethostbyname2_r call.

	* intl/locale.alias: Add aliases for Korean.

2000-08-21  Martin Schwidefsky	<schwidefsky@de.ibm.com>

	* sysdeps/s390/__longjmp.c: Remove unused variable result.
	* sysdeps/s390/fpu/bits/fenv.h: Move FPC_* definitions to fenv_libc.h.
	* sysdeps/s390/fpu/fclrexcpt.c: Include fenv_libc.h instead of fenv.h.
	* sysdeps/s390/fpu/fegetenv.c: New file.
	* sysdeps/s390/fpu/fegetround.c: Include fenv_libc.h instead of fenv.h.
	* sysdeps/s390/fpu/feholdexcpt.c: New file.
	* sysdeps/s390/fpu/fenv_libc.h: New file.
	* sysdeps/s390/fpu/fesetenv.c: New file.
	* sysdeps/s390/fpu/fesetround.c: Include fenv_libc.h instead of fenv.h.
	* sysdeps/s390/fpu/feupdateenv.c: New file.
	* sysdeps/s390/fpu/fgetexcptflg.c: Reformatted.
	* sysdeps/s390/fpu/fpu_control.h: Corrected header.
	* sysdeps/s390/fpu/fraiseexcpt.c: New file.
	* sysdeps/s390/fpu/fsetexcptflg.c: New file.
	* sysdeps/s390/fpu/ftestexcept.c: New file.
	* sysdeps/s390/fpu/libm-test-ulps: New file.
	* sysdeps/s390/gmp-mparam.h: Add end of comment.
	* sysdeps/s390/initfini.c: New file.
	* sysdeps/unix/sysv/linux/s390/Dist: Add sys/procfs.h.
	* sysdeps/unix/sysv/linux/s390/Makefile: Remove sys/reg.h.
	* sysdeps/unix/sysv/linux/s390/bits/stat.h: New file.
	* sysdeps/unix/sysv/linux/s390/lchown.c: New file.
	* sysdeps/unix/sysv/linux/s390/sys/elf.h: Move elf definitions to
	sys/procfs.h as proposed by Mark Kettenis.
	* sysdeps/unix/sysv/linux/s390/sys/procfs.h: New file.

2000-08-21  Andreas Jaeger  <aj@suse.de>

	* include/poll.h: Include include/sys/poll.h to get __poll
	declaration.

	* io/sys/poll.h: Move __poll declaration from here...
	* include/sys/poll.h: ...to here.

	* include/sys/socket.h (__getpeername): Add declaration.

	* include/wchar.h (__vswprintf): Add declaration.

	* include/stdio.h (__flockfile): Add declaration.
	(__funlockfile): Likewise.

2000-08-20  Ulrich Drepper  <drepper@redhat.com>

	* misc/sys/cdefs.h: Define __restrict_arr.
	* include/sys/time.h: Add restrict where required by AGd4.
	* inet/arpa/inet.h: Likewise.
	* io/sys/stat.h: Likewise.
	* io/sys/statvfs.h: Likewise.
	* misc/search.h: Likewise.
	* misc/sys/select.h: Likewise.
	* posix/glob.h: Likewise.
	* posix/regex.h: Likewise.
	* posix/spawn.h: Likewise.
	* posix/unistd.h: Likewise.
	* rt/aio.h: Likewise.
	* signal/signal.h: Likewise.
	* socket/sys/socket.h: Likewise.
	* stdlib/ucontext.h: Likewise.
	* streams/stropts.h: Likewise.
	* string/string.h: Likewise.
	* time/time.h: Likewise.
	* time/sys/time.h: Likewise.

	* posix/spawn.h: Add declarations for posix_spawnattr_getscheparam
	and posix_spawnattr_setscheparam.

	* libio/stdio.h: Make cuserid prototype again available for all
	XPG versions.

	* argp/argp-help.c: Unify use of function aliases to make more compact
	PLT.
	* include/libintl.h: Likewise.
	* inet/rcmd.c: Likewise.
	* intl/dcigettext.c: Likewise.
	* libio/iofputws.c: Likewise.
	* libio/iofputws_u.c: Likewise.
	* libio/iogetwline.c: Likewise.
	* libio/swprintf.c: Likewise.
	* malloc/malloc.c: Likewise.
	* nss/digits_dots.c: Likewise.
	* posix/fnmatch.c: Likewise.
	* posix/spawn_faction_addclose.c: Likewise.
	* posix/spawn_faction_adddup2.c: Likewise.
	* posix/spawn_faction_addopen.c: Likewise.
	* posix/spawni.c: Likewise.
	* posix/wordexp.c: Likewise.
	* posix/spawni.c: Likewise.
	* resolv/res_hconf.c: Likewise.
	* resolv/res_init.c: Likewise.
	* shadow/lckpwdf.c: Likewise.
	* signal/sighold.c: Likewise.
	* signal/sigrelse.c: Likewise.
	* stdio-common/printf-parse.h: Likewise.
	* stdio-common/printf-prs.c: Likewise.
	* stdio-common/printf_fp.c: Likewise.
	* stdio-common/vfprintf.c: Likewise.
	* stdio-common/vfscanf.c: Likewise.
	* stdlib/rpmatch.c: Likewise.
	* sunrpc/create_xid.c: Likewise.
	* sunrpc/key_call.c: Likewise.
	* sysdeps/generic/setrlimit64.c: Likewise.
	* sysdeps/generic/utmp_file.c: Likewise.
	* sysdeps/generic/vlimit.c: Likewise.
	* sysdeps/posix/posix_fallocate.c: Likewise.
	* sysdeps/posix/posix_fallocate64.c: Likewise.
	* sysdeps/posix/sigpause.c: Likewise.
	* sysdeps/posix/sigset.c: Likewise.
	* sysdeps/unix/grantpt.c: Likewise.
	* sysdeps/unix/bsd/ualarm.c: Likewise.
	* sysdeps/unix/sysv/linux/dl-origin.c: Likewise.
	* sysdeps/unix/sysv/linux/getloadavg.c: Likewise.
	* sysdeps/unix/sysv/linux/ttyname.c: Likewise.
	* sysdeps/unix/sysv/linux/ulimit.c: Likewise.
	* time/strftime.c: Likewise.
	* wcsmbs/wcscoll.c: Likewise.
	* wcsmbs/wcsxfrm.c: Likewise.

	* time/tst-getdate.c (main): Make error messages more human readable.

	* sysdeps/powerpc/fpu_control.h (_FPU_GETCW): Allow gcc to generate
	postinc/predec instruction.
	(_FPU_SETCW): Likewise.
	Patch by Franz Sirl <Franz.Sirl-kernel@lauterbach.com>.

2000-08-20  Andreas Jaeger  <aj@suse.de>

	* time/tst-getdate.c (main): Increase error in case of wrong
	conversion.
	Fix typo in test case.

2000-08-20  Ulrich Drepper  <drepper@redhat.com>

	* ctype/ctype.h (isblank): Make available if ISO C99.
	* wctype/wctype.h (iswblank): Make available if ISO C99.
	* math/math.h (signgam): Don't make available if ISO C99.
	* math/tgmath.h (tgamma): Renamed from gamma.
	Patches by Joseph S. Myers <jsm28@cam.ac.uk>.

	* intl/loadmsgcat.c (_nl_unload_domain): Also free conv_tab element.
	Pretty printing.
	* intl/plural.y (new_exp): Take number of optional parameters in
	second parameter.  Test for correct number of parameters and free
	correctly in case of failure.  Adjust all callers.
	(yylex): Allow ';' as terminator character.

2000-08-19  Ulrich Drepper  <drepper@redhat.com>

	* locale/lc-time.c (free_mem): New function.  Free alt_digits and
	walt_digits.

	* locale/findlocale.c (free_mem): Also free here->filename.

	* locale/loadlocale.c (_nl_unload_locale): Also free locale->name.

	* math/test-fenv.c (feenv_tests): Clear all exceptions before
	first test.
	(feexcp_nomask_test): Correct printf args.
	(feexcp_mask_test): Likewise.

2000-08-19  Andreas Jaeger  <aj@suse.de>

	* inet/tst-gethnm.c: Include string.h to provide prototype for
	strcmp.

	* malloc/mtrace.pl (usage): Inform about --help.

2000-08-19  Wolfram Gloger  <wg@malloc.de>

	* malloc/malloc.c (new_heap): Try harder to get an aligned chunk of
	size HEAP_MAX_SIZE.

2000-08-19  Andreas Jaeger  <aj@suse.de>

	* shlib-versions: Remove libnss_db, libdb and libdb1.

2000-08-19  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/readdir.c: Move...
	* sysdeps/unix/sysv/linux/ia64/readdir.c: ...here and
	* sysdeps/unix/sysv/linux/sparc/sparc64/readdir.c: ...here.
	* sysdeps/unix/sysv/linux/alpha/readdir_r.c: Move...
	* sysdeps/unix/sysv/linux/ia64/readdir_r.c: ...here and
	* sysdeps/unix/sysv/linux/sparc/sparc64/readdir_r.c: ...here.
	* sysdeps/unix/sysv/linux/alpha/readdir64.c: Remove.
	* sysdeps/unix/sysv/linux/alpha/readdir64_r.c: Remove.
	* sysdeps/unix/sysv/linux/alpha/getdents64.c: Remove.
	* sysdeps/unix/sysv/linux/alpha/getdents.c: Only use for non-LFS
	getdents.
	* sysdeps/unix/sysv/linux/readdir64.c: Remove versioning.
	* sysdeps/unix/sysv/linux/readdir64_r.c: Likewise.

2000-08-18  Jakub Jelinek  <jakub@redhat.com>

	* include/glob.h (__glob64): Add prototype.
	* sysdeps/generic/glob.c: If GLOB_ONLY_P is defined, only
	define glob and glob_in_dir.
	* sysdeps/unix/sysv/linux/i386/Versions: Add glob64@@GLIBC_2.2.
	* sysdeps/unix/sysv/linux/arm/Versions: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/Versions: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/Versions: Likewise.
	* sysdeps/unix/sysv/linux/i386/glob64.c: New file.
	* sysdeps/unix/sysv/linux/arm/glob64.c: New file.
	* sysdeps/unix/sysv/linux/powerpc/glob64.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/glob64.c: New file.

2000-08-18  Jakub Jelinek  <jakub@redhat.com>

	* malloc/Makefile (memusage): libmemusage.so is installed in slibdir.

2000-08-17  Andreas Jaeger  <aj@suse.de>

	* math/test-fenv.c (fe_single_test): New function.
	(fe_env_tests): Use fe_single_test.
	(feenable_test): New tests for feenable/fedisable and
	fegetexcpetions.
	(feexcp_mask_test): New function.
	(feexcp_nomask_test): New function.

2000-08-19  Richard Henderson  <rth@cygnus.com>

	* sysdeps/alpha/fpu/fenv_libc.h: New file.
	* sysdeps/alpha/fpu/fclrexcpt.c: Use it.
	* sysdeps/alpha/fpu/fegetenv.c: Likewise.
	* sysdeps/alpha/fpu/fesetround.c: Likewise.
	* sysdeps/alpha/fpu/fegetround.c: Likewise.
	* sysdeps/alpha/fpu/fgetexcptflg.c: Likewise.
	* sysdeps/alpha/fpu/fraiseexcpt.c: Likewise.
	* sysdeps/alpha/fpu/ftestexcept.c: Likewise.
	* sysdeps/alpha/fpu/fedisblxcpt.c: Likewise.  Use the smaller mask.
	* sysdeps/alpha/fpu/feenablxcpt.c: Likewise.
	* sysdeps/alpha/fpu/fegetexcept.c: Likewise.
	* sysdeps/alpha/fpu/feholdexcpt.c: Retain the SWCR_MAP bits.
	* sysdeps/alpha/fpu/fesetenv.c: Likewise.
	* sysdeps/alpha/fpu/feupdateenv.c: Likewise.
	* sysdeps/alpha/fpu/fsetexcptflg.c: Likewise.
	* sysdeps/alpha/fpu/bits/fenv.h (FE_DENORMAL): New.
	(FE_MAP_DMZ, FE_MAP_UMZ, FE_NONIEEE_ENV): New.

2000-08-19  Andreas Jaeger  <aj@suse.de>

	* elf/constload1.c: Include <stdio.h> for puts prototype.

2000-08-19  Ulrich Drepper  <drepper@redhat.com>

	* elf/Versions [ld] (GLIBC_2.2): Export _dl_check_map_versions.
	* elf/dl-deps.c (_dl_map_object_deps): If object was dependency of
	a dynamically loaded object remove old l_initfini list.
	* elf/dl-libc.c (free_mem): Used as __libc_subfreeres callback to
	remove some dynamically allocated memory blocks in the dynamic
	loading data structures.
	* elf/dl-load.c (add_name_to_object): Initialize dont_free to 0.
	* elf/dl-open.c (dl_open_workder): Don't call _dl_check_all_versions.
	Instead call _dl_check_map_versions only for the dependencies.
	* elf/rtld.c: Avoid unneccessary initializations.  Mark l_libname
	information of initial objects as not free-able.
	* sysdeps/generic/ldsodefs.h (struct libname_list): Add dont_free
	element.

	* elf/filter.c: Call mtrace.
	* elf/restest1.c: Likewise.  Close the objects.
	* elf/loadtest.c: Call mtrace.  Check result of dlclose.  Print more
	debug information.

	* elf/constload1.c: Add comment explaining not freed memory.

2000-08-18  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/mips/bits/stat.h: Add pads to show
	alignment for structs stat and stat64.
	Patch by Maciej W. Rozycki <macro@ds2.pg.gda.pl>.

2000-08-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/getdents.c: Remove special d_ino
	handling.  Patch by Richard Henderson <rth@twiddle.net>.

	* nss/Versions: Remove libnss_db information.

2000-08-16  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/sparc/fpu/fedisblxcpt.c: New file.
	* sysdeps/sparc/fpu/feenablxcpt.c: New file.
	* sysdeps/sparc/fpu/fegetexcept.c: New file.
	* sysdeps/sparc/sparc64/fpu/e_sqrtl.c: New file.

	* sysdeps/sparc/sparc64/dl-machine.h: Subtract 4 .rela.plt entries
	to match Solaris.

2000-08-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/powerpc/fpu_control.h (_FPU_GETCW): Use type-correct code.
	(_FPU_SETCW): Likewise.
	Patch by Franz Sirl <Franz.Sirl-kernel@lauterbach.com>.

	* stdio-common/printf_fp.c: Fix chars_needed computation.
	Patch by Greg McGary <greg@mcgary.org>.

2000-08-17  Jakub Jelinek  <jakub@redhat.com>

	* elf/dl-load.c (_dl_map_object): Don't crash if both loader and
	_dl_loaded are NULL.

2000-08-17  Jakub Jelinek  <jakub@redhat.com>

	* manual/arith.texi (feholdexcept): Returns 0 on success.

2000-08-17  Andreas Jaeger  <aj@suse.de>

	* sysdeps/gnu/net/if.h (struct ifreq): Add ifru_newname.
	(ifr_newname): New.
	Reported by Andi Kleen <ak@suse.de>.

2000-08-17  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/alpha/fpu/fedisblxcpt.c: New file.
	* sysdeps/alpha/fpu/feenablxcpt.c: New file.
	* sysdeps/alpha/fpu/fegetexcept.c: New file.

2000-08-16  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/xstatconv.c (xstat32_conv): Test sizes
	of buf->st_ino and kbuf->st_ino, not __st_ino.
	If _HAVE_STAT64___ST_INO is not defined, don't use __st_ino at all.
	* sysdeps/unix/sysv/linux/getdents64.c: Change path in #include
	directive so that only linux/getdents.c is used, not some
	architecture specific one.

2000-08-16  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/i386/fpu/fegetexcept.c (fegetexcept): Return currently
	enabled, not disabled exceptions.
	* sysdeps/i386/fpu/fedisblxcpt.c (fedisableexcept): Likewise.
	* sysdeps/i386/fpu/feenablxcpt.c (feenableexcept): Likewise.

2000-08-17  Greg McGary  <greg@mcgary.org>

	* Makeconfig (link-extra-libs-bounded): Strip `-bp' suffix
	from test program name when constructing suffix for $(LDLIBS-*).
	(bounded-thread-library): New variable.
	* crypt/Makefile
	[build-shared, build-static] (libcrypt-dep): Remove variable.
	($(addprefix $(objpfx),$(tests))): Consolidate individual dependencies.
	[build-bounded] ($(tests:%=$(objpfx)%-bp)): Add dependencies.
	* linuxthreads/Makefile (libpthread, librt): Remove variables.
	(librt-tests): Add variable.  (tests): Use it.
	[build-shared, build-static]
	($(addprefix $(objpfx),$(tests)),
	$(addprefix $(objpfx),$(librt-tests))):
	Consolidate individual dependencies.
	[build-bounded]
	($(tests:%=$(objpfx)%-bp), $(librt-tests:%=$(objpfx)%-bp)):
	Add dependencies.
	* math/Makefile (LDLIBS-*): Remove variables (they are redundant).
	[build-bounded] ($(tests:%=$(objpfx)%-bp)): Add dependencies.
	* misc/Makefile
	[build-bounded] ($(objpfx)tst-tsearch-bp): Add dependencies.
	* rt/Makefile
	[build-shared, build-static]
	($(addprefix $(objpfx),$(tests))): Consolidate individual dependencies.
	[build-bounded] ($(tests:%=$(objpfx)%-bp)): Add dependencies.

2000-08-17  Greg McGary  <greg@mcgary.org>

	* sysdeps/generic/bp-checks.h: s/\(CHECK\w+\)opt/\1_NULL_OK/
	* sysdeps/unix/make-syscalls.sh: Likewise.
	* sysdeps/unix/sysv/linux/shmctl.c: Likewise.
	* sysdeps/unix/sysv/linux/sigprocmask.c: Likewise.
	* sysdeps/unix/sysv/linux/ia64/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/ia64/sigprocmask.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/sigprocmask.c: Likewise.

2000-08-17  Greg McGary  <greg@mcgary.org>

	* sysdeps/i386/fpu/s_frexp.S: Check bounds.
	Wrap extern symbols in BP_SYM ().
	* sysdeps/i386/fpu/s_frexpf.S: Likewise.
	* sysdeps/i386/fpu/s_frexpl.S: Likewise.
	* sysdeps/i386/fpu/s_remquo.S: Likewise.
	* sysdeps/i386/fpu/s_remquof.S: Likewise.
	* sysdeps/i386/fpu/s_remquol.S: Likewise.
	* sysdeps/i386/fpu/s_sincos.S: Likewise.
	* sysdeps/i386/fpu/s_sincosf.S: Likewise.
	* sysdeps/i386/fpu/s_sincosl.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/mmap64.S: Likewise.

2000-08-16  Andreas Schwab  <schwab@suse.de>

	* sysdeps/m68k/fpu/fegetexcept.c: New file.
	* sysdeps/m68k/fpu/fedisblxcpt.c: New file.
	* sysdeps/m68k/fpu/feenablxcpt.c: New file.

2000-08-15  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/ldsodefs.h: Declare _nl_nloaded.
	* elf/Versions [ld] (GLIBC_2.2): Add _nl_nloaded.
	* elf/dl-support.c: Define _nl_nloaded.
	* elf/rtld.c: Likewise.  Increment _nl_nloaded for rtld itself.
	* elf/dl-object.c (_dl_new_object): Increment _nl_nloaded after adding
	object to global list.
	* elf/dl-close.c (_dl_close): Decrement _nl_nloaded after removing
	from _dl_loaded list.
	* elf/dl-load.c (_dl_map_object_from_fd): Likewise.
	* elf/dl-fini.c (_dl_fini): Use _nl_nloaded instead of computing the
	number here.

	* sysdeps/i386/fpu/fedisblxcpt.c (fedisableexcept): Mask, not
	unmask, exceptions.
	* sysdeps/i386/fpu/feenablxcpt.c (feenableexcept): Unmask, not mask,
	exceptions.
	Reported by Harvey J. Stein <hjstein@bfr.co.il>.

2000-08-16  Andreas Jaeger  <aj@suse.de>

	* elf/elf.h (EM_X8664): Add official x86-64 specific value.

2000-08-15  Marko Myllynen  <myllynen@lut.fi>

	* inet/netinet/icmp6.h: Added Mobile IPv6 definitions.

2000-08-15  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/Dist: Add oldgetrlimit64.c.
	* sysdeps/unix/sysv/linux/powerpc/Makefile [$(subdir)=resource]
	(sysdep_routines): Add oldgetrlimit64.
	* sysdeps/unix/sysv/linux/powerpc/oldgetrlimit64.c: New file.
	Patch by Franz Sirl <Franz.Sirl-kernel@lauterbach.com>.

	* include/link.h: Undo last patches.  Hurd now has stat64.
	* elf/Makefile: Likewise.
	* elf/dl-load.c: Likewise.
	* elf/dl-misc.c: Likewise.
	* elf/dl-profile.c: Likewise.
	* sysdeps/generic/sysd-link.h: Removed.
	* sysdeps/unix/sysv/linux/sysd-link.h: Removed.

	* rt/aio_notify.c (notify_func_wrapper): Wrapper function to call
	thread event callback function.
	(__aio_notify_only): Use function above.
	Patch by Kaz Kylheku <kaz@ashi.footprints.net>.

2000-08-16  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/mach/hurd/lseek64.c: New file.

2000-08-15  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/mach/hurd/i386/bits/time.h (__clockid_t, __timer_t):
	Remove typedefs.
	* sysdeps/mach/hurd/bits/time.h (__clockid_t, __timer_t): Remove
	typedefs.
	* sysdeps/generic/bits/time.h (__clockid_t, __timer_t): Remove
	typedefs.
	* sysdeps/generic/bits/types.h (__clockid_t, __timer_t): New typedefs.

2000-08-15  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/mach/hurd/xstatconv.c: New file.
	* sysdeps/mach/hurd/fxstat64.c: New file.
	* sysdeps/mach/hurd/lxstat64.c: New file.
	* sysdeps/mach/hurd/xstat64.c: New file.
	* sysdeps/mach/hurd/Dist: Add xstatconv.c.

2000-08-15  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/mach/hurd/dl-sysdep.c (__libc_multiple_libcs):
	Initialize, needed for change in common symbol handling in newer
	binutils.  Mirrors 2000-01-03 change made by Andreas Schwab.

2000-08-15  Ulrich Drepper  <drepper@redhat.com>

	* elf/constload1.c: Call mtrace.  Check return value of dlclose call.
	* elf/constload2.c: Add destructor to unload constload3.

	* include/link.h: Include sysd-link.h.
	* sysdeps/generic/sysd-link.h: New file.
	* sysdeps/unix/sysv/linux/sysd-link.h: New file.
	* elf/Makefile (distribute): Add sysd-link.h.
	* elf/dl-load.c: Use definitions from sysd-link.h instead of stat
	types and functions directly.
	* elf/dl-misc.c: Likewise.
	* elf/dl-profile.c: Likewise.

	* elf/loadfail.c (main): Close all successfully loaded objects.

	* elf/multiload.c: Add mtrace call.  Call dlclose for all handles and
	free wd.
	* elf/dl-deps.c (_dl_map_object_deps): Don't allocate needed list if
	there is already one.

	* elf/dl-close.c: Pretty print.

2000-08-14  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/posix/ttyname.c: Make name variable from getttyname function
	global (with file scope).  Add __libc_subfreeres function to free the
	string.
	* sysdeps/unix/sysv/linux/ttyname.c: Likewise.  Also for buf variable
	in ttyname function.

	* sysdeps/generic/strtok.c: Remove initializer for olds variable.

	* crypt/md5-crypt.c: Let destructor deallocate static buffer.

	* iconvdata/sjis.c (from_ucs4_lat1): Handle U005C and U007E by
	mapping them to /x5c and /x7e respectively.

	* locale/programs/ld-ctype.c: Add support for more definitions after
	copy statement.

2000-08-14  Jakub Jelinek  <jakub@redhat.com>

	* dirent/Versions (getdirentries64): Export at GLIBC_2.2.
	* sysdeps/unix/sysv/linux/kernel-features.h
	(__ASSUME_GETDENTS64_SYSCALL): Define.
	* sysdeps/unix/sysv/linux/getdents.c (__getdents): Use getdents64
	syscall if available to get d_type fields.
	* sysdeps/unix/sysv/linux/alpha/getdents.c (DIRENT_TYPE): Define.
	* sysdeps/unix/sysv/linux/arm/Versions (__xstat64, __fxstat64,
	__lxstat64): Export at GLIBC_2.2.
	(alphasort64, readdir64, readdir64_r, scandir64, versionsort64):
	Likewise.
	* sysdeps/unix/sysv/linux/i386/Versions (getdirentries64): Remove.
	* sysdeps/unix/sysv/linux/i386/getdents64.c (kernel_dirent64): Define.
	* sysdeps/unix/sysv/linux/powerpc/Versions (alphasort64,
	getdirentries64, versionsort64): Remove.
	* sysdeps/unix/sysv/linux/sparc/sparc32/Versions (alphasort64,
	getdirentries64, versionsort64): Remove.

2000-08-13  Ulrich Drepper  <drepper@redhat.com>

	* posix/Makefile: Remove rules to generate glob package.

	* posix/Makefile (tests): Add tst-regexloc.
	(tst-regexloc-ENV): Add LOCPATH.
	* posix/tst-regexloc.c: New file.

2000-08-12  Andreas Jaeger  <aj@suse.de>

	* include/features.h (__STDC_ISO_10646__): Define.
	Reported by Markus Kuhn <Markus.Kuhn@cl.cam.ac.uk>.

2000-08-13  Ulrich Drepper  <drepper@redhat.com>

	* include/features.h (__USE_ISOC99): Define for _XOPEN_SOURCE >= 600.

	* locale/langinfo.h: Define YESSTR and NOSTR also for XPG4 (but not
	for revision 6 and up).

	* posix/sys/types.h: Define __need_timer_t and __need_clockid_t before
	including <time.h>.
	* time/time.h: Allow __need_timer_t and __need_clockid_t to be defined
	to get definitions of just these types.

	* signal/signal.h: Define thread signal handling functions also for
	POSIX95.

	* sysdeps/unix/sysv/linux/bits/types.h: Define thread types also for
	POSIX95.
	* sysdeps/unix/sysv/linux/alpha/bits/types.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/bits/types.h: Likewise.
	* sysdeps/unix/sysv/linux/mips/bits/types.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/types.h: Likewise.

	* sysvipc/sys/shm.h: Define pid_t for XPG.

	* posix/unistd.h: Remove setkey, rename, and cuserid prototypes as
	they are not anymore required here.

	* wcsmbs/wchar.h: Make the various wide char string and stream
	functions available for the respective XPG versions.

	* nss/Makefile: Remove rules to build and distribute nss_db.

	* sysdeps/generic/alphasort64.c: Remove unnecessary versioning.
	* sysdeps/generic/scandir64.c: Likewise.
	* sysdeps/generic/versionsort64.c: Likewise.

2000-08-13  Ulrich Drepper  <drepper@redhat.com>
	    Benjamin Koznik  <bkoz@redhat.com>

	* libio/fileops.c: Merge with libstdc++-v3.
	* libio/genops.c: Likewise.
	* libio/iofclose.c: Likewise.
	* libio/iofopen.c: Likewise.
	* libio/iofwide.c: Likewise.
	* libio/libio.h: Likewise.
	* libio/libioP.h: Likewise.
	* libio/stdfiles.c: Likewise.
	* libio/stdio.c: Likewise.
	* libio/wfileops.c: Likewise.
	* libio/wgenops.c: Likewise.

	* libio/Versions: Export functions needed by libstdc++-v3 in GLIBC_2.2.

2000-08-12  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/localedef.c: Implement --prefix option to allow
	writing in standard places of alternative install directories.

	* posix/regex.c (compile_range): Implement collation sequence
	handling for glibc.  Use simple character ordering otherwise and
	not strcoll.

2000-08-12  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/generic/scandir64.c: Include <dirent.h>.

2000-08-12  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/i386/bits/fcntl.h: Handle
	__USE_FILE_OFFSET64 correctly for locking.
	* sysdeps/unix/sysv/linux/sparc/bits/fcntl.h: Likewise.

2000-08-12  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/kernel-features.h (__ASSUME_FCNTL64):
	Define for 2.4.1 on sparc as well.
	* sysdeps/unix/sysv/linux/sparc/bits/fcntl.h: Fill in correct values
	for F_GETLK64, F_SETLK64, and F_SETLKW64.
	* sysdeps/unix/sysv/linux/sparc/sparc32/fcntl.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/lockf64.c: New file.

2000-08-12  Ulrich Drepper  <drepper@redhat.com>

	* io/fts.c (fts_stat): Recognize DT_WHT only if S_IFWHT is also
	defined.

2000-08-12  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/alpha/bits/fcntl.h (F_GETLK64,
	F_SETLK64, F_SETLKW64): Define with F_GETLK etc.

	* sysdeps/unix/sysv/linux/mips/sys/tas.h (_test_and_set): Add .set
	mips2 for assembler.

	* sysdeps/unix/sysv/linux/i386/fcntl.c (__libc_fcntl): Try fcntl
	if fnctl64 is not available for F_*LK*64.

	* sysdeps/unix/sysv/linux/i386/lockf64.c: New file.

2000-08-12  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/kernel-features.h (__ASSUME_FCNTL64):
	Define for 2.4.1 on x86.
	* sysdeps/unix/sysv/linux/i386/fcntl.c: New file.
	* sysdeps/unix/sysv/linux/i386/bits/fcntl.h: Fill in correct values
	for F_GETLK64, F_SETLK64, and F_SETLKW64.

	* dirent/dirent.h: Define DT_WHT.

	* sysdeps/unix/sysv/linux/arm/alphasort64.c: New file.
	* sysdeps/unix/sysv/linux/arm/getdents64.c: New file.
	* sysdeps/unix/sysv/linux/arm/readdir64.c: New file.
	* sysdeps/unix/sysv/linux/arm/readdir64_r.c: New file.
	* sysdeps/unix/sysv/linux/arm/scandir64.c: New file.
	* sysdeps/unix/sysv/linux/arm/versionsort64.c: New file.

2000-08-11  Ulrich Drepper  <drepper@redhat.com>

	* nss/digits_dots.c: Don't pass NULL in h_aliases for successful
	lookup, pass pointer to array with NULL pointer [PR libc/1858].
	* inet/Makefile (tests): Add tst-gethnm.
	* inet/tst-gethnm.c: New file.

	* rt/aio_cancel.c: If canceling a specific request which is running
	*really* do nothing.
	* rt/aio_misc.h: Add `done' to states of a request.
	* rt/aio_misc.c: Add several tests for the correct state.
	Simplify request table memory handling.

2000-08-10  Jakub Jelinek  <jakub@redhat.com>

	* dirent/scandir.c: Use it for scandir64 and old_scandir64 as well.
	* dirent/scandir64.c: Move...
	* sysdeps/generic/scandir64.c: ...here.
	* dirent/alphasort64.c: Move...
	* sysdeps/generic/alphasort64.c: ...here.
	* dirent/versionsort64.c: Move...
	* sysdeps/generic/versionsort64.c: ...here.
	* sysdeps/unix/sysv/linux/i386/dirent/Versions (alphasort64,
	getdirentries64, readdir64, readdir64_r, scandir64, versionsort64):
	Export symbols at GLIBC_2.2.
	* sysdeps/unix/sysv/linux/powerpc/dirent/Versions: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/dirent/Versions: Likewise.
	* include/dirent.h (__readdir64_r, __scandir64, __alphasort64,
	__versionsort64): Add prototypes.
	* io/Versions (__xstat64, __fxstat64, __lxstat64): Export at GLIBC_2.2.
	* sysdeps/unix/sysv/linux/alpha/kernel_stat.h (__xstat_conv): Remove
	unused prototype.
	* sysdeps/unix/sysv/linux/alpha/readdir.c: Export at both GLIBC_2.1
	and GLIBC_2.2.
	* sysdeps/unix/sysv/linux/alpha/readdir_r.c: Likewise.
	* sysdeps/unix/sysv/linux/alpha/getdents.c: New.
	* sysdeps/unix/sysv/linux/alpha/getdents64.c: New.
	* sysdeps/unix/sysv/linux/bits/types.h (__ino64_t): Change to
	__u_quad_t.
	* sysdeps/unix/sysv/linux/bits/stat.h (struct stat, struct stat64):
	Adjust for kernel-2.4.0-test6 layout.
	* sysdeps/unix/sysv/linux/i386/fxstat.c (__fxstat64): Export at both
	GLIBC_2.1 and GLIBC_2.2.
	* sysdeps/unix/sysv/linux/i386/lxstat.c (__lxstat64): Likewise.
	* sysdeps/unix/sysv/linux/i386/xstat.c (__xstat64): Likewise.
	* sysdeps/unix/sysv/linux/i386/getdents64.c: New.
	* sysdeps/unix/sysv/linux/i386/olddirent.h: New.
	* sysdeps/unix/sysv/linux/i386/readdir64.c: New.
	* sysdeps/unix/sysv/linux/i386/readdir64_r.c: New.
	* sysdeps/unix/sysv/linux/i386/scandir64.c: New.
	* sysdeps/unix/sysv/linux/i386/alphasort64.c: New.
	* sysdeps/unix/sysv/linux/i386/versionsort64.c: New.
	* sysdeps/unix/sysv/linux/ia64/getdents.c: New.
	* sysdeps/unix/sysv/linux/ia64/getdents64.c: New.
	* sysdeps/unix/sysv/linux/ia64/readdir.c: Include alpha/readdir.c.
	* sysdeps/unix/sysv/linux/ia64/readdir_r.c: Include alpha/readdir_r.c.
	* sysdeps/unix/sysv/linux/mips/bits/types.h (__ino64_t): Change to
	__u_quad_t.
	* sysdeps/unix/sysv/linux/powerpc/bits/stat.h: New.
	* sysdeps/unix/sysv/linux/powerpc/kernel_stat.h (_HAVE_STAT*): Define.
	* sysdeps/unix/sysv/linux/powerpc/scandir64.c: New.
	* sysdeps/unix/sysv/linux/powerpc/getdents64.c: New.
	* sysdeps/unix/sysv/linux/powerpc/readdir64.c: New.
	* sysdeps/unix/sysv/linux/powerpc/readdir64_r.c: New.
	* sysdeps/unix/sysv/linux/sparc/bits/types.h (__ino64_t): Change to
	__u_quad_t.
	* sysdeps/unix/sysv/linux/sparc/bits/stat.h: New.
	* sysdeps/unix/sysv/linux/sparc/sparc32/kernel_stat.h (_HAVE_STAT*):
	Define.
	* sysdeps/unix/sysv/linux/sparc/sparc32/getdents64.c: New.
	* sysdeps/unix/sysv/linux/sparc/sparc32/readdir64.c: New.
	* sysdeps/unix/sysv/linux/sparc/sparc32/readdir64_r.c: New.
	* sysdeps/unix/sysv/linux/sparc/sparc32/scandir64.c: New.
	* sysdeps/unix/sysv/linux/sparc/sparc64/kernel_stat.h (_HAVE_STAT*):
	Define.
	* sysdeps/unix/sysv/linux/sparc/sparc64/readdir.c: Include
	alpha/readdir.c.
	* sysdeps/unix/sysv/linux/sparc/sparc64/readdir_r.c: Include
	alpha/readdir_r.c
	* sysdeps/unix/sysv/linux/sparc/sparc64/getdents.c: New.
	* sysdeps/unix/sysv/linux/sparc/sparc64/getdents64.c: New.
	* sysdeps/unix/sysv/linux/fxstat64.c (__fxstat64): If
	_HAVE_STAT64___ST_INO and __st_ino != (uint32_t)st_ino, set
	st_ino from __st_ino.
	* sysdeps/unix/sysv/linux/lxstat64.c (__lxstat64): Likewise.
	* sysdeps/unix/sysv/linux/xstat64.c (__xstat64): Likewise.
	* sysdeps/unix/sysv/linux/xstatconv.c (xstat_conv, xstat64_conv,
	xstat32_conv): Use _HAVE_STAT* macros.  If _HAVE_STAT64___ST_INO,
	set __st_ino in addition to st_ino.
	* sysdeps/unix/sysv/linux/kernel_stat.h (_HAVE_STAT*): Define.
	* sysdeps/unix/sysv/linux/getdents.c: Use it for __getdents64 and
	__old_getdents64 as well.
	* sysdeps/unix/sysv/linux/getdirentries.c: Use it for
	getdirentries64 and old_getdirentries64 as well.
	* sysdeps/unix/sysv/linux/getdirentries64.c (GETDIRENTRIES,
	__GETDENTS): Define.
	(GETDENTS64): Remove.
	* sysdeps/unix/sysv/linux/getdents64.c (__GETDENTS, DIRENT_TYPE):
	Define.
	(GETDENTS64): Remove.
	* sysdeps/unix/sysv/linux/readdir64.c: Use sysdeps/unix/readdir.c.
	* sysdeps/unix/sysv/linux/readdir64_r.c: Use sysdeps/unix/readdir_r.c.
	* sysdeps/unix/readdir.c: Use it for readdir64 and __old_readdir64
	as well.
	* sysdeps/unix/readdir_r.c: Use it for readdir64_r and
	__old_readdir64_r as well.
	* sysdeps/unix/sysv/linux/kernel-features.h: Define
	__ASSUME_ST_INO_64_bit for kernel 2.4.1 and up.

2000-08-08  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/unix/sysv/linux/ia64/bits/siginfo.h: Add SI_KERNEL define.
	Add missing ILL_BADIADDR to enum and make ILL_BREAK match the
	define of the kernel.
	Add missing __SEG_PSTKOVF definition.
	Adjust the padding of struct siginfo and struct sigevent to
	match the fact that sigval_t is 64 bit.

2000-08-10  Ulrich Drepper  <drepper@redhat.com>

	* timezone/zic.c: Update from tzcode2000f.
	* timezone/australasia: Update from tzdata2000f.
	* timezone/europe: Likewise.
	* timezone/southamerica: Likewise.
	* timezone/yearistype: Likewise.

2000-08-10  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/mips/bits/stat.h: Synch struct stat64 and
	stat with current MIPS kernel.

2000-08-01  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/unix/sysv/linux/i386/sys/elf.h (elf_greg_t, ELF_NGREG,
	elf_gregset_t, elf_fpregset_t, elf_fpxregset_t): Moved to
	sysdeps/unix/sysv/linux/i386/sys/procfs.h.
	Remove the junk that's only relevant in the Linux kernel itself.
	Add a warning saying that this file is now obsolete, and include
	<sys/procfs.h>.
	* sysdeps/unix/sysv/linux/i386/sys/procfs.h (elf_greg_t,
	ELF_NGREG, elf_gregset_t, elf_fpregset_t, elf_fpxregset_t): Moved
	here from sysdeps/unix/sysv/linux/i386/sys/elf.h.  Don't include
	<signal.h>, <sys/ucontext.h> and <sys/elf.h>.  Remove parts of
	`struct elf_prstatus' that are #ifdef'ed out.  Improve comments
	and add the notice that the file is primarily there for GDB.
	* sysdeps/unix/sysv/linux/i386/sys/user.h: Fix comment.

2000-08-09  Jakub Jelinek  <jakub@redhat.com>

	* time/tzfile.c (__tzfile_compute): __tzstring zones
	from zone_names.

2000-08-09  Jakub Jelinek  <jakub@redhat.com>

	* resolv/resolv.h (__res_state): Surround prototype with
	__BEGIN_DECLS/__END_DECLS.
	* sysdeps/unix/sysv/linux/m68k/chown.c: Include kernel-features.h.

2000-08-04  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/unix/sysv/linux/ia64/bits/resource.h (__rlimit_resource):
	Make independant of asm/resource.h from the Linux kernel.

2000-08-06  Bruno Haible  <haible@clisp.cons.org>

	* iconv/gconv_conf.c (__gconv_read_conf): Don't call realpath.

2000-08-06  Bruno Haible  <haible@clisp.cons.org>

	* intl/Makefile (CPPFLAGS): Remove $(i18ndir) from LOCALE_ALIAS_PATH.
	* locale/Makefile (locale-CPPFLAGS): Likewise.

2000-08-09  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/i386/fpu/libm-test-ulps: Increase several error values
	for AMD processors.

2000-08-03  Jakub Jelinek  <jakub@redhat.com>

	* misc/Versions (mincore): Export at GLIBC_2.2.

2000-08-03  Bruno Haible  <haible@clisp.cons.org>

	* intl/libintl.h (gettext, dgettext, dcgettext): Add back __THROW.

2000-08-02  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/mach/hurd/socketpair.c (__socketpair): Renamed from
	socketpair.  Made socketpair a weak alias.
	* sysdeps/mach/hurd/pipe.c (__pipe): Reimplemented using
	__socketpair.  Use S_IFIFO protocol to make pipes POSIX
	conforming, but fall back on the old protocol if the socket server
	doesn't support it.
	* include/sys/socket.h: Add prototype for __socketpair.

2000-08-09  Andreas Schwab  <schwab@suse.de>

	* stdio-common/vfprintf.c (vfprintf): Also set `is_long' if the
	long long modifier is seen.

	* elf/nodelete.c (do_test): Remove reference to undefined member
	sa_restorer.
	* rt/tst-aio4.c (do_test): Likewise.

	* configure.in: Add `-lm' when checking for libgd.
	* malloc/Makefile ($(objpfx)memusagestat): Add `-lm' during
	linking.

2000-08-09  Andreas Jaeger  <aj@suse.de>

	* configure.in: Change required make versions.

	* manual/install.texi (Tools for Compilation): Document required
	make version.
	(Supported Configurations): Update list of supported
	configurations.

2000-08-08  Ulrich Drepper  <drepper@redhat.com>

	* locale/linereader.c (get_string): Don't print an error is a string
	contains an unknown character.

2000-08-06  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/ld-collate.c (struct symbol_t): Add name element.
	(new_symbol): Take new parameters with name of the symbol.
	Adjust callers.
	(handle_ellipsis): Don't only allow character symbols.
	(collate_read): Allow string of collating elements contain invalid
	characters; ignore entry in this case.
	Handle ellipsis of collating symbols before first order_start.
	Allow ellipsis in state 0.

2000-08-04  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/ld-collate.c (handle_ellipsis): Fix typo in
	error message.
	Reported by Tung-Han Hsieh <thhsieh@twcpro.phys.ntu.edu.tw>.

2000-08-04  Greg McGary  <greg@mcgary.org>

	* posix/regex.c (SET_HIGH_BOUND): New macro.
	(MOVE_BUFFER_POINTER): Use it.
	(ELSE_EXTEND_BUFFER_HIGH_BOUND): New macro.
	(EXTEND_BUFFER): Use it.

2000-08-03  Ulrich Drepper  <drepper@redhat.com>

	* libio/iofwide.c (_IO_fwide): Initialize fp->_codecvt as well.
	* libio/fileops.c (_IO_new_file_fopen): Use _codecvt not from
	_wide_data but from _IO_FILE directly.
	* libio/iofclose.c: Likewise.
	* libio/wfileops.c: Likewise.

	* libio/genops.c (_IO_default_showmanyc): Change return type to size_t.
	* libio/libioP.h: Change prototypes.

2000-08-03  Greg McGary  <greg@mcgary.org>

	* sysdeps/i386/setjmp.S (__sigsetjmp): Pop our
	frame pointer early so that we save caller's frame pointer.
	* sysdeps/i386/elf/setjmp.S: Likewise.

	* sysdeps/unix/sysv/syscalls.list (time, utime): Correct signatures.
	* io/test-utime.c: Test passing NULL as utimbuf* arg.

	* posix/regex.c (EXTEND_BUFFER_HIGH_BOUND): Remove macro.
	(MOVE_BUFFER_POINTER): Handle high_bound properly.
	(EXTEND_BUFFER): Don't call EXTEND_BUFFER_HIGH_BOUND.

2000-08-03  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/big5.c: Updated.
	Patch by Tung-Han Hsieh <thhsieh@twcpro.phys.ntu.edu.tw>.

2000-08-02  Ulrich Drepper  <drepper@redhat.com>

	* Makeconfig (all-subdirs): Add conform.
	* conform/Makefile: Include ../Rules.

	* Makefile (README): Add rules to generate here as well.

2000-08-02  Ulrich Drepper  <drepper@redhat.com>

	* version.h (VERSION): Bump to 2.1.92.

	* sysdeps/ia64/Dist: Add _mcount.S.

	* sysdeps/unix/sysv/linux/ia64/Dist: Add clone.S.

	* sysdeps/unix/sysv/linux/mips/Dist: Add _test_and_set.c.

	* elf/Makefile (distribute): Add missing modules.

	* sysdeps/unix/sysv/linux/s390/Dist: Remove nonexisting files.

	* posix/regex.c (compile_range): Translate range start and end
	characters to avoid empty range in case of REG_ICASE [PR libc/1842].

	* sysdeps/unix/sysv/linux/ia64/bits/resource.h: Don't include
	asm/resource.h.

	* sysdeps/unix/sysv/linux/arm/Makefile: Undo last change.

2000-08-02  Andreas Jaeger  <aj@suse.de>

	* elf/elf.h (EM_S390): Added.
	(R_390_*): New relocs for S390.

	* sysdeps/unix/sysv/linux/s390/Dist: New file.
	* sysdeps/unix/sysv/linux/s390/sysdep.h: New file.
	* sysdeps/unix/sysv/linux/s390/sysdep.S: New file.
	* sysdeps/unix/sysv/linux/s390/syscall.S: New file.
	* sysdeps/unix/sysv/linux/s390/sys/user.h: New file.
	* sysdeps/unix/sysv/linux/s390/sys/ucontext.h: New file.
	* sysdeps/unix/sysv/linux/s390/sys/ptrace.h: New file.
	* sysdeps/unix/sysv/linux/s390/sys/elf.h: New file.
	* sysdeps/unix/sysv/linux/s390/socket.S: New file.
	* sysdeps/unix/sysv/linux/s390/sigcontextinfo.h: New file.
	* sysdeps/unix/sysv/linux/s390/shmctl.c: New file.
	* sysdeps/unix/sysv/linux/s390/setreuid.c: New file.
	* sysdeps/unix/sysv/linux/s390/setresuid.c: New file.
	* sysdeps/unix/sysv/linux/s390/setresgid.c: New file.
	* sysdeps/unix/sysv/linux/s390/setregid.c: New file.
	* sysdeps/unix/sysv/linux/s390/setgroups.c: New file.
	* sysdeps/unix/sysv/linux/s390/setgid.c: New file.
	* sysdeps/unix/sysv/linux/s390/setfsuid.c: New file.
	* sysdeps/unix/sysv/linux/s390/setfsgid.c: New file.
	* sysdeps/unix/sysv/linux/s390/seteuid.c: New file.
	* sysdeps/unix/sysv/linux/s390/setegid.c: New file.
	* sysdeps/unix/sysv/linux/s390/semctl.c: New file.
	* sysdeps/unix/sysv/linux/s390/register-dump.h: New file.
	* sysdeps/unix/sysv/linux/s390/putpmsg.c: New file.
	* sysdeps/unix/sysv/linux/s390/putmsg.c: New file.
	* sysdeps/unix/sysv/linux/s390/profil-counter.h: New file.
	* sysdeps/unix/sysv/linux/s390/msgctl.c: New file.
	* sysdeps/unix/sysv/linux/s390/mmap.S: New file.
	* sysdeps/unix/sysv/linux/s390/getuid.c: New file.
	* sysdeps/unix/sysv/linux/s390/getresuid.c: New file.
	* sysdeps/unix/sysv/linux/s390/getresgid.c: New file.
	* sysdeps/unix/sysv/linux/s390/getpmsg.c: New file.
	* sysdeps/unix/sysv/linux/s390/getmsg.c: New file.
	* sysdeps/unix/sysv/linux/s390/getgroups.c: New file.
	* sysdeps/unix/sysv/linux/s390/getegid.c: New file.
	* sysdeps/unix/sysv/linux/s390/geteuid.c: New file.
	* sysdeps/unix/sysv/linux/s390/fchown.c: New file.
	* sysdeps/unix/sysv/linux/s390/clone.S: New file.
	* sysdeps/unix/sysv/linux/s390/brk.c: New file.
	* sysdeps/unix/sysv/linux/s390/bits/time.h: New file.
	* sysdeps/unix/sysv/linux/s390/bits/resource.h: New file.
	* sysdeps/unix/sysv/linux/s390/bits/mman.h: New file.
	* sysdeps/unix/sysv/linux/s390/bits/fcntl.h: New file.
	* sysdeps/unix/sysv/linux/s390/Makefile: New file.
	* sysdeps/s390/sysdep.h: New file.
	* sysdeps/s390/sys/ucontext.h: New file.
	* sysdeps/s390/sub_n.S: New file.
	* sysdeps/s390/strncpy.S: New file.
	* sysdeps/s390/strcpy.S: New file.
	* sysdeps/s390/stackinfo.h: New file.
	* sysdeps/s390/setjmp.S: New file.
	* sysdeps/s390/s390-mcount.S: New file.
	* sysdeps/s390/mul_1.S: New file.
	* sysdeps/s390/memusage.h: New file.
	* sysdeps/s390/memset.S: New file.
	* sysdeps/s390/memcpy.S: New file.
	* sysdeps/s390/memchr.S: New file.
	* sysdeps/s390/machine-gmon.h: New file.
	* sysdeps/s390/ldbl2mpn.c: New file.
	* sysdeps/s390/gmp-mparam.h: New file.
	* sysdeps/s390/fpu/fpu_control.h: New file.
	* sysdeps/s390/fpu/fesetround.c: New file.
	* sysdeps/s390/fpu/fegetround.c: New file.
	* sysdeps/s390/fpu/fclrexcpt.c: New file.
	* sysdeps/s390/fpu/bits/fenv.h: New file.
	* sysdeps/s390/ffs.c: New file.
	* sysdeps/s390/elf/start.S: New file.
	* sysdeps/s390/elf/setjmp.S: New file.
	* sysdeps/s390/elf/bsd-setjmp.S: New file.
	* sysdeps/s390/elf/bsd-_setjmp.S: New file.
	* sysdeps/s390/dl-machine.h: New file.
	* sysdeps/s390/bzero.S: New file.
	* sysdeps/s390/bsd-setjmp.S: New file.
	* sysdeps/s390/bsd-_setjmp.S: New file.
	* sysdeps/s390/bits/string.h: New file.
	* sysdeps/s390/bits/setjmp.h: New file.
	* sysdeps/s390/bits/huge_val.h: New file.
	* sysdeps/s390/bits/endian.h: New file.
	* sysdeps/s390/bits/byteswap.h: New file.
	* sysdeps/s390/bcopy.S: New file.
	* sysdeps/s390/backtrace.c: New file.
	* sysdeps/s390/atomicity.h: New file.
	* sysdeps/s390/asm-syntax.h: New file.
	* sysdeps/s390/addmul_1.S: New file.
	* sysdeps/s390/add_n.S: New file.
	* sysdeps/s390/abort-instr.h: New file.
	* sysdeps/s390/__longjmp.c: New file.
	* sysdeps/s390/Makefile: New file.
	* sysdeps/s390/Implies: New file.
	* sysdeps/s390/Dist: New file.
	Patches by Martin Schwidefsky <schwidefsky@de.ibm.com>.

2000-08-01  Ulrich Drepper  <drepper@redhat.com>

	Remove incompatible IPv6 extension of RPC.
	* sunrpc/Makefile: Undo changes.
	* sunrpc/rpc_main.c: Likewise.
	* sunrpc/rpc/clnt.h: Likewise.
	* sunrpc/rpc/svc.h: Likewise.
	* sunrpc/bindrsvprt6.c: Removed.
	* sunrpc/clnt_tcp6.c: Removed.
	* sunrpc/clnt_udp6.c: Removed.
	* sunrpc/svc_tcp6.c: Removed.
	* sunrpc/svc_udp6.c: Removed.

	* intl/libintl.h: Don't use __attribute_format_arg__ for gettext,
	dgettext, and dcgettetxt.

	* intl/locale.alias: Update japanese aliases.

	* sysdeps/ia64/bits/byteswap.h: New file.
	Patch by Dan Pop <Dan.Pop@cern.ch>.

	* misc/sys/cdefs.h: Define __attribute_format_arg__.
	* intl/libintl.h: Use it here instead of using __attribute__ directly.

2000-07-13  H.J. Lu  <hjl@gnu.org>

	* posix/regex.c (re_max_failures): Set to 4000.

2000-08-01  Ulrich Drepper  <drepper@redhat.com>

	* gnulib/Makefile (tests): Add tst-gcc.
	* gnulib/tst-gcc.c: New file.

	* assert/Makefile (routines): Add __assert.
	* assert/Versions: Export __assert for glibc 2.2.
	* assert/__assert.c: New file.
	* assert/assert.h: Declare __assert.

2000-07-27  Bruno Haible  <haible@clisp.cons.org>

	* locale/localeinfo.h (_ISCTYPE): New macro.
	* posix/fnmatch_loop.c (internal_fnmatch): Use it, support new
	LC_CTYPE locale format.
	* locale/programs/ld-ctype.c (locale_ctype_t): New field class_b.
	(ctype_output): Output class_b[nr] right before class_3level[nr].
	(allocate_arrays): Fill class_b, similarly to class_3level.

2000-08-01  Ulrich Drepper  <drepper@redhat.com>
	    Joseph S. Myers  <jsm28@cam.ac.uk>

	* math/tgmath.h: Make standard compliant.  Don't ask how.

2000-07-04  H.J. Lu  <hjl@gnu.org>

	* elf/Makefile ($(inst_slibdir)/$(rtld-version-installed-name)):
	Use $(do-install-program) instead of "$(INSTALL_PROGRAM) $< $@.new".
	($(inst_slibdir)/$(rtld-installed-name)): Use $(make-shlib-link) only.

2000-07-30  Maciej W. Rozycki  <macro@ds2.pg.gda.pl>

	* include/features.h (_XOPEN_SOURCE): Update the explanation.
	(__USE_LARGEFILE): Add an explanation.
	(_POSIX_C_SOURCE): Define to 2 only if _XOPEN_SOURCE < 500.
	(__USE_XOPEN2K): Define whenever _XOPEN_SOURCE >= 600.

2000-08-01  Ulrich Drepper  <drepper@redhat.com>

	* libio/Makefile: Enable exception handling for genops, wgenops,
	fileops, and wfileops.

2000-07-29  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/mach/hurd/dl-sysdep.c (_dl_sysdep_start): Take into
	acount that elf/rtld's main program might remove some varibales
	from the environment if we're trying to be secure.  Move the Hurd
	startup data if necessary, or, if we there is no startup data,
	make sure the magical convention that ARGV[0] is stored just after
	the environment list.

2000-08-01  Philip Blundell  <philb@gnu.org>

	* sysdeps/unix/sysv/linux/arm/Makefile [subdir=resource]
	(sysdep_routines): Add oldgetrlimit, oldsetrlimit.
	* sysdeps/unix/sysv/linux/arm/syscalls.list: Add oldgetrlimit,
	oldsetrlimit for GLIBC_2.0.

2000-08-01  Andreas Jaeger  <aj@suse.de>

	* nss/nss_files/files-ethers.c: Use case-insensitive lookup.
	(LINE_PARSER): Allow any number of spaces between ip address and
	number.  Fixes PR libc/1833, reported by rp010gf@voruta.vu.lt.

	* conform/data/netdb.h-data: Remove getipnodebyaddr and friends.

	* include/netdb.h: Remove getipnodebyaddr and friends, leave
	constants in.

	* nis/Versions: Remove _nss_nis_getipnodebyname_r and
	_nss_nisplus_getipnodebyname_r.

	* nis/nss_nis/nis-hosts.c (_nss_nis_getipnodebyname_r): #if 0 for
	now, getipnodebyname is deprecated.
	* nis/nss_nisplus/nisplus-hosts.c (_nss_nisplus_getipnodebyname_r):
	Likewise.

	* inet/Makefile (routines): Don't build getipnodebyaddr and
	friends.

	* intl/Makefile (distribute): Add tst-translit.sh and translit.po.

	* hesiod/Makefile (distribute): Add nss_hesiod/nss_hesiod.h.

	* elf/Makefile (distribute): Add filtmod1.c and filtmod2.c.

	* wctype/Makefile (distribute): Add wchar-lookup.h.

	* sysdeps/generic/Dist: Add bp-checks.h and bp-semctl.h.

	* iconvdata/Makefile (distribute): Add isiri-3342.h.

2000-08-01  Andreas Schwab  <schwab@suse.de>

	* Make-dist (dist): Resolve `..' in file names.

2000-08-01  Andreas Jaeger  <aj@suse.de>

	* stdio-common/Makefile (distribute): Remove removed files, add
	new files.

	* Makefile (distribute): Remove include/db_185.h and db.h.

	* include/db_185.h: Remove, it's not needed anymore.
	* include/db.h: Likewise.

2000-07-31  Ulrich Drepper  <drepper@redhat.com>

	* inet/Makefile (tests): Remove tst-ipnode.
	* include/netdb.h: Add stuff removed from resolv/netdb.h here for
	now.

2000-07-31  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/ia64/elf/initfini.c: Kill dummy section since align and
	endp statements have already been added.

2000-04-18  David Mosberger  <davidm@hpl.hp.com>

	* sysdeps/unix/sysv/linux/ia64/sysdep.h: Include
	<sysdeps/ia64/sysdep.h>.

	* sysdeps/ia64/_mcount.S: New file.

	* sysdeps/ia64/elf/initfini.c (_init): Preserve gp around call to
	__gmon_start__.  Fix up extraneous whitespace.

2000-01-12  H.J. Lu  <hjl@gnu.org>

	* sysdeps/ia64/elf/initfini.c: New file.

2000-07-31  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/unix/sysv/linux/ia64/clone.S: Add stop bit to avoid WAW
	dependency between branch and ar.pfs write.

2000-07-31  H.J. Lu  <hjl@gnu.org>

	* sysdeps/generic/printf_fphex.c (__printf_fphex): Correctly
	handle the wchar_t array.

2000-07-31  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/gb18030.c: Don't map to and from positions in ISO
	10646 which are not yet assigned.
	Patch by wang shouhua <shouhuawang@redflag-linux.com>.

2000-07-31  Andreas Jaeger  <aj@suse.de>

	* inet/Versions: Remove getipnodebyaddr and friends from
	GLIBC_2.2.

	* resolv/netdb.h: Remove getipnodebyaddr and friends.

2000-07-30  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/sjis.c (BODY for FROM_LOOP): Treat the case
	ch >= 0x81 && ch2 < 0x40 as invalid.

2000-07-30  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/uhc.c (BODY for FROM_LOOP): Reject ch2 == 0xff as invalid.
	(BODY for TO_LOOP): Accept 0x7f. Increment outptr as needed.

2000-07-30  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/johab.c (BODY for TO_LOOP): After calling
	ucs4_to_ksc5601_sym, fix the conversion to JOHAB.

2000-07-30  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/t.61.c (to_ucs4): Change values of 0xa4, 0a6, 0xa8, 0xb4,
	0xb8.
	(from_ucs4): Change values of U+00A4, U+00BB, U+00ED.

2000-07-30  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/macintosh.c (HAS_HOLES): Set to 1.

2000-07-30  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/iso_6937.c (to_ucs4): Change values of 0x24 and 0xb4.
	(from_ucs4): Change values of U+00A4 and U+00ED.
	(BODY of TO_LOOP): Remove mapping from U+02DC to 0x0020.

2000-07-30  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/ansi_x3.110.c (from_ucs4): Change entry for 0xed.
	(BODY for TO_LOOP): Map U+2122, U+2126, not U+2022, U+2026.

2000-07-30  Bruno Haible  <haible@clisp.cons.org>

	* iconvdata/Makefile (gen-8bit-gap-modules): Remove isiri-3342.
	* iconvdata/isiri-3342.h: New file.
	* iconvdata/isiri-3342.c (HAS_HOLES): Avoid gaps >= 0xe0, but don't
	treat 0x80 as a gap.

2000-07-30  Bruno Haible  <haible@clisp.cons.org>

	* string/strxfrm.c (encoding_mask, encoding_byte): Remove.
	(utf8_encode): Use simple shifts instead.  Fix return value.

2000-07-31  Ulrich Drepper  <drepper@redhat.com>

	* timezone/private.h: Update from tzcode2000e.
	* timezone/asia: Update from tzdata2000e.
	* timezone/australasia: Likewise.
	* timezone/europe: Likewise.
	* timezone/northamerica: Likewise.
	* timezone/zone-tab: Likewise.

2000-07-30  Ralf Baechle  <ralf@gnu.org>

	* sysdeps/unix/sysv/linux/mips/bits/sigstack.h:  New file.  On MIPS
	the order of struct sigaltstack members is different.

2000-07-26  Philip Blundell  <philb@gnu.org>

	* sysdeps/unix/sysv/linux/arm/bits/fcntl.h: New file.

2000-07-29  Ulrich Drepper  <drepper@redhat.com>

	* locale/langinfo.h: Add entries for extra tables in CTYPE data.
	* locale/programs/ld-ctype.c: Adjust for this.

	* locale/programs/ld-collate.c: Add more alignment checks.
	* locale/string/strcoll.c: Likewise.

2000-07-30  Mark Kettenis  <kettenis@gnu.org>

	* stdio-common/vfprintf.c: Move inclusion of _i18n_number.h
	outside USE_IN_LIBIO block.

2000-07-26  Philip Blundell  <philb@gnu.org>

	* sysdeps/arm/dl-machine.h (fix_bad_pc24): New function.
	(elf_machine_rel): Use it for out-of-range PC24 relocs.

2000-07-28  Philip Blundell  <philb@gnu.org>

	* math/test-fpucw.c: Ignore reserved bits in control word.

2000-07-28  Philip Blundell  <philb@gnu.org>

	* sysdeps/unix/sysv/linux/arm/sysdep.h (PSEUDO_RET): New macro.
	(ret): Redefine to PSEUDO_RET.
	(PSEUDO): Remove jump to syscall_error.

2000-07-29  Mark Kettenis  <kettenis@gnu.org>

	* resolv/README: Add some information about using the resolver in
	multi-threaded code and with C++.  Spelling fixes.

2000-07-29  Mark Kettenis  <kettenis@gnu.org>

	* resolv/resolv.h (struct __sockaddr_in): Remove.
	(struct __res_state) [!_LIBC]: Remove reference to __sockaddr_in.

2000-07-29  Greg McGary  <greg@mcgary.org>

	* Rules (test-bp-inputs, make-test-out): New variables.
	($(objpfx)%-bp.out): New rule.
	($(objpfx)%.out): Rewrite in terms of new variables.

	* libio/iovswscanf.c (vswscanf): Pass _IO_FILE_plus pointer to
	internal function that uses vtable.
	* libio/vsnprintf.c (_IO_vsnprintf): Likewise.
	* libio/vswprintf.c (_IO_vswprintf): Likewise.

	* malloc/malloc.c (mem2chunk): Define in terms of chunk_at_offset.
	(malloc_extend_top): Convert brk to chunk using chunk_at_offset.
	(chunk_align): Likewise.

	* time/asctime.c (ab_day_name, ab_month_name): Rewrite expression
	in a way that conforms to decl, and avoids spurious bounds violation.

	* sysdeps/arm/frame.h (struct layout): Make pointers __unbounded.
	* sysdeps/generic/frame.h: Likewise.
	* sysdeps/generic/backtrace.c (ADVANCE_STACK_FRAME): Wrap bounds
	around return value.
	(__backtrace): Qualify frame-pointer chain and return address
	pointers as __unbounded.  Wrap bounds around variable `current'.
	* sysdeps/generic/segfault.c (ADVANCE_STACK_FRAME): Wrap bounds
	around return value.
	(catch_segfault): Qualify frame-pointer chain and return address
	pointers as __unbounded.  Wrap bounds around variable `current'.
	* sysdeps/i386/backtrace.c (struct layout): Make pointers __unbounded.
	(ADVANCE_STACK_FRAME): Wrap bounds around return value.
	* sysdeps/powerpc/backtrace.c (struct layout): Make pointers
	__unbounded.
	(__backtrace): Qualify frame-pointer chain and return address
	pointers as __unbounded.  Wrap bounds around variable `current'.

	* sysdeps/i386/addmul_1.S: s2_limb is scalar so remove bounds check.
	* sysdeps/i386/mul_1.S: Likewise.
	* sysdeps/i386/submul_1.S: Likewise.
	* sysdeps/i386/i586/addmul_1.S: Likewise.
	* sysdeps/i386/i586/mul_1.S: Add bounds checks.
	* sysdeps/i386/i586/submul_1.S: Likewise.

2000-07-27  Andreas Jaeger  <aj@suse.de>

	* libio/Depend: New file, libio needs localedata for tests.
	* posix/Depend: Likewise.

2000-07-28  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/_i18n_itoa.c: Removed.
	* stdio-common/_i18n_itoa.h: Removed.
	* stdio-common/_i18n_itowa.c: Removed.
	* stdio-common/_i18n_itowa.h: Removed.
	* stdio-common/_i18n_number.h: New file.
	* stdio-common/Depend: New file.
	* stdio-common/printf-parse.h: Handle I modifier correctly.  Optimize.
	* stdio-common/vfprintf.c: Rewrite buffer handling for integer
	printing.  Change printing of numbers with locale specific digits to
	use new code in _i18n_number.h.
	* stdio-common/Makefile (routines): Remove _i18n_itoa and
	_i18n_itowa.

	* stdio-common/bug13.c: Improve messages.

	* locale/programs/ld-ctype.c (ctype_read): Improve error message.
	(set_class_defaults): Always search also for Uxxxx names.
	Detect insufficient number of outdigits.

	* locale/Makefile (C-translit.h): Use mv not $(move-if-changed).

2000-07-27  Bruno Haible  <haible@clisp.cons.org>

	* locale/C-ctype.c (_nl_C_LC_CTYPE): Swap the two names in
	_NL_CTYPE_MAP_NAMES.
	* locale/localeinfo.h (__TOW_toupper, __TOW_tolower): New enum values.
	* wctype/wcfuncs.c (towlower, towupper): Use them.
	* wctype/wcfuncs_l.c (__towlower_l, __towupper_l): Likewise.
	* wctype/wctrans.c (wctrans): Likewise.
	* wctype/wctrans_l.c (__wctrans_l): Likewise.

2000-07-27  Bruno Haible  <haible@clisp.cons.org>

	* posix/fnmatch.c (is_char_class): Fix logic.  Avoid buffer overrun.
	Use the optimized version of this function outside glibc as well.

2000-07-27  Jakub Jelinek  <jakub@redhat.com>

	* locale/indigits.h (indigit_value): Correct.
	* locale/indigitswc.h (indigitwc_value): Correct.
	* stdio-common/vfscanf.c (__vfscanf): Fix I18N number
	conversion, add GROUP checking for it, fix GROUP number
	conversion with strlen(thousands) > 1.
	Honour width correctly in the presence of floating
	decimal points and thousands separators.
	* stdio-common/tst-sscanf.c: New test.
	* stdio-common/Makefile: Add it to tests.
	* sysdeps/generic/strtol.c (strtol): Fix conversion if there are
	thousands separators and group argument is non-zero.

2000-07-25  Bruno Haible  <haible@clisp.cons.org>

	* locale/Versions: Enumerate __*_l functions individually. __wctrans_l
	starts at GLIBC_2.2.

2000-07-12  Maciej W. Rozycki  <macro@ds2.pg.gda.pl>

	* sysdeps/unix/sysv/linux/mips/Dist: Add sys/tas.h.
	* sysdeps/unix/sysv/linux/mips/Makefile (sysdep_routines): Add
	_test_and_set.
	(headers): Add sys/tas.h.
	* sysdeps/unix/sysv/linux/mips/Versions: Export _test_and_set for
	GLIBC_2.2 from libc.
	* sysdeps/unix/sysv/linux/mips/_test_and_set.c: New file.
	* sysdeps/unix/sysv/linux/mips/sys/tas.h: New file for
	_test_and_set.

2000-07-28  Andreas Jaeger  <aj@suse.de>

	* sysdeps/gnu/netinet/tcp.h: Add TCP options from Linux 2.4.

	* dlfcn/Makefile ($(objpfx)tst-dladdr): New.
	($(objpfx)tst-dladdr.out): new.
	(tests): Add tst-dladdr.
	($(objpfx)glrefmain): Use libdl.

	* dlfcn/tst-dladdr.c: New file.  Based on a test by Volkmar Sieh
	<vs@caldera.de>.

2000-07-27  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/unix/sysv/linux/ia64/syscalls.list: Add truncate(64) and
	ftruncate(64) calls.

2000-07-27  Jes Sorensen  <jes@linuxcare.com>

	* intl/tst-translit.c: Include string.h to get prototype for
	strcmp().

2000-07-27  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/unix/sysv/linux/ia64/fork.c: Make __libc_fork the strong
	name and add weak alias for __fork.

	* sysdeps/unix/sysv/linux/ia64/syscalls.list: Change llseek, pread
	& pwrite to use __libc_<name> as strong names instead of
	__syscall_<name>.

	* include/sched.h: Add clone2 prototype.

2000-07-26  Jes Sorensen  <jes@linuxcare.com>

	* sysdeps/unix/sysv/linux/ia64/sysdep.h (ENTRY): Don't declare the
	procedure name twice.

2000-07-27  Philip Blundell  <philb@gnu.org>

	* malloc/malloc.c (HAVE_MREMAP): Undo change of 1997-12-04.

2000-07-27  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/bits/socket.h: Rename MSG_URG TO
	MSG_CONFIRM following kernel 2.4.0 (MSG_URG was never used).
	* sysdeps/unix/sysv/linux/mips/bits/socket.h: Likewise.
	Reported by Andi Kleen <ak@suse.de>.

	* rt/tst-aio64.c: Add tests for aio_fsync64 and aio_cancel64.
	(do_wait): Test requests with aio_return64.
	(do_test): Change callers of do_wait.

2000-07-26  Andreas Jaeger  <aj@suse.de>

	* rt/tst-aio.c: Add tests for aio_fsync and aio_cancel.
	(do_wait): Test requests with aio_return.
	(do_test): Change callers of do_wait.

2000-07-27  Ulrich Drepper  <drepper@redhat.com>

	* rt/aio_misc.c (__aio_remove_request): New function.  Handle removing
	from request list.  Don't do the list handling here, call
	__aio_remove_request.
	* rt/aio_misc.h: Add prototype for __aio_remove_request.
	* rt/aio_cancel.c: Don't assume __aio_find_req_fd succeeds since the
	request might already be processed.  Don't do the list handling
	here, call __aio_remove_request.

	* rt/aio_misc.c: Don't depend on aio_reqprio field for LIO_SYNC and
	LIO_DSYNC.

	* rt/aio_misc.c: Add comment explaining why writer memory barriers
	are missing.

2000-07-27  Greg McGary  <greg@mcgary.org>

	* sysdeps/generic/bp-checks.h (BOUNDED_N): Make it work for void*.
	* sysdeps/generic/bp-semctl.h (check_semctl): Fix syntax error
	in union init.  Pass zero for ignored semnum arg to semctl.
	* sysdeps/unix/sysv/linux/shmat.c (shmat): Fix typo.

2000-07-26  Greg McGary  <greg@mcgary.org>

	* sysdeps/gnu/bits/msq.h: Qualify kernel's
	data structure pointers as __unbounded.
	* sysdeps/unix/sysv/linux/mips/bits/shm.h: Likewise.
	* sysdeps/generic/bp-semctl.h: New file.
	* sysdeps/unix/sysv/linux/msgctl.c: Qualify kernel's data structure
	pointers as __unbounded.  Check bounds of syscall args.
	* sysdeps/unix/sysv/linux/msgrcv.c: Likewise.
	* sysdeps/unix/sysv/linux/msgsnd.c: Likewise.
	* sysdeps/unix/sysv/linux/semctl.c: Likewise.
	* sysdeps/unix/sysv/linux/semop.c: Likewise.
	* sysdeps/unix/sysv/linux/shmat.c: Likewise.
	* sysdeps/unix/sysv/linux/shmctl.c: Likewise.
	* sysdeps/unix/sysv/linux/shmdt.c: Likewise.
	* sysdeps/unix/sysv/linux/alpha/msgctl.c: Likewise.
	* sysdeps/unix/sysv/linux/alpha/semctl.c: Likewise.
	* sysdeps/unix/sysv/linux/alpha/shmctl.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/msgctl.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/semctl.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/shmctl.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/msgctl.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/semctl.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/shmctl.c: Likewise.

2000-07-26  Ulrich Drepper  <drepper@redhat.com>

	* libio/iofwide.c: Enable transliteration for conversion from wchar_t
	by default.
	* locale/C-ctype.c: Likewise.
	* wcsmbs/wcsmbsload.c: Likewise.

2000-07-26  Greg McGary  <greg@mcgary.org>

	* Makeconfig (+link-bounded, link-libc-bounded,
	link-extra-libs-bounded): New variables.
	(built-program-cmd): Omit $(run-program-prefix) for static BP tests.
	* Makerules (do-tests-clean, common-mostlyclean): Remove BP test files.
	* Rules (tests-bp.out): New variable.
	(tests): Conditionally add BP tests.
	(binaries-bounded): Add variable and associated rule.
	* csu/Makefile [build-bounded] (extra-objs, install-lib):
	Move conditional stuff after place where condition is defined.

	* malloc/malloc.c (bp-checks.h): Add #include.
	(mem2chunk, chunk_at_offset, bin_at): Wrap BOUNDED_1 around expression.
	(_bin_at): Add unbounded version of bin_at.
	(IAV, chunk_alloc): Use unbounded _bin_at.
	(mALLOc, rEALLOc, chunk_realloc, mEMALIGn, cALLOc,
	chunk2mem_check, realloc_check, malloc_starter, malloc_atfork):
	Wrap BOUNDED_N around return value.
	(chunk_realloc): Adjust oldsize once.

	* sysdeps/generic/bp-checks.h (__memchr): Remove incorrect decl.
	(__ubp_memchr): Add correct decl.
	(_CHECK_STRING): Use __ubp_memchr.
	* sysdeps/alpha/memchr.S [!__BOUNDED_POINTERS__] (__ubp_memchr):
	New alias for unbounded-pointer __memchr.
	* sysdeps/i386/memchr.S: Likewise.
	* sysdeps/ia64/memchr.S: Likewise.
	* sysdeps/m68k/memchr.S: Likewise.
	* sysdeps/sparc/sparc32/memchr.S: Likewise.
	* sysdeps/sparc/sparc64/memchr.S: Likewise.
	* sysdeps/vax/memchr.s: Likewise.

	* sysdeps/i386/strtok.S: Fix bounds checks to pass tests.
	(SAVE_PTR): New macro.  (save_ptr): Expand size as BP.
	(strtok): Don't bother to write into SAVE_PTR when returning NULL.
	* sysdeps/i386/i686/strtok.S: Likewise.
	* sysdeps/i386/bp-asm.h (RETURN_BOUNDED_POINTER,
	RETURN_NULL_BOUNDED_POINTER): Use %ecx as the scratch register.

	* sysdeps/i386/bits/string.h [!__BOUNDED_POINTERS__]: Disable inlines.
	* sysdeps/i386/i486/bits/string.h [!__BOUNDED_POINTERS__]: Likewise.

	* sysdeps/unix/sysv/linux/getsysstats.c (get_proc_path): Copy
	bounds of copy_result to mount_proc.

2000-07-25  Bruno Haible  <haible@clisp.cons.org>

	* wctype/wctype.h (__wctrans_l): New declaration.
	* wctype/wctrans_l.c: New file.
	* wctype/Makefile (routines): Add wctrans_l.

2000-07-26  Ulrich Drepper  <drepper@redhat.com>

	* posix/fnmatch_loop.c: Fixes for use outside glibc.
	Patch by MacGyver <macgyver@tos.net>.

2000-07-26  Andreas Jaeger  <aj@suse.de>

	* rt/tst-aio4.c: New file, slightly modified version of tst-aio2.
	* rt/tst-aio5.c: New file, slightly modified version of tst-aio2.
	* rt/Makefile: Add rules to build and run tst-aio4 and tst-aio5.

	* rt/tst-aio.c (test_file): Fix typo.
	* rt/tst-aio64.c (test_file): Likewise.

	* rt/tst-aio3.c: New file, slightly modified version of tst-aio2.
	* rt/Makefile: Add rules to build and run tst-aio3.

	* sysdeps/unix/sysv/linux/netinet/ip.h: Removed ip_options since
	it's not needed and confuses only.

2000-07-26  Ulrich Drepper  <drepper@redhat.com>

	* resolv/res_init.c: Add support for nameserver communication with
	IPv6.
	* resolv/res_send.c: Likewise.
	* resolv/resolv.h (struct __res_state): Store IPv6 address, not IPv4
	in nsaddrs field.
	Patch by <venaas@nvg.ntnu.no>.

2000-07-25  Bruno Haible  <haible@clisp.cons.org>

	* locale/programs/ld-ctype.c (wctype_table_get): New function.
	(wcwidth_table_get): New function.
	(wcwidth_table_add): Call it.
	(wctrans_table_get): New function.
	(wctrans_table_add): Call it.

2000-07-25  Ulrich Drepper  <drepper@redhat.com>

	* rt/lio_listio.c (lio_listio): Always disable individual
	notification.
	* rt/Makefile: Add rules to build and run tst-aio2.
	* rt/tst-aio2.c: New file.

	* rt/lio_listio.c (lio_listio): Handle case of SIG == NULL correctly.
	Reported by Kevin Beard <beardk@gatwick.Geco-Prakla.slb.com>.

2000-07-25  Mark Kettenis  <kettenis@gnu.org>

	* nss/nss_files/files-netgrp.c (strip_whitespace): New function.
	(_nss_netgroup_parseline): Use strip_whitespace to strip off any
	leading and trailing spaces from host, user and domain name.

2000-07-25  Jes Sorensen  <jes@linuxcare.com>

	* csu/defs.awk: Add support for need_endp.

2000-07-25  Mark Kettenis  <kettenis@gnu.org>

	* resolv/resolv.h: Remove __P from res_send_qhook and
	res_send_rhook typedefs.

2000-07-25  Bruno Haible  <haible@clisp.cons.org>

	* intl/tst-translit.c (main): Unset OUTPUT_CHARSET.

2000-07-25  Ulrich Drepper  <drepper@redhat.com>

	* iconv/gconv_builtin.h: Add WCHAR_T alias.

2000-07-25  Mark Kettenis  <kettenis@gnu.org>

	* hurd/thread-cancel.c (hurd_thread_cancel): When cancelling the
	calling thread, set the cancellation flag and return success
	instead of EINTR.

2000-07-25  Ulrich Drepper  <drepper@redhat.com>

	* libio/Makefile: Add rules build, run, and distribute tst-widetext.c.
	* libio/tst-widetext.c: New file.
	* libio/tst-widetext.input: New file.

	* libio/iogetwline.c (_IO_getwline_info): Pretty print.

	* libio/wfileops.c (_IO_wfile_underflow): Handle not entirely
	empty external buffer correctly.

2000-07-25  Maciej W. Rozycki  <macro@ds2.pg.gda.pl>

	* sysdeps/mips/dl-machine.h (_RTLD_PROLOGUE): Stringify using
	__STRING(entry) and not #entry.
	(_RTLD_EPILOGUE): Likewise.
	* sysdeps/mips/mips64/dl-machine.h: Likewise.

2000-07-25  Andreas Jaeger  <aj@suse.de>

	* stdio-common/Makefile ($(objpfx)tst-unbputc.out): Change parameter
	according to changes in test program, run also with static only
	builds.
	($(objpfx)tst-printf.out): Likewise.

	* stdio-common/tst-unbputc.sh: Likewise.
	* stdio-common/tst-printf.sh: Likewise.

2000-07-25  Ulrich Drepper  <drepper@redhat.com>

	* libio/wfileops.c (_IO_wdo_write): Correct return value.

	* libio/wfileops.c (_IO_wdo_write): Allow partial conversions in the
	loop.

	* libio/fileops.c: Pretty print.

2000-07-23  Bruno Haible  <haible@clisp.cons.org>

	* wctype/wchar-lookup.h: New file.
	* wctype/iswctype.c: Include "wchar-lookup.h".
	(__iswctype): Support alternate locale format with 3-level tables.
	* wctype/iswctype_l.c (__iswctype_l): Likewise.
	* wctype/towctrans.c (__towctrans): Likewise.
	* wctype/towctrans_l.c (__towctrans_l): Likewise.
	* wctype/wcfuncs.c: Include "wchar-lookup.h".
	(__ctype32_wctype, __ctype32_wctrans): Declare external.
	(__iswalnum, __iswalpha, __iswcntrl, __iswdigit, __iswlower,
	__iswgraph, __iswprint, __iswpunct, __iswspace, __iswupper,
	__iswxdigit, towlower, towupper): Support alternate locale format
	with 3-level tables.
	* wctype/wcextra.c (iswblank): Likewise.
	* wctype/wcfuncs_l.c: Include "wchar-lookup.h".
	(__iswalnum_l, __iswalpha_l, __iswcntrl_l, __iswdigit_l, __iswlower_l,
	__iswgraph_l, __iswprint_l, __iswpunct_l, __iswspace_l, __iswupper_l,
	__iswxdigit_l, __towlower_l, __towupper_l): Support alternate locale
	format with 3-level tables.
	* wctype/wcextra_l.c (__iswblank_l): Likewise.
	* wctype/wctype.c (__wctype): Likewise.  In the alternate locale
	format, return a 3-level table pointer.
	* wctype/wctype_l.c (__wctype_l): Likewise.
	* wctype/wctrans.c (wctrans): Likewise.
	* wctype/wctype.h (__ISwupper, __ISwlower, __ISwalpha, __ISwdigit,
	__ISwxdigit, __ISwspace, __ISwprint, __ISwgraph, __ISwblank,
	__ISwcntrl, __ISwpunct, __ISwalnum): New enum values.
	(iswctype): Remove macro definition.
	* wcsmbs/wcwidth.h: Include "wchar-lookup.h".
	(internal_wcwidth): Support alternate locale format with 3-level
	tables.
	* locale/langinfo.h (_NL_CTYPE_CLASS_OFFSET, _NL_CTYPE_MAP_OFFSET):
	New nl_items.
	* locale/categories.def (_NL_CTYPE_CLASS_OFFSET, _NL_CTYPE_MAP_OFFSET):
	Define them as being type "word".
	* locale/C-ctype.c (_nl_C_LC_CTYPE): Add initializers for them.
	* ctype/ctype-info.c (__ctype32_wctype, __ctype32_wctrans,
	__ctype32_width): New exported variables.
	* locale/lc-ctype.c (_nl_postload_ctype): Initialize them in the
	alternate locale format. Don't initialize __ctype_names and
	__ctype_width in the alternate locale format.
	* locale/programs/localedef.h (oldstyle_tables): New declaration.
	* locale/programs/localedef.c (oldstyle_tables): New variable.
	(OPT_OLDSTYLE): New macro.
	(options): Add --old-style option.
	(parse_opt): Handle --old-style option.
	* locale/programs/ld-ctype.c (locale_ctype_t): Add class_offset,
	map_offset, class_3level, map_3level, width_3level members.
	(ctype_output): Support for alternate locale format: Computation of
	nelems changes. _NL_CTYPE_TOUPPER32, _NL_CTYPE_TOLOWER32 and
	_NL_CTYPE_CLASS32 only 256 characters. _NL_CTYPE_NAMES empty.
	New fields _NL_CTYPE_CLASS_OFFSET, _NL_CTYPE_MAP_OFFSET. Field
	_NL_CTYPE_WIDTH now contains the three-level table. Extra elems
	now contain both class and map tables.
	(struct wctype_table): New type.
	(wctype_table_init, wctype_table_add, wctype_table_finalize): New
	functions.
	(struct wcwidth_table): New type.
	(wcwidth_table_init, wcwidth_table_add, wcwidth_table_finalize): New
	functions.
	(struct wctrans_table): New type.
	(wctrans_table_init, wctrans_table_add, wctrans_table_finalize): New
	functions.
	(allocate_arrays): Support for alternate locale format: Set
	plane_size and plane_cnt to 0. Restrict ctype->ctype32_b to the first
	256 characters. Compute ctype->class_3level. Restrict ctype->map32[idx]
	to the first 256 characters. Compute ctype->map_3level. Set
	ctype->class_offset and ctype->map_offset. Compute ctype->width_3level
	instead of ctype->width.

2000-07-24  Ulrich Drepper  <drepper@redhat.com>

	* libio/iogetwline.c (_IO_getwline_info): Use wide character
	string functions.

2000-07-24  Jakub Jelinek  <jakub@redhat.com>

	* libio/wfiledoalloc.c (_IO_wfile_doallocate): Measure size
	in wide characters, not bytes.
	* libio/tst_putwc.c (do_test): Add test for writing lots of data
	into file.

2000-07-22  Bruno Haible  <haible@clisp.cons.org>

	* locale/nl_langinfo.c (nl_langinfo): Accept items belonging to the
	new categories LC_PAPER, LC_NAME, LC_ADDRESS, LC_TELEPHONE,
	LC_MEASUREMENT, LC_IDENTIFICATION.

	* locale/xlocale.h (struct __locale_struct): Increase size of
	__locales array.
	* locale/duplocale.c (__duplocale): Copy newly added categories as
	well.
	* locale/freelocale.c (__freelocale): Free newly added categories.
	* locale/newlocale.c (__newlocale): Fix typo in sanity check.
	If a base is given, use it, don't simply return it.

2000-07-22  Bruno Haible  <haible@clisp.cons.org>

	* crypt/md5-crypt.c (__md5_crypt_r): Avoid gcc warnings: Use pointer
	variables, copied_key and copied_salt, instead of boolean variables.

2000-07-24  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/powerpc/mmap64.c (__mmap64): Really fix
	check for offset.

	* grp/initgroups.c (initgroups_dyn_function): Renamed from
	initgroups_function, adopted prototype for change from 2000-07-23.
	(initgroups): Follow type change.

	* sysdeps/unix/sysv/linux/powerpc/mmap64.c (__mmap64): Fix offset
	& PAGE_MASK case, reformat.

	* string/Makefile ($(objpfx)tst-svc.out): Fix rule to read input
	from stdin and setup environment.

2000-07-24  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/m68k/mmap.S: Remove mmap64 alias.

2000-07-23  Ulrich Drepper  <drepper@redhat.com>

	* string/endian.h: Explain the _*_ENDIAN constant values a bit
	more.  Patch by scarlet@mit.edu [PR libc/1799].

	* io/ftwtest-sh: Add -f parameter to chmod if -R is also given.
	[PR libc/1792].

	* argp/argp-parse.c (parser_finalize): Reverse order in which
	parsers are run for ARGP_KEY_END.  [PR libc/1755].

	* grp/initgroups.c (initgroups): Don't limit the possible number
	of groups to NGROUPS_MAX.  Allow dynamic resizing.  Loop around
	the setgroups call while the call fails and descrease the number
	of groups each round.
	The name of the initgroups function in the NSS modules changed.
	(compat_call): Adapt for dynamic resizing.
	* hesiod/nss_hesiod/hesiod-grp.c (_nss_hesiod_initgroups_dyn):
	Implement dynamic resizing.
	* nis/nss_compat/compat-initgroups.c (_nss_compat_initgroups_dyn):
	Likewise.
	* nis/nss_nis/compat-initgroups.c (_nss_nis_initgroups_dyn): Likewise.
	* hesiod/Versions: Change exported interface name.
	* nis/Versions: Change exported interface name.

2000-07-23  Ulrich Drepper  <drepper@redhat.com>

	* locale/iso-639.def: Some errors corrected.
	Patch by Keld Simonsen.

	* include/limits.h: Update non-gcc portion.
	Patch by Joseph S. Myers <jsm28@cam.ac.uk>.

2000-07-22  Mark Kettenis  <kettenis@gnu.org>

	* sysdeps/mach/hurd/brk.c (_hurd_set_brk): When shrinking the
	program's data space, reallocate only the space that was just
	deallocated to release its backing space.

2000-07-23  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/vfprintf.c (process_string_arg): For wide character
	version, handle precision also correctly.

	* nss/nss_files/files-hosts.c: Correct problem with three or more
	entries with the same name.

	* nss/nss_files/files-hosts.c: Implement multi handling.
	* resolv/Versions: Export _res_hconf for GLIBC_2.2 from libc.

2000-07-22  Ulrich Drepper  <drepper@redhat.com>

	* nss/nss_files/files-parse.c: Don't pollute namespace by using
	strcasecmp.

	* grp/Makefile: Change Makefiles and tests to run only when necessary.
	* malloc/Makefile: Likewise.
	* malloc/tst-mtrace.sh: Likewise.
	* posix/Makefile: Likewise.
	* posix/globtest.sh: Likewise.
	* posix/wordexp-tst.sh: Likewise.
	* string/Makefile: Likewise.

2000-07-22  Mark Kettenis  <kettenis@gnu.org>

	* locale/findlocale.c (locale_file_list): Use __LC_LAST as array
	size instead of LC_ALL to take into account the new locale
	categories.

2000-07-22  Ulrich Drepper  <drepper@redhat.com>

	* iconv/gconv_trans.c: Correct a few bugs in the search loop.  Remove
	remainders of hash table.
	* locale/categories.def: Remove remainders of transliteration
	hash table.
	* locale/langinfo.h: Likewise.
	* locale/programs/ld-ctype.c: Likewise.  Fix code to write out
	transliteration tables.

	* locale/gen-translit.pl: New file.
	* locale/C-translit.h.in: New file.
	* locale/C-ctype.c: Include C-translit.h.  Initialize transliteration
	data pointers with data from this file.
	* locale/Makefile (distribute): Add C-translit.h.in, C-translit.h,
	and gen-translit.pl.
	Add rule to generate C-translit.h.
	* intl/tst-translit.c (main): Update for now performed
	transliteration.

	* stdio-common/vfscanf.c: Handle input -- with format %f correctly
	(it's no input error).
	* stdio-common/tstscanf.c: Add test case for format %f with input --.
	* stdio-common/scanf12.c: Correct expected result for first scanf.

	* stdio-common/vfprintf.c (process_string_arg): Correct handling
	of multibyte character strings in %s format with precision.

2000-07-21  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/ld-collate.c (collate_read): Allow collating
	symbols and elements be named in reorder-after instructions.
	Reported by Yoshito Kawada <KAWADA@jp.ibm.com>.

	* locale/programs/ld-collate.c (handle_ellipsis): Test for
	duplication with generated name, not the name of the first
	character.
	Patch by Yong Li <yong.li@asu.edu>.

	* sysdeps/powerpc/strchr.S: Correct bugs introduced in BP-ification.
	Patch by Franz Sirl <Franz.Sirl-kernel@lauterbach.com>.

2000-07-21  Wolfram Gloger  <wg@malloc.de>

	* malloc/malloc.c (chunk_alloc): Try mmap_chunk() for smaller
	allocations only if a non-main arena cannot be extended.

2000-07-21  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-load.c (_dl_map_object): Take loader==NULL into account
	in DF_1_NODEFLIB handling.

2000-07-21  Andreas Jaeger  <aj@suse.de>

	* elf/Makefile ($(test-modules)): Exclude filtmod1.so, it has its
	own rule.

	* libio/fwide.c: Include <wchar.h> for prototype.

2000-07-21  Greg McGary  <greg@mcgary.org>

	* malloc/malloc.c (next_chunk, prev_chunk, inuse_bit_at_offset,
	set_inuse_bit_at_offset, clear_inuse_bit_at_offset, set_foot):
	Define in terms of chunk_at_offset.
	(inuse, set_inuse, clear_inuse): Define in terms of next_chunk.
	(next_bin, prev_bin): offset by size of real array elements.
	(chunk_align): Make `m' a scalar, since that's how it's used.

2000-07-21  Greg McGary  <greg@mcgary.org>

	* sysdeps/powerpc/bp-asm.h (DISCARD_BOUNDS): Rename from
	UNCHECK_BOUNDS.
	* sysdeps/powerpc/bits/setjmp.h (JB_SIZE): New constant.
	* sysdeps/powerpc/elf/libc-start.c (__libc_start_main):
	Wrap bounds around argv & envp and each of their string members.
	* sysdeps/powerpc/elf/start.S: Designate BP symbols.
	* sysdeps/unix/sysv/linux/powerpc/brk.S: Wrap entry-point
	symbol in BP_SYM ().  Discard bounds of address arg.
	* sysdeps/unix/sysv/linux/powerpc/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/mmap64.c (__mmap64):
	Discard bounds on address arg, add bounds to return value.

2000-07-20  Ulrich Drepper  <drepper@redhat.com>

	* elf/Makefile (tests): Add filter.  Add rules to generate filter.
	* elf/filter.c: New file.
	* elf/filtmod1.c: New file.
	* elf/filtmod2.c: New file.

	* elf/rtld.c: Define _dl_bind_not variable.
	(process_envvars): Recognize LD_BIND_NOT and set _dl_bind_not.
	* elf/dl-support.c: Likewise.
	* sysdeps/generic/ldsodefs.h: Declare _dl_bind_not.
	* elf/dl-runtime.c (fixup): Don't remember looked up value if
	_dl_bind_not.
	(profile_fixup): Likewise.

	* libio/Makefile (routines): Add fwide.
	* libio/iofwide.c (_IO_fwide): Remove locking.  This is done in
	fwide now.  Internal calls to _IO_fwide must do locking themselves
	or don't need locking.
	* libio/fwide.c: New file.

	* elf/dl-load.c (_dl_map_object): Implement handling of DF_1_NODEFLIB.

	* elf/Makefile: Add no modules for nodelete test.
	* elf/nodelmod3.c: New file.
	* elf/nodelmod4.c: New file.
	* elf/nodelete.c: Also test case where dependency of dlopen() object
	is marked nodelete.

	* elf/Makefile (tests): Add nodlopen.  Add rules to generate nodlopen.
	* elf/nodlopen.c: New file.
	* elf/nodlopenmod.c: New file.
	* include/dlfcn.h: Define __RTLD_DLOPEN.
	* elf/dl-load.c (_dl_map_object_from_fd): If DF_1_NOOPEN is set
	and this is a dlopen() call, do not load the binary.
	* dlfcn/dlopen.c: Add __RTLD_DLOPEN to mode passed down to _dl_open.
	* dlfcn/dlopenold.c: Likewise.
	* configure.in: Add test for -z nodelete option.
	* config.make.in: Define have-z-nodelete with libc_cv_z_nodelete.

2000-07-20  Mark Kettenis  <kettenis@gnu.org>

	Make Hesiod NSS module thread-safe.

	* hesiod/README.hesiod: Update.

	* hesiod/Versions [GLIBC_2.2]: Add _nss_hesiod_getservbyport_r,
	_nss_hesiod_setprotoent, _nss_hesiod_endprotoent,
	_nss_hesiod_getprotobyname_r, and _nss_hesiod_getprotobynumber_r.
	* hesiod/Makefile (libnss_hesiod-routines): Add hesiod-init and
	hesiod-proto.
	* hesiod/nss_hesiod/hesiod-init.c: New file.
	* hesiod/nss_hesiod/hesiod-pwd.c: Rewritten for thread-safeness.
	* hesiod/nss_hesiod/hesiod-grp.c: Likewise.
	* hesiod/nss_hesiod/nss_hesiod.h: New file.
	* hesiod/nss_hesiod/hesiod-service.c
	(_nss_hesiod_getservbyport_r): New function.  Provide support for
	looking up services by port number.
	* hesiod/nss_hesiod/hesiod-proto.c: New file.

	* hesiod/hesiod.c: Update from BIND 8.2.3-T5B.
	* hesiod/hesiod.h: Likewise.
	* hesiod/hesiod_p.h: Likewise.

2000-07-20  Mark Kettenis  <kettenis@gnu.org>

	Fix problems with `struct __res_state' getting too big.
	* resolv/resolv.h (struct __sockaddr_in): New definition.
	(struct __res_state): Use __sockaddr_in instead of sockaddr_in in
	the private parts of the structure to save some space.
	* resolv/res_send.c (res_nsend): Cast &EXT(statp).nsaddrs[ns] to
	(struct sockaddr_in *) in call to sock_eq.
	Use memcpy to copy statp->nsaddr_list[ns] to &EXT(statp).nsaddrs[ns].

2000-07-20  Ulrich Drepper  <drepper@redhat.com>

	* elf/elf.h: Add various DF_1_*, DTF_1_*, and DF_P1_* entries.
	* elf/dl-close.c (_dl_close): Don't close an object if it is marked
	with nodelete.
	* elf/dl-open.c (dl_open_worker): Pass RTLD_NOLOAD as new parameter
	to _dl_map_object.  Return immediately if no object loaded.
	Set DF_1_NODELETE bit in l_flags_1 if RTLD_NODELETE was passed.
	* elf/dynamic-link.h (elf_get_dynamic_info): Copy DT_FLAGS_1 entry
	if it exists into l_flags_1 word.
	* elf/dl-load.c (_dl_map_object_from_fd): Take no parameter and use
	it to determine whether loading is wanted or not.
	(_dl_map_object): Likewise.
	Call _dl_map_object_from_fd with new parameter.
	* sysdeps/generic/ldsodefs.h: Update prototype.
	* elf/dl-deps.c: Add new parameter to _dl_map_object calls.
	* elf/rtld.c: Likewise.
	* sysdeps/mach/hurd/dl-sysdep.c: Likewise.
	* elf/Makefile (tests): Add noload.  Add rules to generate noload.
	* elf/noload.c: New file.
	* include/link.h (struct link_map): Add l_feature_1 and l_flags_1.
	* sysdeps/generic/bits/dlfcn.h: Define RTLD_NOLOAD and RTLD_NODELETE.
	* sysdeps/mips/bits/dlfcn.h: Likewise.
	* elf/Makefile (tests): Add $(tests-nodelete-$(have-z-nodelete)).
	(tests-nodelete-yes): Define.
	(modules-names): Add $(modules-nodelete-$(have-z-nodelete)).
	Add rules to build nodelete and modules.
	* elf/nodelete.c: New file.
	* elf/nodelmod1.c: New file.
	* elf/nodelmod2.c: New file.
	* configure.in: Add test for -z nodelete option.
	* config.make.in: Define have-z-nodelete with libc_cv_z_nodelete.

	* libio/Makefile (tests): Add tst_wprintf2.
	(tst_wprintf2-ARGS): Define.
	* libio/tst_wprintf2.c: New file.
	Based on a test case by Yoshito Kawada <KAWADA@jp.ibm.com>.

	* libio/wfiledoalloc.c: Only allocate external buffer if this
	hasn't happened yet.

	* libio/wfileops.c (_IO_wdo_write): Overflow only if there is really
	something in the buffer.  gconv call can write up to end of the
	buffer, not only _IO_write_end.
	(_IO_wfile_overflow): Allocate also external buffer.

2000-07-19  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/vfprintf.c (process_string_arg): Handle multibyte
	strings with precision in vfwprintf correctly.
	* stdio-common/vfprintf.c: Fix completely broken handling of
	unbuffered wide character streams.
	Reported by Yoshito Kawada <KAWADA@jp.ibm.com>.

	* resolv/Makefile (distribute): Add README.

	* resolv/README: New file.  By Mark Kettenis <kettenis@gnu.org>.

2000-07-18  Mark Kettenis  <kettenis@gnu.org>

	Update resolver code to BIND 8.2.3-T5B.

	* resolv/Versions [GLIBC_2.2] (libc): Add __res_init and
	__res_nclose.
	[GLIBC_2.2] (libresolv): Add __dn_expand, __ns_samename,
	__res_mkquery, __res_nsend, __res_query, __res_querydomain and
	__res_search.
	* resolv/Banner: BIND-8.2.3-T5B.

	* resolv/base64.c: Update from BIND 8.2.3-T5B.
	* resolv/herror.c: Likewise.
	* resolv/inet_addr.c: Likewise.
	* resolv/inet_net_ntop.c: Likewise.
	* resolv/inet_net_pton.c: Likewise.
	* resolv/inet_neta.c: Likewise.
	* resolv/inet_ntop.c: Likewise.
	* resolv/nsap_addr.c: Likewise.
	* resolv/inet_pton.c: Likewise.  Reject a few more more invalid
	IPv6 addresses (ISC bug #520).

	* resolv/ns_name.c: Avoid emitting RCS ID in object file.
	* resolv/ns_parse.c: Likewise.
	* resolv/ns_netint.c: Likewise.
	* resolv/ns_samedomain.c: Likewise.
	* resolv/ns_ttl.c: Likewise.
	* resolv/ns_print.c: Update from BIND 8.2.3-T5B.  Avoid emitting
	RCS ID in object file.

	* resolv/res_debug.c: Update from BIND 8.2.3-T5B.
	* resolv/res_mkquery.c: Likewise.
	* resolv/res_query.c: Likewise.
	* resolv/res_init.c: Likewise.
	(res_setoptions): Mark internal.
	* resolv/res_send.c: Likewise.
	[_LIBC]: Fully reinstate the code that avoids the FD_SETSIZE limit
	by using poll instead.
	* resolv/res_comp.c: Likewise.
	[SHLIB_COMPAT (libresolv, GLIBC_2_0, GLIBC_2_2)]: Make dn_expand a
	weak alias for __dn_expand.
	* resolv/res_data.c: Likewise.
	(res_close) [_LIBC]: Don't call res_nclose if RES_INIT isn't set
	in _res.options.  Avoids a potential security risk by avoiding a
	close (0).
	[SHLIB_COMPAT (libresolv, GLIBC_2_0, GLIBC_2_2)]: Make
	res_mkquery, res_query, res_querydomain adn res_search weak
	aliases for __res_mkquery, __res_query, __res_querydomain and
	__res_search.
	* resolv/res_libc.c: (_res): Don't initialize.  Fix res_close
	instead to avoid close(0).
	(res_init): Always use the static resolver context.
	[SHLIB_COMPAT (libc, GLIBC_2.0, GLIBC_2_2)]: Make res_init a weak
	alias for __res_init.

	* resolv/resolv.h: Update from BIND 8.2.3-T5B.  Move definition of
	RES_SET_H_ERRNO and accompanying comment to...
	* include/resolv.h: ... here.

	* resolv/arpa/namser.h: Update from BIND 8.2.3-T5B.
	* resolv/arpa/nameser_compat.h: Likewise.

2000-07-18  Ulrich Drepper  <drepper@redhat.com>

	* nss/makedb.c (main): Compare result of load_db with
	NSS_STATUS_SUCCESS and not 0.
	Patch by Jan Rekorajski <baggins@sith.mimuw.edu.pl>.

	* sysdeps/unix/sysv/linux/Versions: Export __sysctl for GLIBC_2.2.

2000-07-18  Greg McGary  <greg@mcgary.org>

	* posix/regex.c (EXTEND_BUFFER_HIGH_BOUND): New macro.
	(EXTEND_BUFFER): Use it.

2000-07-18  Ulrich Drepper  <drepper@redhat.com>

	* include/libc-symbols.h: Define RETURN_ADDRESS macro.
	* dlfcn/dlopen.c: Use RETURN_ADDRESS instead of
	__builtin_return_address.
	* dlfcn/dlopenold.c: Likewise.
	* dlfcn/dlsym.c: Likewise.
	* dlfcn/dlvsym.c: Likewise.
	* elf/dl-profstub.c: Likewise.
	* malloc/malloc.c: Likewise.
	* sysdeps/generic/machine-gmon.h: Likewise.
	Based on a patch by schwidefsky@de.ibm.com.

2000-07-18  Andreas Jaeger  <aj@suse.de>

	* sysdeps/alpha/dl-machine.h (elf_machine_rela): Pass 0 instead of
	NULL to elf_machine_fixup_plt t argument to silence GCC.

	* include/string.h: Add prototype for __memchr.

	* sysdeps/alpha/memchr.S: Fix copy & error in weak_alias.

	* sysdeps/generic/memchr.c: Fix copy & paste error: Use memchr
	instead of memrchr.

2000-07-18  Ulrich Drepper  <drepper@redhat.com>

	* intl/Makefile: Make sure tst-translit is run after tst-gettext.

	* locale/C-ctype.c: Add initializers for gap elements.
	* locale/programs/ld-ctype.c (ctype_output): Write out index entries
	for gap elements.

2000-07-16  Ulrich Drepper  <drepper@redhat.com>

	* nscd/nscd.c (print_version): Update copyright year.

2000-07-17  Greg McGary  <greg@mcgary.org>

	* sysdeps/unix/make-syscalls.sh: Handle new arg signature
	keyletters F, I, S, W.  Remove unused keyletter V.  Surround
	signature argnames with angle-brackets for use as word delimiters,
	and to induce syntax errors for any args not handled.  Split
	multi-echo echoes and comment each stage.
	* sysdeps/unix/common/syscalls.list: Refine & correct signatures.
	* sysdeps/unix/inet/syscalls.list: Likewise.
	* sysdeps/unix/mman/syscalls.list: Likewise.
	* sysdeps/unix/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/ia64/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/mips/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/syscalls.list: Likewise.
	* sysdeps/unix/sysv/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/syscalls.list

	* sysdeps/generic/strcpy.c (strcpy): Stifle unused-value warnings.
	* sysdeps/unix/sysv/linux/execve.c (__execve): Add const
	qualifiers.  Don't check NULL-terminator of argv & envp.
	* sysdeps/unix/sysv/linux/getsysstats.c (get_proc_path): Use
	unbounded pointer type in word-size assertion.
	* sysdeps/unix/sysv/linux/ptrace.c (ptrace): Add missing
	cases to stifle warnings.

	* libio/iofdopen.c (_IO_new_fdopen): Pass _IO_FILE_plus pointer to
	_IO_file_attach.
	* libio/iovdprintf.c (_IO_vdprintf): Likewise.

	* include/libc-symbols.h (symbol_set_declare): Revert 2000-06-26 mods.
	* include/set-hooks.h (RUN_HOOK): Revert 2000-06-26 mods.  Qualify
	ptr as __unbouned.

	* Makerules (o-objects): Supplement with $(o-objects$o).
	* string/Makefile (o-objects.ob): Add variable to pull
	unbounded versions of memcpy, memset and memchr into libc_b.

	* sysdeps/generic/bp-checks.h: Use unbounded __memchr
	rather than non-existent __ubp_memchr.
	(CHECK_STRINGopt, CHECK_FCNTL, BOUNDED_N, BOUNDED_1): New macros.
	(_CHECK_STRING, _CHECK_N): New macros.
	(CHECK_STRING, CHECK_N, CHECK_Nopt): Rewrite in terms of _CHECK_*.
	(CHECK_IOCTL): Move inside `#if !__ASSEMBLER__'.
	* sysdeps/alpha/memchr.S: Change strong name to "__memchr".
	Add weak alias "memchr".
	* sysdeps/generic/memchr.c: Likewise.
	* sysdeps/i386/memchr.S: Likewise.
	* sysdeps/ia64/memchr.S: Likewise.
	* sysdeps/m68k/memchr.S: Likewise.
	* sysdeps/sparc/sparc32/memchr.S: Likewise.
